CC=mpiCC
GENERIC_LFLAGS =\
-L../../hypre_clx_vec/lib \
  -lHYPRE\
  -lHYPRE_DistributedMatrix\
  -lHYPRE_DistributedMatrixPilutSolver\
  -lHYPRE_Euclid\
  -lHYPRE_FEI\
  -lHYPRE_IJ_mv\
  -lHYPRE_krylov\
  -lHYPRE_LSI\
  -lHYPRE_MatrixMatrix\
  -lHYPRE_mli\
  -lHYPRE_multivector\
  -lHYPRE_ParaSails\
  -lHYPRE_parcsr_block_mv\
  -lHYPRE_parcsr_ls\
  -lHYPRE_parcsr_mv\
  -lHYPRE_seq_mv\
  -lHYPRE_sstruct_ls\
  -lHYPRE_sstruct_mv\
  -lHYPRE_struct_ls\
  -lHYPRE_struct_mv\
  -lHYPRE_superlu\
  -lHYPRE_utilities\
  -lm

 CFLAGS= -I.\
  -D_FLOAT_EXPAND  -DMY_HYPRE\
  -DHYPRE_TIMING \
 -I../..//hypre_clx/include\
 -align -tpp7 -O3  
all: cparpcg cpelast

cparpcg: crest.o ccg.o cfunctors.o csysgen.o cvisitors.o cvectors.o csolver.o cmatrix.o cprecon.o
	$(CC) $(CFLAGS) crest.o ccg.o cfunctors.o csysgen.o cvectors.o csolver.o cmatrix.o cprecon.o -o cparpcg $(GENERIC_LFLAGS)

cpelast: cpelast.o csparcemmat.o celastgen.o csysgen.o cvectors.o celastsolver.o csolver.o cprecon.o cvisitors.o cfunctors.o 
	$(CC) $(CFLAGS) -o cpelast cpelast.o csparcemmat.o celastgen.o  csysgen.o cvectors.o celastsolver.o csolver.o cprecon.o cvisitors.o cfunctors.o $(GENERIC_LFLAGS)

cvisitors.o:visitors.cpp visitors.hpp visitors.h index.h vectors.h \
  small.h
	$(CC) $(CFLAGS) -o cvisitors.o -c visitors.cpp

cvectors.o:vectors.cpp vectors.hpp vectors.h small.h index.h useful.h
	$(CC) $(CFLAGS) -o cvectors.o -c vectors.cpp

cprecon.o:precon.h precon.hpp precon.cpp
	$(CC) $(CFLAGS) -o cprecon.o -c precon.cpp

cmatrix.o:  matrix.cpp matrix.hpp matrix.h solver.h useful.h small.h \
  vectors.h index.h functors.h mmpl.hpp ttl/meta/typelist.hpp \
  ttl/config.hpp ttl/exception.hpp ttl/config.hpp ttl/macro_params.hpp \
  ttl/macro_repeat.hpp ttl/macro_misc.hpp ttl/detail/macro_counter.hpp \
  ttl/macro_misc.hpp ttl/equivalent_types.hpp ttl/selector.hpp visitors.h \
  visitors.hpp
	$(CC) $(CFLAGS) -o cmatrix.o -c matrix.cpp

csolver.o: solver.cpp solver.hpp solver.h useful.h small.h functors.h \
  mmpl.hpp ttl/meta/typelist.hpp ttl/config.hpp ttl/exception.hpp \
  ttl/config.hpp ttl/macro_params.hpp ttl/macro_repeat.hpp \
  ttl/macro_misc.hpp ttl/detail/macro_counter.hpp ttl/macro_misc.hpp \
  ttl/equivalent_types.hpp ttl/selector.hpp visitors.h index.h vectors.h
	$(CC) $(CFLAGS) -o csolver.o -c solver.cpp

ccg.o:	cg.cpp cg.hpp cg.h vectors.h small.h index.h sysgen.h ntransform.h \
  multipoly.h base.h calc.h poly.h mirorer.h matrix.h solver.h useful.h \
  functors.h mmpl.hpp ttl/meta/typelist.hpp ttl/config.hpp \
  ttl/exception.hpp ttl/config.hpp ttl/macro_params.hpp \
  ttl/macro_repeat.hpp ttl/macro_misc.hpp ttl/detail/macro_counter.hpp \
  ttl/macro_misc.hpp ttl/equivalent_types.hpp ttl/selector.hpp visitors.h \
  visitors.hpp precon.h
	$(CC) $(CFLAGS) -o ccg.o -c cg.cpp

csysgen.o: sysgen.cpp sysgen.hpp sysgen.h small.h ntransform.h multipoly.h \
  base.h calc.h poly.h mirorer.h useful.h index.h vectors.h
	$(CC) $(CFLAGS) -o csysgen.o -c sysgen.cpp

cfunctors.o:  functors.cpp functors.hpp visitors.h index.h vectors.h \
  small.h functors.h mmpl.hpp ttl/meta/typelist.hpp ttl/config.hpp \
  ttl/exception.hpp ttl/config.hpp ttl/macro_params.hpp \
  ttl/macro_repeat.hpp ttl/macro_misc.hpp ttl/detail/macro_counter.hpp \
  ttl/macro_misc.hpp ttl/equivalent_types.hpp ttl/selector.hpp useful.h \
  visitors.hpp
	$(CC) $(CFLAGS) -o cfunctors.o -c functors.cpp

crest.o:parpcg.cpp small.h sysgen.h ntransform.h multipoly.h base.h \
  calc.h poly.h mirorer.h index.h cg.h vectors.h matrix.h solver.h \
  useful.h util.h functors.h mmpl.hpp ttl/meta/typelist.hpp \
  ttl/config.hpp ttl/exception.hpp ttl/config.hpp ttl/macro_params.hpp \
  ttl/macro_repeat.hpp ttl/macro_misc.hpp ttl/detail/macro_counter.hpp \
  ttl/macro_misc.hpp ttl/equivalent_types.hpp ttl/selector.hpp visitors.h \
  fc.h
	$(CC) $(CFLAGS)  -o crest.o -c parpcg.cpp 



celastgen.o: elastgen.cpp elastgen.hpp elastgen.h small.h sysgen.h \
  ntransform.h multipoly.h base.h calc.h poly.h mirorer.h sparcemmat.h
	$(CC) $(CFLAGS) -c -o celastgen.o elastgen.cpp

cpelast.o: pelast.cpp elastgen.h small.h sysgen.h ntransform.h multipoly.h \
  base.h calc.h poly.h mirorer.h sparcemmat.h util.h elastsolver.h \
  vectors.h index.h solver.h useful.h
	$(CC) $(CFLAGS) -c -o  cpelast.o pelast.cpp 

csparcemmat.o:  sparcemmat.cpp sparcemmat.hpp sparcemmat.h small.h
	$(CC) $(CFLAGS) -c -o csparcemmat.o sparcemmat.cpp

celastsolver.o:  elastsolver.cpp elastsolver.hpp elastsolver.h vectors.h \
  small.h index.h elastgen.h sysgen.h ntransform.h multipoly.h base.h \
  calc.h poly.h mirorer.h sparcemmat.h solver.h useful.h precon.h \
  functors.h mmpl.hpp ttl/meta/typelist.hpp ttl/config.hpp \
  ttl/exception.hpp ttl/config.hpp ttl/macro_params.hpp \
  ttl/macro_repeat.hpp ttl/macro_misc.hpp ttl/detail/macro_counter.hpp \
  ttl/macro_misc.hpp ttl/equivalent_types.hpp ttl/selector.hpp visitors.h
	$(CC) $(CFLAGS) -c -o celastsolver.o elastsolver.cpp

clean:
	rm c*.o cparpcg cpelast
