#include <iostream>
#include <string>
#include <sstream>
#include "mirorer.h"

void ReadNumbersFromName(std::string name, int &N1, int &N2, int &N3)
{
  N1 = N2 = N3 = 0;
  name = name.substr(0, name.find('.'));
  std::replace(name.begin(), name.end(), 'x', ' ');

  std::istringstream is(name);
  is >> N1 >> N2 >> N3;
  if (  std::count(name.begin(), name.end(), ' ')!=2)
    N2 = N3 = N1;
  
}

double ReadDim(const std::string &name)
{
  std::istringstream is(name);
  double res = 0;
  is >> res;
  return res;
}
int main(int argc, char **argv)
{
  std::string filename = "default";
  if (argc >1)
    filename = argv[1];
  std::istringstream is(filename);
  int N1, N2, N3;
  ReadNumbersFromName(filename, N1, N2, N3);
  double dim;
  if (argc >2)
    dim = ReadDim(argv[2]);
  else
    dim = 1./N1;
  //  vector3d<unsigned short > vec;
  vector3d<unsigned char > vec;

  std::ostringstream os;
  os << N1 << "x" << N2 << "x" << N3 <<".inr";
  vec.SetSize(N1, N2, N3, dim, dim, dim);
  vec.Read(filename, 0);
  std::cout << "Writing " << os.str() << std::endl;
  vec.WriteInr(os.str());
}
