
#include <iostream>
#include <string>
#include <sstream>
#include "mirorer.h"

template<class T>
T Get(const std::string &s)
{
  std::istringstream is(s);
  T a;
  is >> a;
  return a;
}

int main(int argc, char **argv)
{
  std::string filename = "default";
  if (argc <8)
    return 0;
  filename = Get<std::string>(argv[1]);

  int xm, ym, zm, xM, yM, zM;

  xm = Get<int>(argv[2]);
  ym = Get<int>(argv[3]);
  zm = Get<int>(argv[4]);
  xM = Get<int>(argv[5]);
  yM = Get<int>(argv[6]);
  zM = Get<int>(argv[7]);
    
  vector3d<unsigned char > vec;
  vector3d<unsigned char > ovec;
  vec.ReadInr(filename);
  int xs, ys, zs;
  xs = xM - xm;
  ys = yM - ym;
  zs = zM - zm;
  ovec.SetSize(xs, ys, zs, vec.dim[0], vec.dim[1], vec.dim[2]);

  for (int i = xm; i < xM; ++i)
    for (int j = ym; j< yM; ++j)
      for (int k = zm; k< zM; ++k)
	ovec(i-xm, j-ym, k-zm) = vec(i,j,k);
  ovec.WriteInr("clipped."+filename);	  
}
