#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <iomanip>
#include <cassert>
#include "mirorer.h"

template<class T>
void Extract(vector3d<T> &src,  unsigned coordx, unsigned coordy, unsigned coordz, const std::string &namebase)
{
  assert((coordx <= 1) && (coordy <=1) && (coordz <=1));
  vector3d<T> dst;
  size_t sizex = src.sizes[0]/2; 
  size_t sizey = src.sizes[1]/2;
  size_t sizez = src.sizes[2]/2;
  size_t ofx = sizex*coordx;
  size_t ofy = sizey*coordy;
  size_t ofz = sizez*coordz;
  dst.SetSize(sizex,
	      sizey,
	      sizez,
	      src.dim[0],
	      src.dim[1],
	      src.dim[2]);
  size_t i,j,k;
  for(i = 0; i <sizex; ++i)
    for (j = 0; j < sizey; ++j)
      for (k = 0; k < sizez; ++k)
	dst(i,j,k) = src(ofx+i, ofy +j, ofz + k);
  std::ostringstream names;
  names << namebase << ".s." << coordx << coordy << coordz << ".inr";
  dst.WriteInr(names.str());
}

int main(int argc, char **argv)
{
  if (argc != 2)
    return -1;
  using namespace std;
  string fname = argv[1];


  vector3d<unsigned char> vec;
  vec.ReadInr(fname);
  std::istringstream is(fname);
  std::ostringstream names;
  names << (vec.sizes[0]/2);
  const std::string namebase = names.str();
  Extract(vec, 0, 0, 0, namebase);
  Extract(vec, 0, 0, 1, namebase);
  Extract(vec, 0, 1, 0, namebase);
  Extract(vec, 0, 1, 1, namebase);
  Extract(vec, 1, 0, 0, namebase);
  Extract(vec, 1, 0, 1, namebase);
  Extract(vec, 1, 1, 0, namebase);
  Extract(vec, 1, 1, 1, namebase);
  return 0;
}
	  
    
  
