#include <iostream>
#include <fstream>
#include <string>
#include <sstream>

#include "mirorer.h"
double data[21];

void transform(double ni, double E)
{
  double mu, lambda;
  lambda = E * ni /((1+ni)*(1-2* ni));
  mu = E / (2 *(1+ni));

  data[20] -= 2.* mu * data[11];
  data[16] -= 2.* mu * data[7];
  data[12] -= 2.* mu * data[3];

  data[20] += data[16]+data[12];
  data[16] = data[12] = data[20];

  data[20] += 2.* mu * data[11];
  data[16] += 2.* mu * data[7];
  data[12] += 2.* mu * data[3];
}


int main(int argc, char **argv)
{
  if (argc != 2)
    return -1;
  using namespace std;
  string fname = argv[1];
  int field;
  int maxfield=21;
  int N;
  string bonename;
  {
    istringstream is(argv[1]);
    is >> N;
    ostringstream os;
    os << N/2 << ".bonec";
    bonename = os.str();
  }
  
  ifstream f(fname.c_str());
  ofstream g((fname + ".good").c_str());
  g.precision(16);
  //  g.setf(ios::scientific);
  vector3d<unsigned char> vec;
  vec.SetSize(N/2, N/2, N/2);
  double val;
  int i, j, k;
  f.exceptions(ios::eofbit);
  try{
  for( k = 0; k < N; ++k)
    for( i = 0; i < N; ++i)
      for( j = 0; j < N; ++j)
      {
	for(int l = 0; l < maxfield; ++l)
	{
	  f >> data[l];
	}
	double E;
	if (k<=1)
	  E = 10;
// 	else  if (k>=(N-2))
// 	  E = 10;
	else if (vec(i/2,j/2,k/2))
	  E = 1;
	else
	  E = 0.001;
	double ni = 0.3;
	  
	transform (ni, E);
	for(int l = 0; l < maxfield; ++l)
	{
	  g << data[l] << " ";
	}
	g << "\n";
      }
  }catch(...)
  {
    cout << "File not long enough" << endl;
  }
  return 0;
}
	  
    
  
