#define NDEBUG
# include <vector>
# include <map>
# include <cmath>
# include <iostream>
# include <iomanip>
# include <fstream>
# include <string>
# include <sstream>
# include <stdexcept>
#include <sstream>
#include "mirorer.h"
#include <algorithm>
#include <png.h>

std::vector<signed short> im;

std::string fname;

std::vector<float> pixels;

int width, height;
void save_png()
{
  FILE *fp;
  std::ostringstream os;
  os.fill('0');
  os<< "o" << fname << ".png";
  fp = fopen(os.str().c_str(), "wb");
  //

  //    cout << " " << width << "x" << height << endl;
  try{
    png_structp png_ptr = png_create_write_struct
      (PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
    if (!png_ptr)
      throw(4);
      
    png_infop info_ptr = png_create_info_struct(png_ptr);
    if (!info_ptr)
    {
      png_destroy_write_struct(&png_ptr,
			       (png_infopp)NULL);
      throw 5;
    }
      
    if (setjmp(png_jmpbuf(png_ptr)))
    {
      png_destroy_write_struct(&png_ptr, &info_ptr);
      fclose(fp);
      throw 6;
    }
    png_init_io(png_ptr, fp);      
    /* set the zlib compression level */
    png_set_compression_level(png_ptr,
			      Z_BEST_COMPRESSION);

    /* set other zlib parameters */
    png_set_compression_mem_level(png_ptr, 8);
    png_set_compression_strategy(png_ptr,
				 Z_DEFAULT_STRATEGY);
    png_set_compression_window_bits(png_ptr, 15);
    png_set_compression_method(png_ptr, 8);
    png_set_compression_buffer_size(png_ptr, 8192);
    png_set_IHDR(png_ptr, info_ptr, width, height,
		 8, PNG_COLOR_TYPE_RGB_ALPHA, PNG_INTERLACE_NONE,
		 PNG_COMPRESSION_TYPE_DEFAULT,
		 PNG_FILTER_TYPE_DEFAULT);
    png_set_sRGB(png_ptr, info_ptr, PNG_sRGB_INTENT_PERCEPTUAL);
    png_color_8 a;
    a.red = 8;
    a.green=8;
    a.blue=8;
    a.gray=0;
    a.alpha=0;
    //    png_set_sBIT(png_ptr, info_ptr, &a);
    png_text  text[6];
    int  num_text = 0;
    text[num_text].compression = PNG_TEXT_COMPRESSION_NONE;
    text[num_text].key = const_cast<char*>("Title");
    text[num_text].text = const_cast<char*>("Kartinka");
    ++num_text;
    text[num_text].compression = PNG_TEXT_COMPRESSION_NONE;
    text[num_text].key = const_cast<char*>("Author");
    text[num_text].text = const_cast<char*>("Yavor Vutov");
    ++num_text;
    text[num_text].compression = PNG_TEXT_COMPRESSION_NONE;
    text[num_text].key = const_cast<char*>("Description");
    text[num_text].text = const_cast<char*>("3d Rendering");
    ++num_text;
    
    png_set_text(png_ptr, info_ptr, text, num_text);    
    png_set_packing(png_ptr);

    
    
    unsigned char **row_pointers = new unsigned char* [2*height];
    for (int i=0; i<height; i++)
      row_pointers[i]= new unsigned char[4*width];

    for(int i = 0; i < height;++i)
      for(int j = 0; j < width; ++j)
      {
	row_pointers[i][j*4] =  static_cast<unsigned char>(255*pixels[(i)*width*4 +j*4+0]);
	row_pointers[i][j*4+1] = static_cast<unsigned char>(255*pixels[(i)*width*4 +j*4+1]);
	row_pointers[i][j*4+2] = static_cast<unsigned char>(255*pixels[(i)*width*4 +j*4+2]);
	row_pointers[i][j*4+3] = static_cast<unsigned char>(255*pixels[(i)*width*4 +j*4+3]);
	//	row_pointers[i][j*4+3] = 255;
      }
    
    png_set_rows(png_ptr, info_ptr, row_pointers);

    //    png_write_info(png_ptr, info_ptr);
    
    png_write_png(png_ptr, info_ptr, PNG_TRANSFORM_IDENTITY, NULL);
    png_write_end(png_ptr, info_ptr);

    for (int i=0; i<height; i++)
      delete[] row_pointers[i];
    delete[] row_pointers;
    png_destroy_write_struct(&png_ptr, &info_ptr);
  }catch(int err){
    std::cerr << "Png write error " << err << std::endl;}
  fclose(fp);
}  

void read()
{
  using namespace std;
  std::ifstream f;
  f.exceptions(ios::badbit | ios::eofbit | ios::failbit);
  std::cout << "Reading ... "<< fname.c_str() << std::endl;
  f.open(fname.c_str(), ios::binary);
  im.clear();
  try{
    while(1)
    {
      char unsigned a[2];
      unsigned short b;
      short sb;
      f.read((char*)a, 2);
      b = ((a[0])<<8)|(a[1]);
      sb = (((signed char)(a[0]))<<8)|(a[1]);
      //      std::cout << b << " " << sb << endl;
      im.push_back(sb);
    }
  }catch(...)
  {
  }
}

int main(int argc, char**argv)
{
  if (argc>1)
  {
    fname = argv[1];
  }
  width = height = 220;
  int N1 = width;
  int N2 = height;
  int N3 = 35;
    
  int ox = (512 - width)/2-5;
  int oy = (512 - height)/2+10;
  std::vector<float> pels;
  std::vector<signed short> spels;
  vector3d<unsigned char> image;
  vector3d<signed short> simage;
  image.SetSize(N1, N2, N3);
  simage.SetSize(N1, N2, N3);

  for(int frame = 3; frame <=37; ++frame)
  {
    pels.clear();
    pixels.clear();
    spels.clear();
    {
      std::stringstream a;
      a.fill('0');
      a << "IMG00" << std::setw(2) << frame;
      fname = a.str();
    }
    read();

    for(int i = 0; i < im.size(); ++i)
    {
      int mid = 00;
      int range = 300;
      int min = mid - range/2;
      short a = im[i];
      spels.push_back(a);
      int r = a;
      r -= min;
      if (r<0)
	r = 0;
      if (r>range)
	r = range;
      float f = (float) r/range;
      f = 1-f;
      pels.push_back(f);
    }
    for(int i = 0; i < height; ++i)
      for(int j = 0; j < width; ++j)
      {
	float f = pels[(i+oy)*512+j+ox];
	pixels.push_back(f);
	pixels.push_back(f);
	pixels.push_back(f);
	pixels.push_back(1.);
	short a = spels[(i+oy)*512+j+ox];
		 
	  
	image(i,j,frame-3) = (unsigned char)f*255;
	simage(i,j,frame-3) = a;
      }
    std::cout << fname <<std::endl;
    save_png();
  }
  //  std::auto_ptr<vector3d<unsigned char> > im = Mirror(image, 7);

//   vector3d<unsigned char> oim;
//   oim.SetSize(N3, N1, N2);
//   for(int i = 0; i < N1; ++i)
//     for(int j = 0; j < N2; ++j)
//       for(int k = 0; k < N3; ++k)
//       {
// 	int a = 0;
// 	//oim(i,j,k) = image(i,j,34*k/(N1-1));
// 	a += simage(i + 0, j + 0, k);
// // 	a += simage(i + 1, j + 0, k);
// // 	a += simage(i + 0, j + 1, k);
// // 	a += simage(i + 1, j + 1, k);
// // 	a /= 4;
// 	unsigned char val;
// 	if (a < -1000)
// 	  val = 0;
// 	else if ((a >=-1000)&&(a<-150))
// 	  val = (a+1000)*127/849 + 1;
// 	else if (a <1000)
// 	  val = (a+150)*125/1149+129;
// 	else
// 	  val = 255;
// 	if(a >500)
// 	  std::cout << a << " " << (int) val << std::endl;
// 	oim(k, j, i) = val;
//       }
//   oim.Write("35x220x220.comp.bone");
  vector3d<unsigned char> oim;
  oim.SetSize(N3, N1/2, N2/2);
  for(int i = 0; i < N1/2; ++i)
    for(int j = 0; j < N2/2; ++j)
      for(int k = 0; k < N3; ++k)
      {
	int a = 0;
	//oim(i,j,k) = image(i,j,34*k/(N1-1));
	a += simage(i*2 + 0, j*2 + 0, k);
	a += simage(i*2 + 1, j*2 + 0, k);
	a += simage(i*2 + 0, j*2 + 1, k);
	a += simage(i*2 + 1, j*2 + 1, k);
	a /= 4;
	unsigned char val;
	if (a < -1000)
	  val = 0;
	else if ((a >=-1000)&&(a<-150))
	  val = (a+1000)*127/849 + 1;
	else if (a <1000)
	  val = (a+150)*125/1149+129;
	else
	  val = 255;
	oim(k, j, i) = val;
      }
  oim.Write("35x110x110.comp.bone");

}
