#include <iostream>
#include <string>
#include <sstream>
#include "mirorer.h"

template<class T>T Convert(const std::string &s)
{
  T res;
  std::istringstream is(s);
  is >> res;
  return res;
}

int main(int argc, char **argv)
{
  if (argc <7)
    return  1;
  std::string filename = "default";
  int N1, N2, N3;
  double dim = 37e-6;
  typedef unsigned char T;
  T thres = 100;
  filename = argv[1];
  N1 = Convert<int>(argv[2]);
  N2 = Convert<int>(argv[3]);
  N3 = Convert<int>(argv[4]);
  dim = Convert<double>(argv[5]);
  thres = Convert<int> (argv[6]);
  std::istringstream is(filename);
  int sz;
  is >> sz;
  std::cout << "size is " << N1 <<"x" << N2 << "x" << N3 <<"; voxel size si " << dim<< std::endl;
  vector3d<T > vec;
  vector3d<unsigned char> vecc;

  vec.SetSize(N1, N2, N3, dim, dim, dim);
  vecc.SetSize(N1, N2, N3, dim, dim, dim);
  vec.Read(filename, 0);
  std::ostringstream os;
  os << sz <<".bonec.inr";
  unsigned long cnt = 0;
  std::cout << "Thres is " << thres << std::endl;
  T max = 0;
  for (int i = 0; i < N1; ++i)
    for (int j = 0; j< N2; ++j)
      for (int k =0; k < N3; ++k)
      {
	T val = vec(i,j,k);
	//	SwapEndian(val);
	if (val > max)
	  max = val;
	unsigned char c = val<thres;
	c*=255u;
	if (c)
	  cnt++;
	vecc(i,j,k) = c;
      }
  std::cout << "Nonzero voxel count  = " << cnt << std::endl;
  std::cout << "Volume ratio is " << 100.0*cnt/N1/N2/N3 << "% " << std::endl;
  std::cout << "Max = " <<(int) max << std::endl;
  vecc.WriteInr(os.str());
  //  std::cout << "written " << (double)nzcount/sz1/sz2/sz3 << std::endl;
}
