
# include <vector>
# include <map>
# include <cmath>
# include <iostream>
# include <iomanip>
# include <fstream>
# include <string>
# include <sstream>
# include <stdexcept>

#include <sstream>
#include "meshreader.h"

#include "mirorer.h"


double MIN_X,MAX_X, MIN_Y, MAX_Y, MIN_Z, MAX_Z;
double vsx, vsy, vsz;
double minx, miny, minz, maxx, maxy, maxz;
double xc, yc, zc;

static float angle=0.3,ratio = 1;

double dist = 20;

template <class T>
inline bool In(const T&a, const T&min, const T &max)
{
  return (a >=min) && (a<max);
}



void DoIt ()
{
  
  MAX_X = MIN_X = nodes[0][0];
  MAX_Y = MIN_Y = nodes[0][1];
  MAX_Z = MIN_Z = nodes[0][2];
  
  for(int i = 0; i <  
	ellements.size()
	; ++i)
    {
      Point3d<double> off;
      Point3d<double> &base = nodes[ellements[i][0]];
      GetOffs(ellements[i], off);
      MAX_X = std::max(MAX_X, base[0]);
      MIN_X = std::min(MIN_X, base[0]);
      MAX_Y = std::max(MAX_Y, base[1]);
      MIN_Y = std::min(MIN_Y, base[1]);
      MAX_Z = std::max(MAX_Z, base[2]);
      MIN_Z = std::min(MIN_Z, base[2]);
      double z = (MIN_Z + base[2])/20;
      
    }
  MIN_Z += vsz * 30;
  MAX_Z += vsz * 30;
  xc = (MIN_X + MAX_X)/2;
  yc = (MIN_Y + MAX_Y)/2;
  zc = (MIN_Z + MAX_Z)/2;
  int sz = 64;
  vector3d<unsigned char > vec;
  std::auto_ptr<vector3d<unsigned char > > rvec;
  vec.SetSize(sz,sz,sz);
  for(int i = 0; i <  
	ellements.size()
	; ++i)
    {
      Point3d<double> off;
      Point3d<double> &base = nodes[ellements[i][0]];
      GetOffs(ellements[i], off);

      int ix, iy, iz;
      ix = int((base[0] - xc)/vsx + sz/2);
      iy = int((base[1] - yc)/vsy + sz/2);
      iz = int((base[2] - zc)/vsz + sz/2);
      double c = 0.5 + double(iz)/sz/2;
      if (In (ix, 0, sz) &&
	  In (iy, 0, sz) &&
	  In (iz, 0, sz))
	//	if(!(rand()%4))
	//  DrawHex(base[0], base[1], base[2], off[0], off[1], off[2]);
	vec(ix,iy,iz) = 1;
    }
  rvec = Mirror(vec, 8);
  for(int i = 0; i < 0; i++)
  {
    rvec->ConvertAllTo(2);
    rvec->ExtrudeAll();
    rvec->ConvertAllTo(1);
  }
  //  rvec->RemoveBad();
  rvec->ConvertAllTo(1);
  int sizes[] = {16, 32, 48,  64, 80, 96, 112, 128, 144, 160, 176, 192, 208, 224, 240, 256,512};
  for(int i = 0; i < sizeof(sizes)/sizeof(int); ++i)
  {
    int &a = sizes[i];
    std::cout << "writing " << a <<  std::endl;
    vec.SetSize(a, a, a);
    vec = *rvec;
    vec.ConvertAllTo(1);
    vec.RemoveBad();
    std::stringstream ss;
    ss << a << ".bone";
    vec.Write(ss.str());
  }
}



int main(int argc, char * argv[])
try {
  
  ReadMesh("zv_s06-66_fe.mesh");
  DoIt();

} catch (const std::runtime_error & e) {
    std::cerr << e.what() << std::endl;
}
