
#include <iostream>
#include <string>
#include <sstream>
#include <map>
#include <vector>

#include "mirorer.h"

struct Info
{
  int type;
  int x,y,z;
  int old_type;
};

template<class T>
void Paint(vector3d<T> &vec, int tres = 132)
{
  const int count_thres = 1000;
  typedef unsigned int_type;
  vector3d<int_type > wvec;
  wvec.SetSize(vec);
  int sz1, sz2, sz3;
  sz1 = vec.sizes[0];
  sz2 = vec.sizes[1];
  sz3 = vec.sizes[2];
  unsigned char ch;
  int Air=40;
  for(int i = 0; i < sz1; ++i)
    for(int j = 0; j < sz2; ++j)
      for(int k = 0; k < sz3; ++k)
	wvec(i,j,k)=ch;//((ch=vec(i,j,k))>tres)?255:ch;
  //	wvec(i,j,k)=((ch=vec(i,j,k))>tres)?255:0;
  int_type cur_col = 256;
  typedef std::multimap<size_t, Info> map_type;
  map_type map;
  for(int i = 0; i < sz1; ++i)
    for(int j = 0; j < sz2; ++j)
      for(int k = 0; k < sz3; ++k)
      {
	int_type old = wvec(i,j,k);
	if (old == Air || old == 255)
	{
	  bool strange;
	  std::pair<size_t, short> res =  wvec.floodfill(i,j,k, cur_col, strange);
	  Info info;
	  info.x = i;
	  info.y = j;
	  info.z = k;
	  info.type = cur_col;
	  info.old_type = old;
	  map.insert(std::make_pair(res.first, info));
	  std::cout << cur_col << " " << res.first << " " << res.second << std::endl;
	  cur_col++;
	} 
      }

  std::cout << "Translating 1 ... " << std::endl;
  map_type::reverse_iterator rit;
  rit = map.rbegin();
  // most are void
  Info back = rit->second;
  rit ++;
  // next is good
  Info front = rit->second;
  rit ++;
  if (back.old_type !=Air)
  {
    std::cout << "changing " << std::endl;
    Info tmp = back;
    back = front;
    front = tmp;
  }
  std::cout << "Old back " << back.old_type << ", Old front " << front.old_type << std::endl;
  std::pair<size_t, short> resi;
  bool strange;
  resi = wvec.floodfill(back.x, back.y, back.z, Air, strange);
  std::cout << "fon " << resi.first << " " << resi.second << std::endl;
  resi = wvec.floodfill(front.x, front.y, front.z, 255, strange);
  for (;rit != map.rend(); ++rit)
  {
    Info &info = rit->second;
    int_type old = wvec(info.x, info.y, info.z);
    if (old == Air || old == 255)
    {
      std::cout << "suspisious  --> " << std::endl;
    }
    std::pair<size_t, int_type> res;
    if (rit->second.old_type==Air)
    {
      res = wvec.floodfill(info.x, info.y, info.z, 130, strange);
      if (res.second == 255 && ! strange);
      else
	wvec.floodfill(info.x, info.y, info.z, Air, strange);
    }else
      wvec.floodfill(info.x, info.y, info.z, Air, strange);
  }
  size_t vc = wvec.GetCountOf(Air);
  size_t gc = wvec.GetCountOf(255);
  size_t ic = wvec.GetCountOf(130);
  std::cout << vc << " " << gc << " " << ic <<" " <<  std::endl;
  std::cout << (double)(gc+ic)/(vc+gc+ic)<< " " << (double)ic/gc << std::endl;
  std::cout << "Copying..." << std::endl;
  for(int i = 0; i < sz1; ++i)
    for(int j = 0; j < sz2; ++j)
      for(int k = 0; k < sz3; ++k)
	vec(i,j,k) = wvec(i,j,k);
}

int main(int argc, char **argv)
{
  std::string filename = "default";
  if (argc >1)
    filename = argv[1];
  std::string fame = "132";
  if (argc >2)
    fame = argv[2];
  std::istringstream is1(fame);
  int tres;
  is1 >> tres;
  
  std::cout << "thres is " << tres << std::endl;
  vector3d<unsigned char > vec;
  vec.ReadInr(filename);
  std::cout << "read!" << std::endl;
  std::cout << "Converting..." << std::endl;
  Paint(vec, tres);
  filename = "tran."+filename;
  if (argc >3)
    filename = argv[3];
  vec.WriteInr(filename);
}
