#ifndef __mirorer_h__
#define __mirorer_h__
#include "math.h"
#include <vector>
#include <iostream>
#include <algorithm>
#include <string>
#include <fstream>
#include <limits>
#include <memory>
#include <queue>
#include <cassert>
#include <stdint.h>
#include <cstddef>
#include <sstream>
#include <typeinfo>


template<class T>
struct Tripple
{
  T i, j, k;
};

template<class T>
void SwapEndian(T &a)
{
  T res = 0;
  for (int i = 0; i < sizeof(T); i++)
    {
      T byte = 255&(a >> i*8);
      res += byte << (8*(sizeof(T)-1-i));
    }
  a = res;
}
template<class To, class From>
To NoCast(From const &a)
{
  From b = a;
  // if (typeid(To)==typeid(double))
  //  SwapEndian(b);
  To ret = *reinterpret_cast<To const *>(&b);
  return ret;
}

template<class T, class Str>
  T GetVal(Str&f)
{
  std::string line;
  std::getline(f, line);
  std::istringstream l(line);
  while(true){
    char ch;
    l.get(ch);
    if(!l)
      break;
    if (ch=='=')
      break;
  }
  T res;
  l >> res;
  return res;
}

template<class T>
class vector3d
{
  size_t lastcount;
  typedef std::vector<T> vec_type;
 public:
  typedef typename vec_type::size_type size_type;
 private:
  vec_type buf;
  vector3d(const vector3d&);
public:
  double dim[3];
  void Clear()
  {
    vec_type buf1;
    buf1.swap(buf);
  }
  void RemoveOuter()
  {
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type i = 0; i < sizes[0]; ++i)
	(*this)(i, 0, k) = (*this)(i, sizes[1]-1, k) = 0;
    for(size_type i = 0; i < sizes[0]; ++i)
      for(size_type j = 0; j < sizes[1]; ++j)
	(*this)(i, j, 0) = (*this)(i, j, sizes[2]-1) = 0;
    for(size_type j = 0; j < sizes[1]; ++j)
      for(size_type k = 0; k < sizes[2]; ++k)
	(*this)(0, j, k) = (*this)(sizes[0]-1, j, k) = 0;
	  
  }
  double zero, xmin, xmax, ymin, ymax, zmin, zmax, xs,ys,zs;
  void SetPars(double zer, double xmi, double xma,
	       double ymi, double yma,
	       double zmi, double zma)
  {
    zero = zer;
    xmin = xmi;
    xmax = xma;
    ymin = ymi;
    ymax = yma;
    zmin = zmi;
    zmax = zma;
/*     xmax -= xmin; */
/*     ymax -= ymin; */
/*     zmax -= zmin; */
    xs = xmax-xmin;
    ys = ymax-ymin;
    zs = zmax-zmin;
//    std::cout << zmin << " " << zmax << std::endl;
  }
  
  template<class V>
  V GetAt(V x, V y, V z)
  {
    T a = (*this)(size_type((double)(x-xmin)/xs*sizes[0]),
		   size_type((double)(y-ymin)/ys*sizes[1]),
		   size_type((double)(z-zmin)/zs*sizes[2]));
/*     if (a < 100) */
/*       std::cout << x + xmin << " " << y +ymin << " " << z +zmin<< " " <<a <<std::endl; */
    return a;
    T val =  a/std::numeric_limits<T>::max();
    return zero + val*(1.0-zero);

  }
  void Write(std::string fname)
  {
    std::ofstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str(), std::ios::binary);
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type i = 0; i < sizes[0]; ++i)
	for(size_type j = 0; j < sizes[1]; ++j)
	  f.write(reinterpret_cast<const char*>(&(*this)(i,j,k)), sizeof(T));
  }
  void WriteVTK(std::string fname)
  {
    std::ofstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str(), std::ios::out);
    f << "<?xml version=\"1.0\"?>\n";//"<?xml version=\"1.0\"?>\n"; 
    f << "<VTKFile type=\"ImageData\" version=\"0.1\" byte_order=\"LittleEndian\">\n";
    f << " <ImageData WholeExtent=\"0 "
      << sizes[0] << " 0 " << sizes[1] << " 0 " << sizes[2]
      <<"\" Origin=\"0 0 0\" Spacing=\" "
      <<dim[0] << " " << dim[1] << " " << dim[2] << "\">\n";
    f << "  <Piece Extent=\"0 "
      << sizes[0] << " 0 " << sizes[1] << " 0 " << sizes[2]
      <<"\">\n";
    f << "   <CellData Scalars=\"cell_scalars\">						      \n";
    f << "    <DataArray type=\"Float32\" Name=\"cell_scalars\" format=\"ascii\">		      \n";
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type i = 0; i < sizes[0]; ++i)
	  f << (double)(*this)(i,j,k)<< "\n";
    f << "    </DataArray>								      \n";
    f << "   </CellData>								      \n";
    f << " </Piece>									      \n";
    f << "</ImageData>									      \n";
    f << "</VTKFile>                                                                          \n";










  }
  void WriteNormalOrder(std::string fname)
  {
    std::ofstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str(), std::ios::binary);
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type i = 0; i < sizes[0]; ++i)
	  f.write(reinterpret_cast<const char*>(&(*this)(i,j,k)), sizeof(T));
  }
  void WriteInr(std::string fname)
  {
    WriteInr(fname, dim[0], dim[1], dim[2]);
  }
  void WriteInr(std::string fname, double vx, double vy = 1, double vz = 1)
  {
    std::ofstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str(), std::ios::binary);
    f << "#INRIMAGE-4#{" << std::endl;
    f << "XDIM=" << sizes[0] << std::endl;
    f << "YDIM=" << sizes[1] << std::endl;
    f << "ZDIM=" << sizes[2] << std::endl;
    f << "VDIM=" <<  1 << std::endl;
    f << "VX=" <<  vx << std::endl;
    f << "VY=" <<  vy << std::endl;
    f << "VZ=" <<  vz << std::endl;
    f << "TYPE=unsigned fixed" << std::endl;
    f << "PIXSIZE=" << sizeof(T)*8 << " bits"<< std::endl;
    f << "SCALE=1" << std::endl;
    f << "CPU=pc" << std::endl;
    for (int i = 0; i < 256; ++i)
      f << std::endl;
    f.seekp(256-4, std::ios_base::beg);
    f << "##}" << std::endl;
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type i = 0; i < sizes[0]; ++i)
	  f.write(reinterpret_cast<const char*>(&(*this)(i,j,k)), sizeof(T));
  }
  void ReadInr(std::string fname)
  {
    std::ifstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str());//, std::ios::binary);
    std::cout << "File_Opened" << std::endl;
    GetVal<std::string>(f); //f << "#INRIMAGE-4#{" << std::endl;
    sizes[0] = GetVal<size_type>(f);//f << "XDIM=" << sizes[0] << std::endl;
    sizes[1] = GetVal<size_type>(f);//f << "YDIM=" << sizes[1] << std::endl;
    sizes[2] = GetVal<size_type>(f);//f << "ZDIM=" << sizes[2] << std::endl;
    GetVal<std::string>(f);//    f << "VDIM=" <<  1 << std::endl;
    dim[0] = GetVal<double>(f);//f << "VX=" <<  vx << std::endl;
    dim[1] = GetVal<double>(f);//    f << "VY=" <<  vy << std::endl;
    dim[2] = GetVal<double>(f);//    f << "VZ=" <<  vz << std::endl;
    SetSize(sizes[0], sizes[1], sizes[2],
	    dim[0], dim[1], dim[2]);
    GetVal<std::string>(f);//    f << "TYPE=unsigned fixed" << std::endl;
    int size = GetVal<int>(f);//f << "PIXSIZE=" << sizeof(T)*8 << " bits"<< std::endl;
    assert(sizeof(T)==(size/8));
    //    f << "SCALE=1" << std::endl;
    //    f << "CPU=pc" << std::endl;
    f.seekg(256, std::ios_base::beg);
    std::cout << "read header" << std::endl;
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type i = 0; i < sizes[0]; ++i)
	  {
	    T a;
	    f.read(reinterpret_cast<char*>(&a), sizeof(a));
	    assert((bool)(f));
	    (*this)(i,j,k) = a;
	    //	    f.write(reinterpret_cast<const char*>(&(*this)(i,j,k)), sizeof(T));
	  }
  }

  void WriteKpv(const std::string &fname)
  {
    std::ofstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str(), std::ios::binary);
    uint32_t magic= 0xC0CAFEEEu;
    double md = 2<<16;
    double magicd = md*md*2.0 + md + 1;
    uint16_t header_size = 76;
    f.write(reinterpret_cast<const char*> (&magic), 4);            
    f.write(reinterpret_cast<const char*> (&magicd), 8);
    f.write(reinterpret_cast<const char*> (&header_size), 2);
    double origin[3] = {0,0,0};
    double S[3] = {37e-6, 37e-6, 37e-6};
    uint32_t sz[3];
    const int indorder[3] = {2, 0, 1};
    for(int i = 0; i < 3; ++i)
    {
      sz[i] = sizes[indorder[i]];
      S[i] *= sz[i];
    }
    for (int i = 0; i < 3; ++i)
      f.write(reinterpret_cast<const char*>(sz +i), 4);
    for (int i = 0; i < 3; ++i)
      f.write(reinterpret_cast<const char*>(origin +i), sizeof(double));
    for (int i = 0; i < 3; ++i)
      f.write(reinterpret_cast<const char*>(S +i), sizeof(double));
    
    uint16_t format = sizeof (size_type);
    f.write(reinterpret_cast<const char*> (&format), 2);
    f.seekp(header_size);
    for(size_type k = 0; k < sizes[indorder[0]]; ++k)
      for(size_type i = 0; i < sizes[indorder[1]]; ++i)
	for(size_type j = 0; j < sizes[indorder[2]]; ++j)
	{
	  size_type &ii=k, &jj=i, &kk=j;
	  f.write(reinterpret_cast<const char*>(&(*this)(ii,jj,kk)), sizeof(T));
	}
  }
	
    
  void ReadTextFile(std::string fname)
  {
    std::ifstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str());
    size_t xs, ys, zs;
    f >> xs >> ys >> zs;
    SetSize(xs, ys, zs);
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type i = 0; i < sizes[0]; ++i)
	{
	  T val;
	  f >> val;
	  std::cout << val << std::endl;
	  //	  std::cout << i << ", " << j << ", " << k << " = " << val << std::endl;
	  (*this)(i,j,k) = val;
	}  
        
  }
template<class V>
  void ReadTextFile(std::string fname)
  {
    std::ifstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str());
    size_t xs, ys, zs;
    f >> xs >> ys >> zs;
    SetSize(xs, ys, zs);
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type i = 0; i < sizes[0]; ++i)
	{
	  V val;
	  f >> val;
	  //	  std::cout << val << std::endl;
	  //	  std::cout << i << ", " << j << ", " << k << " = " << val << std::endl;
	  (*this)(i,j,k) = T(val);
	}  
    
  }
    
  void ReadBytes(std::string fname, int startline)
  {
    bool inr = fname.substr(fname.length()-4)==".inr";

    std::ifstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str(), std::ios::binary);
    f.seekg((inr*256)+startline * sizes[0]*sizes[1]);
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type i = 0; i < sizes[0]; ++i)
	  {
	    unsigned char ch;
	    f.read((char*)&ch, 1);
	    (*this)(i,j,k) = ch;
	  }
  }
  void Read(std::string fname, int startline)
  {
    std::ifstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str(), std::ios::binary);
    f.seekg(sizeof(T)*startline * sizes[0]*sizes[1]);
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type i = 0; i < sizes[0]; ++i)
	  {
	    // unsigned long long val = 0;
	    // for (int l = 0; l < sizeof(T); ++l)
	    // {
	    //   unsigned char ch;
	    //   f.read(reinterpret_cast<char*>(&ch), 1);
	    //   val += ch << (l*8);
	    // }
	    // (*this)(i,j,k) = NoCast<T>(val);
	    f.read(reinterpret_cast<char*>(&(*this)(i,j,k)), sizeof(T));
	  }
  }
  size_type sizes[3];
  vector3d(){sizes[0] = sizes[1] = sizes[2] = 0; dim[0]=dim[1]=dim[2]=1.0;}
  void SetSize(size_type i, size_type j, size_type k,
	       double xs=0, double ys=0, double zs =0)
  {
    sizes[0] = i; sizes[1] = j; sizes[2] = k;
    if (xs == 0)
      xs = 1./i;
    if (ys == 0)
      ys = 1./j;
    if (zs == 0)
      zs = 1./k;
    dim[0] = xs;
    dim[1] = ys; 
    dim[2] = zs;
    buf.resize(i*j*k);
  }
  template<class V>
  void SetSize(vector3d<V> const&a)
  {
    SetSize(a.sizes[0], a.sizes[1], a.sizes[2],
	    a.dim[0], a.dim[1], a.dim[2]);
  }
  template<class V>
  vector3d& operator=(const vector3d<V> &a)
  {
    for(size_type i = 0; i < sizes[0]; ++i)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type k = 0; k < sizes[2]; ++k)
	  (*this)(i,j,k) = a(i,j,k);
    return (*this);
  }
  void ExtrudePt(size_type i, size_type j, size_type k)
  {
    ptrdiff_t szs[3];
    for(szs[0] = i - 1; szs[0] <=i+1; ++szs[0])
      for(szs[1] = j - 1; szs[1] <=j+1; ++szs[1])
	for(szs[2] = k - 1; szs[2] <=k+1; ++szs[2])
	{
	  for(int l = 0; l < 3; ++l)
	    if((szs[l] < 0)||(szs[l] >=sizes[l]))
	      goto cont;
	  (*this)(szs[0], szs[1], szs[2]) |= 1;
	cont:;
	}
  }
  void ExtrudeAll()
  {
    ptrdiff_t szs[3];
    for(szs[0] = 0; szs[0] <sizes[0]; ++szs[0])
      for(szs[1] = 0; szs[1] <sizes[1]; ++szs[1])
	for(szs[2] = 0 ; szs[2] <sizes[2]; ++szs[2])
	  if((*this)(szs[0], szs[1], szs[2])&2)
	    ExtrudePt(szs[0], szs[1], szs[2]);
  }
  void ConvertAllTo(T one)
  {
    ptrdiff_t szs[3];
    for(szs[0] = 0; szs[0] <sizes[0]; ++szs[0])
      for(szs[1] = 0; szs[1] <sizes[1]; ++szs[1])
	for(szs[2] = 0 ; szs[2] <sizes[2]; ++szs[2])
	  if((*this)(szs[0], szs[1], szs[2]))
	    (*this)(szs[0], szs[1], szs[2]) = one;
  }
  void Translate(T what, T one)
  {
    ptrdiff_t szs[3];
    for(szs[0] = 0; szs[0] <sizes[0]; ++szs[0])
      for(szs[1] = 0; szs[1] <sizes[1]; ++szs[1])
	for(szs[2] = 0 ; szs[2] <sizes[2]; ++szs[2])
	  if((*this)(szs[0], szs[1], szs[2])==what)
	    (*this)(szs[0], szs[1], szs[2]) = one;
  }
typename  std::vector<T>::reference operator()(size_type i, size_type j, size_type k)
  {
    return buf[sizes[0]*sizes[1]*k + sizes[0]*j + i];
  }
  T const operator()(size_type i, size_type j, size_type k)const
  {
    return buf[sizes[0]*sizes[1]*k + sizes[0]*j + i];
  }

  size_t GetCountOf(T a)
  {
    size_t count = 0;
    for(size_type i = 0; i < sizes[0]; ++i)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type k = 0; k < sizes[2]; ++k)
	  if ((*this)(i,j,k)==a)
	    count++;
    return count;
  }
	  
  // number - is this a border;
  std::pair<size_t, T> floodfill(int i , int j, int k, T newval, bool&strange)
  {
    T oldval = (*this)(i,j,k);
    if (oldval==newval)
      return std::make_pair(0, newval);
    (*this)(i,j,k) = newval;
    size_t count = 1;
    std::queue<Tripple<int> > que;
    Tripple<int> tri,tri1;
    tri.i = i;
    tri.j = j;
    tri.k = k;
    que.push(tri);
    T boundary = newval;
    strange = false;
    while(!que.empty())
    {
      tri = que.front();
      que.pop();
      for(int ii = -1; ii <= 1; ++ii)
	for(int jj = -1; jj <= 1; ++jj)
	  for(int kk = -1; kk <= 1; ++kk)
	  {
	    if((abs(ii)+abs(jj)+abs(kk))!=1)	       
	      continue;
	    i = tri.i + ii;
	    j = tri.j + jj;
	    k = tri.k + kk;
	    if(
	       i < 0 ||
	       i >=sizes[0] ||
	       j < 0 ||
	       j >=sizes[1] ||
	       k < 0 ||
	       k >=sizes[2])
	    {
	      continue;
	    }
	    if((*this)(i,j,k)!=oldval)
	    {
	      int cur_val = (*this)(i,j,k);
	      if (boundary==newval)
		boundary = cur_val;
	      else
		if (boundary != cur_val)
		  strange = true;
	    }

	    if((*this)(i,j,k)==oldval) 
	    {
	      tri1.i = i;
	      tri1.j = j;
	      tri1.k = k;
	      (*this)(i, j, k) = newval;
	      count++;
	      que.push(tri1);
	    }
	  }
    }   
    return std::make_pair(count, boundary);
  }
  T Enumerate(int i, int j, int k, T val)
  {
    //    std::cout << i << " " << j  << " " << k << std::endl;
    if(
       i < 0 ||
       i >=sizes[0] ||
       j < 0 ||
       j >=sizes[1] ||
       k < 0 ||
       k >=sizes[2])
      return 0;
    T  &a = (*this)(i,j,k);
    if (a!=1)
      return a;
    std::queue<Tripple<int> > que;
    Tripple<int> tri,tri1;
    tri.i = i;
    tri.j = j;
    tri.k = k;
    lastcount = 0;
    que.push(tri);
    (*this)(tri.i, tri.j, tri.k) = val;
    lastcount++;
    while(!que.empty())
      {
	tri = que.front();
	que.pop();
	  for(int ii = -1; ii <= 1; ++ii)
	    for(int jj = -1; jj <= 1; ++jj)
	      for(int kk = -1; kk <= 1; ++kk)
		{
		  if((abs(ii)+abs(jj)+abs(kk))!=1)	       
		  continue;
		  i = tri.i + ii;
		  j = tri.j + jj;
		  k = tri.k + kk;
		  if(
		     i < 0 ||
		     i >=sizes[0] ||
		     j < 0 ||
		     j >=sizes[1] ||
		     k < 0 ||
		     k >=sizes[2])
		  continue;
 		  if((*this)(i,j,k)==1) 
/* 		  continue; */
		    {
		      tri1.i = i;
		      tri1.j = j;
		      tri1.k = k;
		      (*this)(i, j, k) = val;
		      lastcount++;
		      que.push(tri1);
		    }
		}
      }
    return val;
  }
  T EnumerateKill(int i, int j, int k, T val)
  {
    //    std::cout << i << " " << j  << " " << k << std::endl;
    if(
       i < 0 ||
       i >=sizes[0] ||
       j < 0 ||
       j >=sizes[1] ||
       k < 0 ||
       k >=sizes[2])
      return 0;
    T  &a = (*this)(i,j,k);
    if (a!=val)
      return 0;
    std::queue<Tripple<int> > que;
    Tripple<int> tri;
    tri.i = i;
    tri.j = j;
    tri.k = k;
    que.push(tri);
    while(!que.empty())
      {
	tri = que.front();
	que.pop();
	if((*this)(tri.i, tri.j, tri.k) == val)
          (*this)(tri.i, tri.j, tri.k) = 0;
	else
	  for(int ii = -1; ii <= 1; ++ii)
	    for(int jj = -1; jj <= 1; ++jj)
	      for(int kk = -1; kk <= 1; ++kk)
		{
		  if((abs(ii)+abs(jj)+abs(kk))!=1)	       
		  continue;
		  i = tri.i + ii;
		  j = tri.j + jj;
		  k = tri.k + kk;
		  if(
		     i < 0 ||
		     i >=sizes[0] ||
		     j < 0 ||
		     j >=sizes[1] ||
		     k < 0 ||
		     k >=sizes[2])
		  continue;
		  if((*this)(i,j,k)!=1)
		  continue;
		  tri.i = i;
		  tri.j = j;
		  tri.k = k;
		  que.push(tri);
		}
      }
    return val;
  }
  
  void RemoveBad(int minsize = 200)
  {
    T cur = 2;
    T ret;
    for(size_type i = 0; i < sizes[0]; ++i)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type k = 0; k < sizes[2]; ++k)
	{
	  ret = Enumerate(i,j,k,cur);
	  if (ret == cur)
	  {
	    //	    std::cout << (int) cur << std::endl;
	    //	    std::cout << (int )cur -2 << " " <<lastcount << std::endl;
	    // 	    if(cur<=20000)

	    if(lastcount < minsize)
	      EnumerateKill(i,j,k,cur);
	    else
	      cur++; 
	  }
	}
    std::cout << "Different "<<(int) cur -2 << std::endl;
/*      if (cur==20000)  */
/*        cur++;  */
    //    return;
    std::vector<size_t> counts;
    counts.resize(cur);
    for(size_type i = 0; i < sizes[0]; ++i)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type k = 0; k < sizes[2]; ++k)
	{
	  assert((*this)(i,j,k)<cur);
	  //	  std::cout << i << " " << j < " " << k << std::endl;
	  ++counts[(*this)(i,j,k)];
	}
    counts[0] = counts[1] = 0;
    //    std::sort(counts.begin(), counts.end(), std::greater<size_t>());
    //    std::cout << "sizes are" << std::endl;
    minsize = 0;
    int mc = 0;
    for(int i = 0; i < counts.size(); ++i)
      if(counts[i] > minsize)
	{
	  minsize=counts[i];
	  mc = i;
	}
/*     for(int i = 0; i < counts.size();++i) */
/*       std:: cout << counts[i] << std::endl; */
    std::cout << "num = " << minsize << std::endl;
    for(size_type i = 0; i < sizes[0]; ++i)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type k = 0; k < sizes[2]; ++k)
	{
	    T &a = (*this)(i,j,k);
	    a = (a==mc)?std::numeric_limits<T>::max():0;
/* 	    int off; */
/* 	    for(off = 2; off < counts.size(); off++) */
/* 	      if(a == off && counts[off]>=minsize) */
/* 	      { */
/* 		a = std::numeric_limits<T>::max();break; */
/* 	      } */
/* 	    if (off == counts.size()) */
/* 	      a = 0; */
	}
      
  }
  
};


template<class T>
std::auto_ptr<vector3d<T> >
Mirror(vector3d<T> const & vec, int times)
{
  vector3d<T> *ret = new vector3d<T>;
  ret->SetSize(vec.sizes[0]*times,
	       vec.sizes[1]*times,
	       vec.sizes[2]*times);

  for(int ii = 0; ii <  times; ++ii)
    for(int jj = 0; jj < times; ++jj)
      for(int kk = 0; kk < times; ++kk)
      {
	int si = (ii&1)*-2 +1;
	int sj = (jj&1)*-2 +1;
	int sk = (kk&1)*-2 +1;
	int oi = vec.sizes[0]*(ii + (ii&1))-(ii&1);
	int oj = vec.sizes[1]*(jj + (jj&1))-(jj&1);
	int ok = vec.sizes[2]*(kk + (kk&1))-(kk&1);
	for(int i = 0; i < vec.sizes[0]; ++i)
	  for(int j = 0; j < vec.sizes[1];++j)
	    for(int k = 0; k < vec.sizes[2];++k)
	      (*ret)(oi + si*i, oj + sj*j, ok + sk*k) = vec(i,j,k);
      }
  return std::auto_ptr<vector3d<T> >(ret);
}

template<class A>
void SetMin(A &a, A const &b)
{
  if (a >b)
    a = b;
}
template<class A>
void SetMax(A &a, A const &b)
{
  if (a <b)
    a = b;
}
template<class T>
void Normalize(vector3d<T> &vec)
{
  T min, max;
  min = max = vec(0,0,0);
  for(int i = 0; i < vec.sizes[0]; ++i)
    for(int j = 0; j < vec.sizes[1];++j)
      for(int k = 0; k < vec.sizes[2];++k)
      {
	SetMin(min, vec(i,j,k));
	SetMax(max, vec(i,j,k));
      }
  for(int i = 0; i < vec.sizes[0]; ++i)
    for(int j = 0; j < vec.sizes[1];++j)
      for(int k = 0; k < vec.sizes[2];++k)
	vec(i,j,k) =  (max-min>0)?(vec(i,j,k)-min)/(max-min):0;
}
template<class T>
void Normalize(vector3d<T> &vec, T min, T max)
{
  for(int i = 0; i < vec.sizes[0]; ++i)
    for(int j = 0; j < vec.sizes[1];++j)
      for(int k = 0; k < vec.sizes[2];++k)
	vec(i,j,k) =  (max-min>0)?(vec(i,j,k)-min)/(max-min):0;
}


template<class R, class A, class B, class C>
  void Convolute3d(vector3d<R> &res, vector3d<A> const &a, vector3d<B> const &b, C mul, int part = 0, int total=1)
{
  typedef typename vector3d<R>::size_type Int;
  Int mi, mj, mk;
  mi = b.sizes[0]/2;
  mj = b.sizes[1]/2;
  mk = b.sizes[2]/2;
  Int beg, end;
  beg = a.sizes[0]*part/total;
  end = a.sizes[0]*(part+1)/total;
  for (Int i = beg; i < end; ++i)
  {
    for (Int j = 0; j < a.sizes[1]; ++j)
      for (Int k = 0; k <a.sizes[2]; ++k)
      {
	Int li,hi, lj,hj, lk,hk, I,J, K;
	li = i - mi;
	hi = li + b.sizes[0];
	lj = j - mj;
	hj = lj + b.sizes[1];
	lk = k - mk;
	hk = lk + b.sizes[2];
	SetMax(li, 0ul);
	SetMin(hi, (Int)a.sizes[0]);
	SetMax(lj, 0ul);
	SetMin(hj, (Int)a.sizes[1]);
	SetMax(lk, 0ul);
	SetMin(hk, (Int)a.sizes[2]);
	C sum = C();
	for (I = li; I < hi; ++I)
	  for (J = lj; J < hj; ++J)
	    for (K = lk; K < hk; ++K)
	      sum += C(a(I,J,K))*b(I - i + mi, J -j + mj, K - k +mk);
	res(i,j,k) = R(mul*sum);
      }
    if (!part)
      std::cout <<"\r" << 100.*(double)(i-beg)/(end-beg) << "%                 " << std::flush;
  }
    if (!part)
      std::cout <<"\r" << "100%                 " << std::endl;
}

inline double Gauss(double sigma, double x)
{
  return exp((-x*x)/(2*sigma*sigma))/(sigma*sqrt(2*atan(1)*4));
}
template<class T>
void GaussianConvMat(vector3d<T> &r, int size, double sigma, double xs=1, double ys=1, double zs=1)
{
  r.SetSize(size, size, size);
  double s = 1;
  int mi = size/2;
  for (int i = 0; i < size; ++i)
    for (int j = 0; j < size; ++j)
      for (int k = 0; k < size; ++k)
	r(i,j,k) = Gauss(s, (i - mi)*xs)*Gauss(s, (j - mi)*ys)*Gauss(s, (k-mi)*zs);
}


template<class T>
void CreateConv3x3x3(vector3d<T> &r)
{
  T c = 6;
  T a = -1;
  T b = 0;
  T f = 0;
/*   c = 0;  */
/*   a = b = f = 1/26.;  */
  r.SetSize(3,3,3);
  for (int i = 0; i < 3; ++i)
    for (int j = 0; j < 3; ++j)
      for (int k = 0; k < 3; ++k)
	r(i,j,k) = f;
  r(1,1,1) = c; //center

  r(1,1,0) = a; //
  r(1,1,2) = a;
  
  r(1,0,1) = a;
  r(1,2,1) = a;
  
  r(0,1,1) = a;
  r(2,1,1) = a;

  
  
  r(0,0,1) = b;
  r(2,2,1) = b;
  r(0,2,1) = b;
  r(2,0,1) = b;
  
  r(0,1,0) = b;
  r(2,1,2) = b;
  r(0,1,2) = b;
  r(2,1,0) = b;
  
  r(1,0,0) = b;
  r(1,2,2) = b;
  r(1,0,2) = b;
  r(1,2,0) = b;
//   double sum = 0;
//   for (int i = 0; i < 3; ++i)
//     for (int j = 0; j < 3; ++j)
//       for (int k = 0; k < 3; ++k)
// 	sum +=r(i,j,k);
//   for (int i = 0; i < 3; ++i)
//     for (int j = 0; j < 3; ++j)
//       for (int k = 0; k < 3; ++k)
// 	r(i,j,k)/=sum;
}		      
		       
	
    

#endif
