#include <iostream>
#include <string>
#include <sstream>
#include "mirorer.h"

template<class T>T Convert(const std::string &s)
{
  T res;
  std::istringstream is(s);
  is >> res;
  return res;
}

int main(int argc, char **argv)
{
  if (argc <6)
    return  1;
  std::string filename = "default";
  int N1, N2, N3;
  double dim = 37e-6;
  filename = argv[1];
  N1 = Convert<int>(argv[2]);
  N2 = Convert<int>(argv[3]);
  N3 = Convert<int>(argv[4]);
  dim = Convert<double>(argv[5]);
  std::istringstream is(filename);
  int sz;
  is >> sz;
  std::cout << "size is " << N1 <<"x" << N2 << "x" << N3 <<"; voxel size si " << dim<< std::endl;
  vector3d<unsigned char > vec;

  std::ostringstream os;
  os << sz <<".bonec.inr";

  vec.SetSize(N1, N2, N3, dim, dim, dim);
  vec.Read(filename, 0);
  vec.WriteInr(os.str());
  //  std::cout << "written " << (double)nzcount/sz1/sz2/sz3 << std::endl;
}
