#ifndef __string_util_h__
#define __string_util_h__

#include <string>
#include <sstream>


void Split(const std::string &what, std::string &l, std::string &r, const std::string &delimiter)
{
  std::string::size_type p;
  p = what.rfind(delimiter);
  if (p==std::string::npos)
  {
    r = "";
    l = what;
  }else
  {
    l = what.substr(0, p);
    r = what.substr(p+delimiter.length());
  }
}



void Trim(std::string &s, const std::string &trims = "\t\n ")
{
  size_t startpos = s.find_first_not_of(trims.c_str());
  size_t endpos = s.find_last_not_of(trims.c_str());
  if(( std::string::npos == startpos ) || (std::string::npos == endpos))
  {
    s = "";
  }
  else
    s = s.substr(startpos, endpos-startpos +1);
}

template <typename T, typename V>
T Convert(const V& str)
{
    T var;
    std::stringstream iss;
    iss << str;
    iss >> var;
    // deal with any error bits that may have been set on the stream
    return var;
}

template <typename T>
T Convert(const std::string& str)
{
    T var;
    std::istringstream iss;
    iss.str(str);
    iss >> var;
    // deal with any error bits that may have been set on the stream
    if (iss)
      return var;
    else
      return T();
}

#endif
