#ifndef __TIMER_H__
# define __TIMER_H__

# include "common.h"
# include <sys/times.h>

class simple_timer {

    struct tms t;

    double ticks_per_sec()
    {
        static double r = sysconf(_SC_CLK_TCK);
        return r;
    }
    
 public:
    simple_timer()
    {
        times(&t);
    }

    ~simple_timer()
    {
        struct tms e;
        times(&e);
        std::cout << "User time: "
                  << (e.tms_utime - t.tms_utime)/ticks_per_sec()
                  << " sec. System time: "
                  << (e.tms_stime - t.tms_stime)/ticks_per_sec()
                  << " sec." << std::endl;
    }
};

#endif 
