#include <iostream>
#include <initializer_list>
#include <vector>

template<class T>
struct Cycler{
  std::vector<T*> v;
  Cycler(  std::initializer_list<T*> a):v(a)
  {
    Begin();
  }
  void Begin()
  {
    for (int i = 0; i < v.size(); ++i)
      *v[i]=0;
  }

  template<class ... Types>
  Cycler(Types& ... args):Cycler({&args...}){
  }

  bool RCycle(int Max)
  {
    for (int i = 0; i < v.size(); ++i)
    {
      (*v[i])++;
      if ((*v[i]) < Max)
	return true;
      *v[i] = 0;
    }
    return false;
  }  
  bool Cycle(int Max)
  {
    for (int i = v.size(); i--;)
    {
      (*v[i])++;
      if ((*v[i]) < Max)
	return true;
      *v[i] = 0;
    }
    return false;
  }  

};


int main()
{
  int k,l, m, n;
  auto a = Cycler<int>{k,l, m, n};

  do{
    std::cout << k << " " << l <<" " <<  m << " " << n <<  std::endl;
  }while(a.Cycle(2));

}

