#include "mpi.h"
#include "elastgen.hpp"

#ifndef USE_EXPORT
// some explicit specializations
//double
template class ElastDiscretizator<double>;

template
SmallVector<double, 3>
FuncRhs(const SmallVector<double, 3> &p);


template
SmallVector<double, 3>
FuncSolution(const SmallVector<double, 3> &p);

template
SmallMatrix<double, 3, 3>
FuncNeuman(const SmallVector<double, 3> &p); // returns sigma



//float
#ifdef _FLOAT_EXPAND

template class ElastDiscretizator<float>;

template
SmallVector<float, 3>
FuncRhs(const SmallVector<float, 3> &p);


template
SmallVector<float, 3>
FuncSolution(const SmallVector<float, 3> &p);

template
SmallMatrix<float, 3, 3>
FuncNeuman(const SmallVector<float, 3> &p); // returns sigma

#endif



#else //export


#endif
