#include "elastmatrix.hpp"

#include "precon.h"



template class ElementwiseElastityMatrix<double, int>;

template class ElastMatrix<BDom<SmallVector<double, 3>, int> >;
template class ElastMatrixPBC<BDom<SmallVector<double, 3>, int> >;

template class MacroElementDescriptor<double>;





namespace{
  typedef SmallVector<double, 6> Drow_type;
  typedef BDom<Drow_type, int> Dmatrix_type;
  typedef BDom<double, int> DVector;

  typedef SmallVector<float, 6> Frow_type;
  typedef BDom<Frow_type, int> Fmatrix_type;
  typedef BDom<float, int> FVector;
  
  typedef SmallVector<double, 3> Dpoint_type;
  typedef BDom<Dpoint_type, int> Dbvector_type;
  typedef SmallVector<float, 3> Fpoint_type;
  typedef BDom<Fpoint_type, int> Fbvector_type;
}


template class JPrecon<Dbvector_type>;







#ifdef _FLOAT_EXPAND

template class ElementwiseElastityMatrix<float, int>;

template class ElastMatrix<BDom<SmallVector<float, 3>, int> >;
template class ElastMatrixPBC<BDom<SmallVector<float, 3>, int> >;

template class MacroElementDescriptor<float>;


template class JPrecon<Fbvector_type>;
template class JPrecon<Fbvector_type, Dbvector_type>;

template class SinglePrecon<Dbvector_type, JPrecon<Dbvector_type> >;

#endif


