#ifndef __elastsolver_h__
#define __elastsolver_h__

#include "vectors.h"

#include "elastmatrix.h"




template<class Double, class Int, class bVector_type = BDom<SmallVector<Double, 3>,Int > >
class ElastWorker
//:public ElastWorkerBase<Double, Int>
{
 public:

  Int StartLine, Lines;
  Int DoubleLines;
  Int StartDoubleLine;
  bool FirstFull;
  bool FirstFirst;
  bool LastFull;
  bool LastLast;
  Double merr;
  Double serr;

  typedef SmallVector<Double, 3> point_type;
  typedef bVector_type bvector_type;

private:
public:
  bvector_type rhs;
  bvector_type dissol;
  bvector_type x;
  MPI::Intracomm& comm;
  Int N1, N2, N3R;
  int rank,size;
  std::string algname;
  DiscretizationType distype;
  BoundaryConditions bc;
  
  ElastMatrix<bvector_type> *mat;
  ElastWorker(MPI::Intracomm &c);
 ~ElastWorker();
  void Sysgen();
  int Solve();
  void CheckSolution();

  void WriteSolution();

};

#endif
#ifdef INCLUSION
#include "elastsolver.hpp"
#endif
