#ifndef __fc_h__
#define __fc_h__
#include <string>

template<class T>
class OpCounter
{
  static size_t cnt_mul;
  static size_t cnt_div;
  static size_t cnt_add;
  static size_t cnt_cmp;
 public:
static  void Save()
    {
      ocnt_mul = cnt_mul;
      ocnt_div = cnt_div;
      ocnt_add = cnt_add;
      ocnt_cmp = cnt_cmp;
      cnt_mul = cnt_div = cnt_add = cnt_cmp = 0;
    }
  static size_t ocnt_mul;
  static size_t ocnt_div;
  static size_t ocnt_add;
  static size_t ocnt_cmp;
  T val;
 public:
  OpCounter(const T&a):val(a){}
  OpCounter():val(){}
  OpCounter(const OpCounter &a):val(a.val){}

/*   operator T ()const */
/*     { */
/*       cnt_cmp++; */
/*       return val; */
/*     } */
/*   operator T& () */
/*     { */
/*       cnt_cmp++; */
/*       return val; */
/*     } */
  T Get()const{return val;}
  operator T ()
  {
    return val;
  }
  operator T () const
  {
    return val;
  }
  OpCounter operator+()const
    {
      return *this;
    }
  OpCounter operator-()const
    {
      return -val;
    }
#define DECL_op_1(op, cntr)                                                    \
  friend OpCounter operator op (const OpCounter &a, const T& b)                \
    {        cntr++;                                                            \
      return OpCounter(T(a.Get() op b));                                           \
    }                                                                           \
  friend OpCounter operator op (const T& a, const OpCounter &b)                \
    {        cntr++;                                                            \
      return OpCounter(T(a op b.Get()));                                           \
    }                                                                           \
  friend OpCounter operator op (const OpCounter&a, const OpCounter &b)          \
    {                      cntr++;                                              \
      return OpCounter(T(a.Get() op b.Get()));                                        \
    }                                                                           
#define DECL_op_2(op, cntr)                                                    \
  friend bool  operator op (const OpCounter &a, const T& b)                    \
    {       cntr++;                                                             \
      return (a.Get() op b);                                                    \
    }                                                                           \
  friend bool operator op (const T& a, const OpCounter &b)                     \
    {        cntr++;                                                            \
      return (T(a op b.Get()));                                                    \
    }                                                                           \
  friend bool operator op (const OpCounter&a, const OpCounter &b)               \
    {               cntr++;                                                     \
      return (a.Get() op b.Get());                                                 \
    }
#define DECL_op_3(op, cntr)                                                    \
   OpCounter  operator op ( const T& b)                                             \
    {       cntr++;                                                             \
      return val op b;                                                          \
    }                                                                           \
  OpCounter operator op (const OpCounter &b)                                        \
    {               cntr++;                                                     \
      return val op b.Get();                                                       \
    }
  DECL_op_1(+, cnt_add)
    DECL_op_1(-, cnt_add)
    DECL_op_1(*, cnt_mul)
    DECL_op_1(/, cnt_div)
    DECL_op_2(>, cnt_cmp)
    DECL_op_2(>=, cnt_cmp)
    DECL_op_2(<, cnt_cmp)
    DECL_op_2(<=, cnt_cmp)
    DECL_op_2(==, cnt_cmp)
    //    DECL_op_2(!=, cnt_cmp)
    DECL_op_3(+=, cnt_add)
    DECL_op_3(-=, cnt_add)
    DECL_op_3(*=, cnt_mul)
    DECL_op_3(/=, cnt_div)
#undef DECL_op_1
#undef DECL_op_2
#undef DECL_op_3

};

#include<math.h>
template<class T>
OpCounter<T> fabs(OpCounter<T> const&a)
{
  return fabs(a.Get());
}

template<class Os, class T>
  Os& operator << (Os& out, const OpCounter<T>&t)
{
  out << t.Get();
  return out;
}
#include "mpi.h"
template<class > class Myf;
template<> class Myf<OpCounter<double> >
{
  public:
static MPI::Datatype Datatype()
{
  return  MPI::DOUBLE;
}
static std::string ToString()
   {
     return "D";
   }
};



#endif
