#include "mpi.h"
#include "functors.hpp"

#include "vectors.h"
#include "projection.hpp"

#include "visitors.h"
#ifndef USE_EXPORT
//namespace{
  typedef BDom<double, int> DVector;
  typedef BDom<float, int> FVector;
  typedef SmallVector<double, 3> Dpoint_type;
  typedef BDom<Dpoint_type, int> Dbvector_type;
  typedef SmallVector<float, 3> Fpoint_type;
  typedef BDom<Fpoint_type, int> Fbvector_type;
  typedef PDom<BDom<Fpoint_type, int> > PFbvector_type;
  typedef PDom<BDom<Dpoint_type, int> > PDbvector_type;
  typedef PDom<BDom<double, int> > PDVector;
  typedef PDom<BDom<float, int> > PFVector;
  
//}
template
void
VecOper<VecRec>(DVector&);

template
void
VecVecOper<VecMul>(DVector&, DVector&);
template
void
VecVecOper<VecMul>(DVector&, const DVector&);
template
void
VecVecOper<VecCpy>(DVector&, DVector&);
template
void
VecVecOper<VecCpy>(DVector&, const DVector&);

template
void
VecVecOper<VecSub>(DVector&, DVector&);
template
void
VecVecOper<VecAdd>(DVector&, DVector&);
template
void
VecVecOper<VecSub>(DVector&, const DVector&);


template
void
VecVecOper<VecUpdate>(DVector&, DVector&,  double);

template
void
VecVecOper<VecUpdate2>(DVector&, DVector&, double);


template
double
VecVecReduce<VecDot>(DVector&, DVector&);


// elastics stuf comes here

template
void
VecOper<VecRec>(Dbvector_type&);

template
void
VecVecOper<VecMul>(Dbvector_type&, Dbvector_type&);
template
void
VecVecOper<VecMul>(Dbvector_type&, const Dbvector_type&);

template
void
VecVecOper<VecCpy>(Dbvector_type&, Dbvector_type&);
template
void
VecVecOper<VecCpy>(Dbvector_type&, const Dbvector_type&);

template
void
VecVecOper<VecSub>(Dbvector_type&, Dbvector_type&);
template
void
VecVecOper<VecAdd>(Dbvector_type&, Dbvector_type&);
template
void
VecVecOper<VecSub>(Dbvector_type&, const Dbvector_type&);


template
void
VecVecOper<VecUpdate>(Dbvector_type&, Dbvector_type&,  double);
template
void
VecVecOper<VecUpdate>(Dbvector_type&, PDbvector_type&,  double);

template
void
VecVecOper<VecUpdate2>(Dbvector_type&, Dbvector_type&, double);


template
double
VecVecReduce<VecDot>(Dbvector_type&, Dbvector_type&);
template
double
VecVecReduce<VecDot>(PDbvector_type&, Dbvector_type&);
template
double
VecVecReduce<VecDot>(Dbvector_type&, PDbvector_type&);
template
double
VecVecReducePBC<VecDot>(PDbvector_type&, PDbvector_type&);
template
double
VecVecReducePBC<VecDot>(Dbvector_type&, PDbvector_type&);
template
double
VecVecReducePBC<VecDot>(PDbvector_type&, Dbvector_type&);
// template
// void
// VecVecOper<VecCpy>(Dbvector_type&, PDbvector_type&);

template
double
VecReduceNorm<CNorm>(Dbvector_type&);
template
double
VecReduceNorm<CNorm>(DVector&);


#ifdef _FLOAT_EXPAND
template
void
VecOper<VecRec>(FVector&);

template
void
VecVecOper<VecMul>(FVector&, FVector&);
template
void
VecVecOper<VecMul>(FVector&, const FVector&);
template
void
VecVecOper<VecCpy>(FVector&, FVector&);
template
void
VecVecOper<VecCpy>(FVector&, const FVector&);

template
void
VecVecOper<VecSub>(FVector&, FVector&);
template
void
VecVecOper<VecAdd>(FVector&, FVector&);
template
void
VecVecOper<VecSub>(FVector&, const FVector&);


template
void
VecVecOper<VecUpdate>(FVector&, FVector&,  float);

template
void
VecVecOper<VecUpdate2>(FVector&, FVector&, float);


template
float
VecVecReduce<VecDot>(FVector&, FVector&);

//elastic stuff comes here

template
void
VecOper<VecRec>(Fbvector_type&);

template
void
VecVecOper<VecMul>(Fbvector_type&, Fbvector_type&);
template
void
VecVecOper<VecMul>(Fbvector_type&, const Fbvector_type&);

template
void
VecVecOper<VecCpy>(Fbvector_type&, Fbvector_type&);
template
void
VecVecOper<VecCpy>(Fbvector_type&, const Fbvector_type&);


template
void
VecVecOper<VecSub>(Fbvector_type&, Fbvector_type&);
template
void
VecVecOper<VecAdd>(Fbvector_type&, Fbvector_type&);
template
void
VecVecOper<VecSub>(Fbvector_type&, const Fbvector_type&);



template
void
VecVecOper<VecUpdate>(Fbvector_type&, Fbvector_type&,  float);
template
void
VecVecOper<VecUpdate>(Fbvector_type&, PFbvector_type&,  float);

template
void
VecVecOper<VecUpdate2>(Fbvector_type&, Fbvector_type&, float);


template
float
VecVecReduce<VecDot>(Fbvector_type&, Fbvector_type&);
template
float
VecVecReduce<VecDot>(PFbvector_type&, Fbvector_type&);
template
float
VecVecReduce<VecDot>(Fbvector_type&, PFbvector_type&);
template
float
VecVecReduce<VecDot>(PFbvector_type&, PFbvector_type&);


template
float
VecReduceNorm<CNorm>(Fbvector_type&);
template
float
VecReduceNorm<CNorm>(FVector&);

template
void
VecVecOper<VecCpy>(Dbvector_type&, const Fbvector_type&);
template
void
VecVecOper<VecCpy>(Fbvector_type&, const Dbvector_type&);
template
void
VecVecOper<VecCpy>(Dbvector_type&,  Fbvector_type&);
template
void
VecVecOper<VecCpy>(Fbvector_type&,  Dbvector_type&);

// template
// double
// VecVecReducePBC<VecDot1, PFbvector_type, PFbvector_type>(PFbvector_type&, PFbvector_type&);
template
float
VecVecReducePBC<VecDot>(PFbvector_type&, PFbvector_type&);
template
float
VecVecReducePBC<VecDot>(Fbvector_type&, PFbvector_type&);
template
float
VecVecReducePBC<VecDot>(PFbvector_type&, Fbvector_type&);

#endif
#endif //export

