C     *********************************************************
C     NC-FEM for 3D Elasticity Problems
C     *********************************************************
      PARAMETER (NNMAX=4723056,MMMAX=14169168)
C     PARAMETER (NNMAX=4723056,MMMAX=14169168)
C     PARAMETER (NNMAX=83700,MMMAX=251100)
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON/GP/ T(3), A(3)
      common/GP_hi/ tx(3),ty(3),tz(3)
C
      COMMON/LOCALR/ ESM(6,6), DESM(6,6)
      COMMON/LOCALI_DD/ M1, M2, M3, MMDD
      COMMON /LOCALI/ N1, N2, N3, NN, NV(6)
      COMMON/GLOBR/ RLAG(NNMAX,5), RUAG(NNMAX,6), FF(MMMAX), XX(MMMAX)
      COMMON/GLOBI/ ILAG(NNMAX,5), IUAG(NNMAX,6)
      COMMON/WORK/ RN(MMMAX),SN(MMMAX),WN(MMMAX)
      COMMON/GSMME/csm1(108,21),csm2(108,21),csm_p(108,21),icsm(108,22)
C
      common /Step/ h1,h2,h3
C      COMMON /Step/ HX(116),HY(116),HZ(116)
C      COMMON /Step/ HX(31),HY(31),HZ(31)
      real*4 tt,tarray(2)
      common /eg_value/ enorm,iv
      common/Lame/EE_s,EE_p,anu_s,anu_p,alambda_s,alambda_p,amu_s,amu_p
      COMMON /CG_PCG_E/ EPS
C
C
C     Lame coefficients:
C
      EE_s=19.88
      anu_s=0.42
      alambda_s=anu_s*ee_s/(1.+anu_s)/(1.-2.*anu_s)
      amu_s=ee_s/2./(1.+anu_s)
C
      EE_p=31500.
      anu_p=0.2
      alambda_p=anu_p*ee_p/(1.+anu_p)/(1.-2.*anu_p)
      amu_p=ee_p/2./(1.+anu_p) 

C
C      WRITE(*,*) 'ENTER M1=M2=M3 = ? '
C      READ(*,*) M1
      M1 = 256
C      write(*,*) 'ENTER EPS=?'
C      read(*,*) EPS
      EPS=0.1
C
C      write(*,*) 'enter h1,h2,h3'
C      read(*,*) h1,h2,h3
      h1 = 1./M1
      h2 = h1
      h3 = h2
C
      M2=M1
      M3=M2
C
      N1=2*M1
      N2=2*M2
      N3=2*M3
C
      NN = (N1+1)*N2*N3 + N1*(N2+1)*N3 + N1*N2*(N3+1)
      MMDD = 3*NN
C
C     /Step/ - initialization
C      do i=1,n1
C       read(*,*) hx(i)
C      enddo
C      do i=1,n2
C       read(*,*) hy(i)
C      enddo
C      do i=1,n3
C       read(*,*) hz(i)
C      enddo

              
C      write(*,*) 'enter Vertical Load'
C      read(*,*) VL
      VL = 1.0
C
C      write(*,*) 'enter Horizontal Load'
C      read(*,*) HL
      
C      write(*,*) 'enter EE_p'
C      read(*,*) EE_p
C
       call gsm_me
C
C
C     R.H.S. 
C
      do i=1,mmdd
        ff(i)=0.
      enddo
C
C     VARIANT 1
C
C      do i=1,n1
C        do j=1,n2
C        call itop(i,j,n3)
C          ff(2*nn+nv(6))=-1.
C        enddo
C      enddo
C
      call itop(n1/2-1,n2/2-1,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2-1,n2/2,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2-1,n2/2+1,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2-1,n2/2+2,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
C
      call itop(n1/2,n2/2-1,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2,n2/2,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2,n2/2+1,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2,n2/2+2,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
C
      call itop(n1/2+1,n2/2-1,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2+1,n2/2,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2+1,n2/2+1,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2+1,n2/2+2,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
C
      call itop(n1/2+2,n2/2-1,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2+2,n2/2,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2+2,n2/2+1,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
      call itop(n1/2+2,n2/2+2,n3)
      ff(2*nn+nv(6))=-VL*(32./9.)*h1*h2
C
C

C     END OF VARIANTS
C
      do i=1,n1
        do j=1,n2
        k=1
        call itop(i,j,k)
        ff(nv(5))=0.
        ff(nn+nv(5))=0.
        ff(2*nn+nv(5))=0.
        enddo
      enddo
C
C
      call esmi
C
      call gsma

      call mic_0
C
      tt=dtime(tarray)
      CALL PCG_DD
C      write(*,*)'time',dtime(tarray)
C
C      call post_pr
C       
      stop
      end
C
C
C     *********************************************************
C     Macroelement sparse matrix vector multiplication:
C
      subroutine smesmvm(csm,ism,v,w)
C     *********************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      dimension csm(108,21), ism(108,22), v(108), w(108)
      do i=1,108
C       w(i)=0.
        do j=1,ism(i,22)
         w(i)=w(i)+csm(i,j)*v(ism(i,j))
        enddo
      enddo
      return
      end
C
C     *********************************************************
C     This routine computes the macroeelement stiffness matrix
C     for the rotated trilinear elasticity problem ===> GSM
C
      SUBROUTINE GSM_ME
C     *********************************************************      
      IMPLICIT REAL*8(A-H,O-Z)
      dimension a10(6,6),a20(6,6),a30(6,6),a12(6,6),a13(6,6)
      dimension a23(6,6),a11(6,6),a22(6,6),a33(6,6)
      dimension esm(18,18), tt(3,36),gsm2(108,108),gsm1(108,108)
      dimension ff(3,3,3)
      dimension itop(8,6), ibc(12)
      dimension gsm11(108,108), gsm12(108,108)
      dimension gsm_s(108,108), gsm_p(108,108)
C
      COMMON/GSMME/csm1(108,21),csm2(108,21),csm_p(108,21),icsm(108,22)
      COMMON/GP/ T(3), A(3)
      common/GP_hi/ tx(3),ty(3),tz(3)
      common/step/ h1,h2,h3
C      COMMON /Step/ HX(116),HY(116),HZ(116)
C      COMMON /Step/ HX(31),HY(31),HZ(31)
      common/Lame/EE_s,EE_p,anu_s,anu_p,alambda_s,alambda_p,amu_s,amu_p
C     
      data itop/1,2,3,4,17,18,19,20,
     >          17,18,19,20,33,34,35,36,
     >           5,6,10,11,21,22,26,27,
     >          10,11,15,16,26,27,31,32,
     >           7,8,12,13,23,24,28,29,
     >           8,9,13,14,24,25,29,30/
C      data ibc/29,30,31,32,65,66,67,68,101,102,103,104/
C
      data ibc/7,12,23,28,43,48,59,64,79,84,95,100/

C
C     Lame coefficients:
C
C      EE_s=10
C      EE_s=1.
C      anu_s=0.35
C      alambda_s=anu_s*ee_s/(1.+anu_s)/(1.-2.*anu_s)
C      amu_s=ee_s/2./(1.+anu_s)
C
C      EE_p=10000.
C      anu_p=0.2
C      alambda_p=anu_p*ee_p/(1.+anu_p)/(1.-2.*anu_p)
C      amu_p=ee_p/2./(1.+anu_p) 
C
C     Gaussian quadrature parameters:
C
      t(1)=-sqrt(0.6)
      t(2)=0.
      t(3)= sqrt(0.6)
      a(1)=5./9.
      a(2)=8./9.
      a(3)=5./9.
C
      tx(1)=h1*t(1)
      tx(2)=h1*t(2)
      tx(3)=h1*t(3)
C
      ty(1)=h2*t(1)
      ty(2)=h2*t(2)
      ty(3)=h2*t(3)
C
      tz(1)=h3*t(1)
      tz(2)=h3*t(2)
      tz(3)=h3*t(3)
C
C     Basic functions and their derivatives:
C
      do i=1,6
         do j=1,6
           a10(i,j)=0.
           a20(i,j)=0.
           a30(i,j)=0.
           a12(i,j)=0.
           a13(i,j)=0.
           a23(i,j)=0.
           a11(i,j)=0.
           a22(i,j)=0.
           a33(i,j)=0.
         enddo
      enddo
CC
CC     computation of A10
CC
C      DO II=1,6
C      DO JJ=1,6
C        do i=1,3
C          do j=1,3
C            do k=1,3
C            ff(i,j,k)=PX(II,t(i),t(j),t(k))*P0(JJ,t(i),t(j),t(k))
C            enddo
C          enddo
C        enddo 
C        a10(II,JJ)=GI(FF)
C      ENDDO
C      ENDDO
CC
CC     computation of A20
CC
C      DO II=1,6
C      DO JJ=1,6
C        do i=1,3
C          do j=1,3
C            do k=1,3
C            ff(i,j,k)=PY(II,t(i),t(j),t(k))*P0(JJ,t(i),t(j),t(k))
C            enddo
C          enddo
C        enddo
C        a20(II,JJ)=GI(FF)
C      ENDDO
C      ENDDO
CC
CC     computation of A30
CC
C      DO II=1,6
C      DO JJ=1,6
C        do i=1,3
C          do j=1,3
C            do k=1,3
C            ff(i,j,k)=PZ(II,t(i),t(j),t(k))*P0(JJ,t(i),t(j),t(k))
C            enddo
C          enddo
C        enddo
C        a30(II,JJ)=GI(FF)
C      ENDDO
C      ENDDO
CC
C     computation of A12
C
      DO II=1,6
      DO JJ=1,6
        do i=1,3
          do j=1,3
            do k=1,3
            ff(i,j,k)=PX(II,tx(i),tx(j),tx(k))*PY(JJ,ty(i),ty(j),ty(k))
            enddo
          enddo
        enddo
        a12(II,JJ)=GI(FF)
      ENDDO
      ENDDO
C
C     computation of A13
C
      DO II=1,6
      DO JJ=1,6
        do i=1,3
          do j=1,3
            do k=1,3
            ff(i,j,k)=PX(II,tx(i),tx(j),tx(k))*PZ(JJ,tz(i),tz(j),tz(k))
            enddo
          enddo
        enddo
        a13(II,JJ)=GI(FF)
      ENDDO
      ENDDO
C
C     computation of A23
C
      DO II=1,6
      DO JJ=1,6
        do i=1,3
          do j=1,3
            do k=1,3
            ff(i,j,k)=PY(II,ty(i),ty(j),ty(k))*PZ(JJ,tz(i),tz(j),tz(k))
            enddo
          enddo
        enddo
        a23(II,JJ)=GI(FF)
      ENDDO
      ENDDO
C 
C     computation of A11
C
      DO II=1,6
      DO JJ=II,6
        do i=1,3
          do j=1,3
            do k=1,3
            ff(i,j,k)=PX(II,tx(i),tx(j),tx(k))*PX(JJ,tx(i),tx(j),tx(k))
            enddo
          enddo
        enddo
        a11(II,JJ)=GI(FF)
      ENDDO
      ENDDO
C
C     computation of A22
C
      DO II=1,6
      DO JJ=II,6
        do i=1,3
          do j=1,3
            do k=1,3
            ff(i,j,k)=PY(II,ty(i),ty(j),ty(k))*PY(JJ,ty(i),ty(j),ty(k))
            enddo
          enddo
        enddo
        a22(II,JJ)=GI(FF)
      ENDDO
      ENDDO
C
C     computation of A33
C
      DO II=1,6
      DO JJ=II,6
        do i=1,3
          do j=1,3
            do k=1,3
            ff(i,j,k)=PZ(II,tz(i),tz(j),tz(k))*PZ(JJ,tz(i),tz(j),tz(k))
            enddo
          enddo
        enddo
        a33(II,JJ)=GI(FF)
      ENDDO
      ENDDO
C  
C     symmetric part
C
      do i=1,6
        do j=i,6
        a11(j,i)=a11(i,j)
        a22(j,i)=a22(i,j)
        a33(j,i)=a33(i,j)
        enddo
      enddo
C
      do i=1,108
        do j=1,108
        gsm1(i,j)=0.
        gsm11(i,j)=0.
        gsm12(i,j)=0.
        gsm2(i,j)=0.
        enddo
      enddo
C
C     assembling of the non-projcted strain part of the ESM1 ==> gsm11
C
      do i=1,18
      do j=1,18
        esm(i,j)=0.
      enddo
      enddo
C
      do i=1,6
      do j=1,6
        esm(i,j) = a11(i,j)+a22(i,j)+a33(i,j)
        esm(i+6,j+6) = a22(i,j)+a11(i,j)+a33(i,j)
        esm(i+12,j+12) = a11(i,j)+a22(i,j)+a33(i,j)
      enddo
      enddo
C
      do ie=1,8
        do i=1,6
        ii=itop(ie,i)
          do j=1,6
          jj=itop(ie,j)
          gsm11(ii,jj)=gsm11(ii,jj)+esm(i,j) 
          gsm11(36+ii,36+jj)=gsm11(36+ii,36+jj)+esm(6+i,6+j)
          gsm11(72+ii,72+jj)=gsm11(72+ii,72+jj)+esm(12+i,12+j)
          enddo
        enddo
      enddo
C
C     assembling of the projected strain part of the ESM1 ==> gsm12
C
      do i=1,3
        do j=1,36
        tt(i,j)=0.
        enddo
      enddo
C
      tt(1,1)=-4.*h2*h3 
      tt(1,2)=-4.*h2*h3
      tt(1,3)=-4.*h2*h3
      tt(1,4)=-4.*h2*h3
      tt(1,33)=4.*h2*h3
      tt(1,34)=4.*h2*h3
      tt(1,35)=4.*h2*h3
      tt(1,36)=4.*h2*h3
C
      tt(2,5)=-4.*h1*h3
      tt(2,6)=-4.*h1*h3
      tt(2,21)=-4.*h1*h3
      tt(2,22)=-4.*h1*h3
      tt(2,15)= 4.*h1*h3
      tt(2,16)= 4.*h1*h3
      tt(2,31)= 4.*h1*h3
      tt(2,32)= 4.*h1*h3
C
      tt(3,7)=-4.*h1*h2
      tt(3,12)=-4.*h1*h2
      tt(3,23)=-4.*h1*h2
      tt(3,28)=-4.*h1*h2
      tt(3,9)= 4.*h1*h2
      tt(3,14)= 4.*h1*h2
      tt(3,25)= 4.*h1*h2
      tt(3,30)= 4.*h1*h2
C
C     tt:=16*tt
C     |E|=64
C
      do i=1,36
        do j=1,36
        gsm12(i,j)=tt(2,i)*tt(2,j)+tt(3,i)*tt(3,j)
        gsm12(i,j+36)=-tt(2,i)*tt(1,j)
        gsm12(i,j+72)=-tt(3,i)*tt(1,j)
        gsm12(i+36,j)=-tt(1,i)*tt(2,j)
        gsm12(i+36,j+36)=tt(1,i)*tt(1,j)+tt(3,i)*tt(3,j)
        gsm12(i+36,j+72)=-tt(3,i)*tt(2,j)
        gsm12(i+72,j)=-tt(1,i)*tt(3,j)
        gsm12(i+72,j+36)=-tt(2,i)*tt(3,j)
        gsm12(i+72,j+72)=tt(1,i)*tt(1,j)+tt(2,i)*tt(2,j)
        enddo
      enddo
      do i=1,108
         do j=1,108
         gsm12(i,j)=(-1./8)*(gsm12(i,j)/(2.*8.*h1*h2*h3))
C         gsm12(i,j)=-gsm12(i,j)/8.
C        gsm12(i,j)=gsm12(i,j)*3/8.
         enddo
      enddo

      do i=1,108
        do j=1,108
        gsm1(i,j)=gsm11(i,j)+gsm12(i,j)
        enddo
      enddo
CC
C
C     assembling of the divergence part of the ESM ==> gsm2
C
CC
      do i=1,18
      do j=1,18
        esm(i,j)=0.
      enddo
      enddo
C
      do i=1,6
      do j=1,6
        esm(i,j) = a11(i,j)
        esm(i,j+6) = a12(i,j)
        esm(i,j+12) = a13(i,j)
        esm(i+6,j) = a12(j,i)
        esm(i+6,j+6) = a22(i,j)
        esm(i+6,j+12) = a23(i,j)
        esm(i+12,j) = a13(j,i)
        esm(i+12,j+6) = a23(j,i)
        esm(i+12,j+12) = a33(i,j)
      enddo
      enddo
C
      do ie=1,8
        do i=1,6
        ii=itop(ie,i)
          do j=1,6
          jj=itop(ie,j)
          gsm2(ii,jj)=gsm2(ii,jj)+esm(i,j)
          gsm2(36+ii,36+jj)=gsm2(36+ii,36+jj)+esm(6+i,6+j)
          gsm2(72+ii,72+jj)=gsm2(72+ii,72+jj)+esm(12+i,12+j)
C
          gsm2(ii,36+jj)=gsm2(ii,36+jj)+esm(i,6+j)
          gsm2(ii,72+jj)=gsm2(ii,72+jj)+esm(i,12+j)
C
          gsm2(36+ii,72+jj)=gsm2(36+ii,72+jj)+esm(6+i,12+j)
          gsm2(36+ii,jj)=gsm2(36+ii,jj)+esm(6+i,j)
C
          gsm2(72+ii,jj)=gsm2(72+ii,jj)+esm(12+i,j)
          gsm2(72+ii,36+jj)=gsm2(72+ii,36+jj)+esm(12+i,6+j)
C
          enddo
        enddo
      enddo
CC
C
C     assembling of the matrix GSM=2*amu*GSM1+alambda*GSM2
C
C     Soil
C     *****************     
C      write(*,*) 'amu=',amu,'   alambda=',alambda
      do i=1,6
        do j=1,6
C           write(*,*) i, j, a11(i,j)
        enddo
      enddo
      do i=1,108
        do j=1,108
           z = 2*gsm1(i,j) + gsm2(i,j)
        write(*,*) i, j, z
        gsm_s(i,j) = 2.*amu_s*gsm1(i,j) + alambda_s*gsm2(i,j)
        enddo
      enddo
C
C     Pile
C     **********
      do i=1,108
        do j=1,108
        gsm_p(i,j) = 2.*amu_p*gsm1(i,j) + alambda_p*gsm2(i,j)
        enddo
      enddo
C
     
C     Dirichlet b.c. on the bottom face:
C
      do i=1,108
        do j=1,108
         gsm2(i,j)=gsm_s(i,j)
        enddo
      enddo
C
      do i=1,12
        ii=ibc(i)
        do j=1,108
          gsm2(ii,j)=0.
          gsm2(j,ii)=0.
        enddo
        gsm2(ii,ii)=gsm_s(ii,ii)
      enddo
C
C     Macroelement matrices storage in a sparse compressed format.
C
      do i=1,108
        pr=0.
        ipr=0.
        do j=1,108
          if(gsm_s(i,j)**2.gt.1.d-8*gsm_s(i,i)) then
          ipr=ipr+1
          icsm(i,ipr)=j
          csm1(i,ipr)=gsm_s(i,j)
          csm_p(i,ipr)=gsm_p(i,j)
          csm2(i,ipr)=gsm2(i,j)
          endif
        enddo
        icsm(i,22)=ipr
      enddo
C 
CCCCCCCCCCCCCCCCCCCCC
C     do i=1,108
C     imaxx=0
C     if(icsm(i,21).gt.imaxx) then
C     imaxx=icsm(i,21)
C     iraw=i
C     endif
C     enddo
C     write(*,*) 'iraw =', iraw, imaxx
CCCCCCCCCCCCCCCCCCCCC
C     stop
CCCCCCCCCCCCCCCCCCCCC

      return 
      end 



      FUNCTION P0(I,X,Y,Z)
      IMPLICIT REAL*8(A-H,O-Z)
      GOTO(1,2,3,4,5,6) i
   1  P0=(1.-3.*X+2.*X*X-Y*Y-Z*Z)/6.
      RETURN
   2  P0=(1.+3.*X+2.*X*X-Y*Y-Z*Z)/6.
      RETURN
   3  P0=(1.-3.*Y+2.*Y*Y-Z*Z-X*X)/6.
      RETURN
   4  P0=(1.+3.*Y+2.*Y*Y-Z*Z-X*X)/6.
      RETURN
   5  P0=(1.-3.*Z+2.*Z*Z-X*X-Y*Y)/6.
      RETURN
   6  P0=(1.+3.*Z+2.*Z*Z-X*X-Y*Y)/6.
      RETURN
      END

      FUNCTION PX(I,X,Y,Z)
      IMPLICIT REAL*8(A-H,O-Z)
      common /step/ h1,h2,h3 
      GOTO(1,2,3,4,5,6) i
   1  PX=-1./(2.*h1)+(2.*X)/(3.*h1*h1)
      RETURN
   2  PX= 1./(2.*h1)+(2.*X)/(3.*h1*h1)
      RETURN
   3  PX=-X/(3.*h1*h1)
      RETURN
   4  PX=-X/(3.*h1*h1)
      RETURN
   5  PX=-X/(3.*h1*h1)
      RETURN
   6  PX=-X/(3.*h1*h1)
      RETURN
      END

      FUNCTION PY(I,X,Y,Z)
      IMPLICIT REAL*8(A-H,O-Z)
      common /step/ h1,h2,h3 
      GOTO(1,2,3,4,5,6) i
   1  PY=-Y/(3.*h2*h2)
      RETURN
   2  PY=-Y/(3.*h2*h2)
      RETURN
   3  PY=-1./(2.*h2)+(2.*Y)/(3.*h2*h2)
      RETURN
   4  PY= 1./(2.*h2)+(2.*Y)/(3.*h2*h2)
      RETURN
   5  PY=-Y/(3.*h2*h2)
      RETURN
   6  PY=-Y/(3.*h2*h2)

      RETURN
      END

      FUNCTION PZ(I,X,Y,Z)
      IMPLICIT REAL*8(A-H,O-Z)
      common /step/ h1,h2,h3 
      GOTO(1,2,3,4,5,6) i
   1  PZ=-Z/(3.*h3*h3)
      RETURN
   2  PZ=-Z/(3.*h3*h3)
      RETURN
   3  PZ=-Z/(3.*h3*h3)
      RETURN
   4  PZ=-Z/(3.*h3*h3)
      RETURN
   5  PZ=-1./(2.*h3)+(2.*Z)/(3.*h3*h3)
      RETURN
   6  PZ=1./(2.*h3)+(2.*Z)/(3.*h3*h3)

      RETURN
      END


      FUNCTION GI(FF)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION FF(3,3,3)
      COMMON/GP/ T(3), A(3)
      common /step/ h1,h2,h3 
C      COMMON /Step/ HX(116),HY(116),HZ(116)
C      COMMON /Step/ HX(31),HY(31),HZ(31)
C
C
      GI=0.
      DO I=1,3
        DO J=1,3
          DO K=1,3
          GI=GI + FF(I,J,K)*A(I)*A(J)*A(K)
          ENDDO
        ENDDO
      ENDDO
      gi=h1*h2*h3*GI
      RETURN
      END

C     *********************************************************
C     Macroelement by macroelement stiffness matrix vaector
C     multiplication
C     *********************************************************
      SUBROUTINE DDSMVM(V,W)
C     *********************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (NNMAX=4723056,MMMAX=14169168)
C     PARAMETER (NNMAX=83700,MMMAX=251100)
      COMMON /LOCALI/ N1, N2, N3, NN, NV(6)
      COMMON/LOCALI_DD/ M1, M2, M3, MMDD
      COMMON/GSMME/csm1(108,21),csm2(108,21),csm_p(108,21),icsm(108,22)
      DIMENSION V(1), W(1)
C
      dimension vl(108), wl(108)
      dimension imesm(8,6), mev(36)
      data imesm/1,2,3,4,17,18,19,20,
     >          17,18,19,20,33,34,35,36,
     >           5,6,10,11,21,22,26,27,
     >          10,11,15,16,26,27,31,32,
     >           7,8,12,13,23,24,28,29,
     >           8,9,13,14,24,25,29,30/

C
      do i=1,mmdd
        w(i)=0.
      enddo
C
      do ii=1,m1
        do jj=1,m2
          do kk=1,m3
C
          do i=1,36
           mev(i)=0
          enddo
C
          il=2*(ii-1)+1
          jl=2*(jj-1)+1
          kl=2*(kk-1)+1
C =====>  1
            call itop(il,jl,kl)
C           write(*,*) (nv(i),i=1,6)
            do i=1,6
              mev(imesm(1,i))=nv(i)
            enddo
C =====>  2
          call itop(il,jl,kl+1)
C           write(*,*) (nv(i),i=1,6)
            do i=1,6
              mev(imesm(2,i))=nv(i)
            enddo
C =====>  3
          call itop(il,jl+1,kl)
C           write(*,*) (nv(i),i=1,6)
            do i=1,6
              mev(imesm(3,i))=nv(i)
            enddo
C =====>  4
          call itop(il,jl+1,kl+1)
C           write(*,*) (nv(i),i=1,6)
            do i=1,6
              mev(imesm(4,i))=nv(i)
            enddo
C =====>  5
          call itop(il+1,jl,kl)
C           write(*,*) (nv(i),i=1,6)
            do i=1,6
              mev(imesm(5,i))=nv(i)
            enddo
C =====>  6
          call itop(il+1,jl,kl+1)
C           write(*,*) (nv(i),i=1,6)
            do i=1,6
              mev(imesm(6,i))=nv(i)
            enddo
C =====>  7
          call itop(il+1,jl+1,kl)
C           write(*,*) (nv(i),i=1,6)
            do i=1,6
              mev(imesm(7,i))=nv(i)
            enddo
C =====>  8
          call itop(il+1,jl+1,kl+1)
C           write(*,*) (nv(i),i=1,6)
            do i=1,6
              mev(imesm(8,i))=nv(i)
            enddo
C
            do i=1,36
              vl(i)=v(mev(i))
              wl(i)=w(mev(i))
              vl(i+36)=v(mev(i)+nn)
              wl(i+36)=w(mev(i)+nn)
              vl(i+72)=v(mev(i)+nn+nn)
              wl(i+72)=w(mev(i)+nn+nn)
            enddo       

C
C
C           Pile
C
           if((il.eq.m1-1).and.(jl.eq.m2-1).and.(kl.gt.m3+1)) then 
C             write(*,*)'Pile:il,jl,kl=',il,jl,kl
            call smesmvm(csm_p,icsm,vl,wl)
 
            goto 11
           endif
C
C
           if((il.eq.m1-1).and.(jl.eq.m2+1).and.(kl.gt.m3+1)) then 
C             write(*,*)'Pile:il,jl,kl=',il,jl,kl
            call smesmvm(csm_p,icsm,vl,wl)
 
            goto 11
           endif
C
C
           if((il.eq.m1+1).and.(jl.eq.m2-1).and.(kl.gt.m3+1)) then 
C             write(*,*)'Pile:il,jl,kl=',il,jl,kl
            call smesmvm(csm_p,icsm,vl,wl)
 
            goto 11
           endif
C
C
           if((il.eq.m1+1).and.(jl.eq.m2+1).and.(kl.gt.m3+1)) then 
C             write(*,*)'Pile:il,jl,kl=',il,jl,kl
            call smesmvm(csm_p,icsm,vl,wl)
 
            goto 11
           endif
C
C         Soil
C
            if(kk.ne.1) then
C             write(*,*)'Soil:il,jl,kl=',il,jl,kl
            call smesmvm(csm1,icsm,vl,wl) 
            goto 11
            endif
C
C           Dirchlet b.c. macroelement stiffness matrix vector 
C           multiplication:
C
            call smesmvm(csm2,icsm,vl,wl)
C             write(*,*)'DBC:il,jl,kl=',il,jl,kl
C
  11        continue
C
            do i=1,36
              w(mev(i))=wl(i)
              w(mev(i)+nn)=wl(i+36)
              w(mev(i)+nn+nn)=wl(i+72)
            enddo
C
          enddo
        enddo
      enddo
C
      return
      end
C     ***********************************************************
C
C     This subroutine locates the global numbering of the nodes
C     corresponding to the element: e(i,j,k) ===> NV(6)
C
C
      subroutine itop(i,j,k)
C     ***********************************************************
C
      COMMON /LOCALI/ N1, N2, N3, NN, NV(6)
      nv(1) = (i-1)*(3*n2*n3 + n2 + n3) + (j-1)*n3 + k
      nv(2) = i*(3*n2*n3 + n2 + n3) + (j-1)*n3 + k
C
      nv(3) = (i-1)*(3*n2*n3 + n2 + n3) + n2*n3 + (j-1)*(2*n3+1) + k
      nv(4) = (i-1)*(3*n2*n3 + n2 + n3) + n2*n3 + j*(2*n3+1) + k
C
      nv(5) = (i-1)*(3*n2*n3 + n2 + n3)+n2*n3+(j-1)*(2*n3+1)+n3+k
      nv(6) = nv(5) + 1
C
      return
      end
C
C     ***********************************************************
C     h1,h2,h3
C     This subroutine computes the current element stiffness
C     matrix: ===> ESM(6,6)
C
      subroutine esmi
C     ***********************************************************
C     ***********************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /LOCALR/ ESM(6,6), DESM(6,6) 
      COMMON/LOCALI/ N1, N2, N3, NN, NV(6)
C      COMMON /Step/ HX(31),HY(31),HZ(31)
      common /step/ h1,h2,h3 
      h=2./(27.*h1*h2*h3)
      h1=h1**2
      h2=h2**2
      h3=h3**2
C     *********glaven diagonal********
      esm(1,1)=h*(43.*h2*h3+4.*h1*h3+4.*h1*h2)
      esm(2,2)=esm(1,1)
      esm(3,3)=h*(4.*h2*h3+43.*h1*h3+4.*h1*h2)
      esm(4,4)=esm(3,3)
      esm(5,5)=h*(4.*h2*h3+4.*h1*h3+43.*h1*h2)
      esm(6,6)=esm(5,5)
C     ********************************
      esm(1,2)=h*(-11.*h2*h3+4.*h1*h3+4.*h1*h2)
      if (esm(1,2).gt.0) then
      esm(1,1)=esm(1,1)+esm(1,2)
      esm(2,2)=esm(1,1)
      esm(1,2)=0
      endif
      esm(2,1)=esm(1,2)
      esm(3,4)=h*(4.*h2*h3-11.*h1*h3+4.*h1*h2)
      if (esm(3,4).gt.0) then
      esm(3,3)=esm(3,3)+esm(3,4)
      esm(4,4)=esm(3,3)
      esm(3,4)=0
      endif
      esm(4,3)=esm(3,4)
      esm(5,6)=h*(4.*h2*h3+4.*h1*h3-11.*h1*h2)
      if (esm(5,6).gt.0) then
      esm(5,5)=esm(5,5)+esm(5,6)
      esm(6,6)=esm(5,5)
      esm(5,6)=0
      endif
      esm(6,5)=esm(5,6)
C
      esm(3,1)=h*(-8.*h2*h3-8.*h1*h3+4.*h1*h2)
      if (esm(3,1).gt.0) then
      esm(3,3)=esm(3,3)+2*esm(3,1)
      esm(4,4)=esm(4,4)+2*esm(3,1)
      esm(1,1)=esm(1,1)+2*esm(3,1)
      esm(2,2)=esm(2,2)+2*esm(3,1)
      esm(3,1)=0
      endif
      esm(3,2)=esm(3,1)
      esm(4,1)=esm(3,1)
      esm(4,2)=esm(3,1)
      esm(1,3)=esm(3,1)
      esm(1,4)=esm(3,1)
      esm(2,3)=esm(3,1)
      esm(2,4)=esm(3,1)
C
      esm(5,1)=h*(-8.*h2*h3+4.*h1*h3-8.*h1*h2)
      if (esm(5,1).gt.0) then
      esm(5,5)=esm(5,5)+2*esm(5,1)
      esm(6,6)=esm(6,6)+2*esm(5,1)
      esm(1,1)=esm(1,1)+2*esm(5,1)
      esm(2,2)=esm(2,2)+2*esm(5,1)
      esm(5,1)=0
      endif
      esm(5,2)=esm(5,1)
      esm(6,1)=esm(5,1)
      esm(6,2)=esm(5,1)
      esm(1,5)=esm(5,1)
      esm(1,6)=esm(5,1)
      esm(2,5)=esm(5,1)
      esm(2,6)=esm(5,1)
C
      esm(5,3)=h*(4.*h2*h3-8.*h1*h3-8.*h1*h2)
      if (esm(5,3).gt.0) then
      esm(5,5)=esm(5,5)+2*esm(5,3)
      esm(6,6)=esm(6,6)+2*esm(5,3)
      esm(3,3)=esm(3,3)+2*esm(5,3)
      esm(4,4)=esm(4,4)+2*esm(5,3)
      esm(5,3)=0
      endif
      esm(5,4)=esm(5,3)
      esm(6,3)=esm(5,3)
      esm(6,4)=esm(5,3)
      esm(3,5)=esm(5,3)
      esm(3,6)=esm(5,3)
      esm(4,5)=esm(5,3)
      esm(4,6)=esm(5,3)
C
      return
      end


C     ***********************************************************
C     Dirichlet boundary conditions setting on the element
C     stiffness matrix level===> DESM(6,6) 
C
      SUBROUTINE D_BC(I,J,K)
C     ***********************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /LOCALR/ ESM(6,6), DESM(6,6)
      COMMON /LOCALI/ N1, N2, N3, NN, NV(6)
C
      if(k.eq.1) then 
       do ii=1,6
         do jj=1,6
         desm(ii,jj)=esm(ii,jj)
         enddo
       enddo
       do ii=1,6
         desm(5,ii)=0.
         desm(ii,5)=0.
C
C     Dirichlet boundary conditions setting on the element
C     stiffness matrix level desm(ii,5)=0.
       enddo
       desm(5,5)=esm(5,5)
C
      endif
C
      return
      end
C
C     ***********************************************************
C     Global stiffness matrix assembling in a compressed
C     form.
C
      SUBROUTINE GSMA
C     ***********************************************************
      PARAMETER (NNMAX=4723056,MMMAX=14169168)
C     PARAMETER (NNMAX=83700,MMMAX=251100)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /LOCALR/ ESM(6,6), DESM(6,6)
      COMMON/LOCALI_DD/ M1, M2, M3, MMDD
      COMMON /LOCALI/ N1, N2, N3, NN, NV(6)
      COMMON /GLOBR/ RLAG(NNMAX,5), RUAG(NNMAX,6), FF(MMMAX), XX(MMMAX)
      COMMON /GLOBI/ ILAG(NNMAX,5), IUAG(NNMAX,6)
      common /eg_value/ enorm,iv
      common /Lame/ EE_s,EE_p,anu_s,anu_p,alambda_s,alambda_p,amu_s,amu_p
C
C      write(*,*)'ee=',EE_s,'  ',EE_p
      EE=EE_p/EE_s
C      write(*,*)'EE=',EE
C
      do i=1,nn
       do j=1,6
        ruag(i,j)=0.
        iuag(i,j)=0
       enddo
      enddo
C
C     
      do i=1,nn
       do j=1,5
        rlag(i,j)=0.
        ilag(i,j)=0
       enddo
      enddo
C
      do i=1,n1
       do j=1,n2
        do k=1,n3
C
C     VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C
C     VARIANT 4 MODIFICATION
C
C     if((i.eq.n1/2+1).and.(j.eq.n2/2+1).and.(k.gt.(n3+1)/4)) then
C     do ii=1,6
C       do jj=1,6
C         desm(ii,jj)=desm(ii,jj)*1000.
C       enddo
C     enddo
C     endif 
C
C     VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C
C         call eg_sol
C
C         call esmi(i,j,k) 
C
         call itop(i,j,k)
C
         call d_bc(i,j,k)
C
C
C     VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C
C     VARIANT 4 MODIFICATION
C
      if((i.eq.n1/2-1).and.(j.eq.n2/2-1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2-1).and.(j.eq.n2/2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2-1).and.(j.eq.n2/2+1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2-1).and.(j.eq.n2/2+2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
C
      if((i.eq.n1/2).and.(j.eq.n2/2-1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2).and.(j.eq.n2/2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2).and.(j.eq.n2/2+1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2).and.(j.eq.n2/2+2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
C
      if((i.eq.n1/2+1).and.(j.eq.n2/2-1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+1).and.(j.eq.n2/2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+1).and.(j.eq.n2/2+1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+1).and.(j.eq.n2/2+2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
C
      if((i.eq.n1/2+2).and.(j.eq.n2/2-1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+2).and.(j.eq.n2/2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+2).and.(j.eq.n2/2+1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+2).and.(j.eq.n2/2+2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)*EE
        enddo
       enddo
      endif
C
C     VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C
C
C        Upper Triangle Part Inicialization
C
         ruag(nv(1),1)=ruag(nv(1),1)+desm(1,1)
         iuag(nv(1),1)=nv(1)
C  
         ruag(nv(1),2)=ruag(nv(1),2)+desm(1,3)
         iuag(nv(1),2)=nv(3)
C
         ruag(nv(1),3)=ruag(nv(1),3)+desm(1,5)
         iuag(nv(1),3)=nv(5)
C
         ruag(nv(1),4)=ruag(nv(1),4)+desm(1,6)
         iuag(nv(1),4)=nv(6)
C
         ruag(nv(1),5)=ruag(nv(1),5)+desm(1,4)
         iuag(nv(1),5)=nv(4)
C
         ruag(nv(1),6)=ruag(nv(1),6)+desm(1,2)
         iuag(nv(1),6)=nv(2)
C
         ruag(nv(2),1)=ruag(nv(2),1)+desm(2,2)
         iuag(nv(2),1)=nv(2)
C
         ruag(nv(3),1)=ruag(nv(3),1)+desm(3,3)
         iuag(nv(3),1)=nv(3)
C
         ruag(nv(3),2)=ruag(nv(3),2)+desm(3,5)
         iuag(nv(3),2)=nv(5)
C
         ruag(nv(3),3)=ruag(nv(3),3)+desm(3,6)
         iuag(nv(3),3)=nv(6)
C
         ruag(nv(3),4)=ruag(nv(3),4)+desm(3,4)
         iuag(nv(3),4)=nv(4)
C
         ruag(nv(3),6)=ruag(nv(3),6)+desm(3,2)
         iuag(nv(3),6)=nv(2)
C
         ruag(nv(4),1)=ruag(nv(4),1)+desm(4,4)
         iuag(nv(4),1)=nv(4)
C
         ruag(nv(4),5)=ruag(nv(4),5)+desm(4,2)
         iuag(nv(4),5)=nv(2)
C
         ruag(nv(5),1)=ruag(nv(5),1)+desm(5,5)
         iuag(nv(5),1)=nv(5)
C
         ruag(nv(5),2)=ruag(nv(5),2)+desm(5,6)
         iuag(nv(5),2)=nv(6)
C
         ruag(nv(5),4)=ruag(nv(5),4)+desm(5,4)
         iuag(nv(5),4)=nv(4)
C
         ruag(nv(5),6)=ruag(nv(5),6)+desm(5,2)
         iuag(nv(5),6)=nv(2)
C
         ruag(nv(6),1)=ruag(nv(6),1)+desm(6,6)
         iuag(nv(6),1)=nv(6)
C
         ruag(nv(6),3)=ruag(nv(6),3)+desm(6,4)
         iuag(nv(6),3)=nv(4)
C
         ruag(nv(6),5)=ruag(nv(6),5)+desm(6,2)
         iuag(nv(6),5)=nv(2)
C
C        Lower Triangle Part Inicialization
C
         rlag(nv(2),1)=rlag(nv(2),1)+desm(2,1)
         ilag(nv(2),1)=nv(1)
C
         rlag(nv(2),2)=rlag(nv(2),2)+desm(2,3)
         ilag(nv(2),2)=nv(3)
C
         rlag(nv(2),3)=rlag(nv(2),3)+desm(2,5)
         ilag(nv(2),3)=nv(5)
C
         rlag(nv(2),4)=rlag(nv(2),4)+desm(2,6)
         ilag(nv(2),4)=nv(6)
C
         rlag(nv(2),5)=rlag(nv(2),5)+desm(2,4)
         ilag(nv(2),5)=nv(4)
C
         rlag(nv(3),2)=rlag(nv(3),2)+desm(3,1)
         ilag(nv(3),2)=nv(1)
C         
         rlag(nv(4),1)=rlag(nv(4),1)+desm(4,1)
         ilag(nv(4),1)=nv(1)
C         
         rlag(nv(4),3)=rlag(nv(4),3)+desm(4,3)
         ilag(nv(4),3)=nv(3)
C         
         rlag(nv(4),4)=rlag(nv(4),4)+desm(4,5)
         ilag(nv(4),4)=nv(5)
C         
         rlag(nv(4),5)=rlag(nv(4),5)+desm(4,6)
         ilag(nv(4),5)=nv(6)
C
         rlag(nv(5),2)=rlag(nv(5),2)+desm(5,1)
         ilag(nv(5),2)=nv(1)
C
         rlag(nv(5),4)=rlag(nv(5),4)+desm(5,3)
         ilag(nv(5),4)=nv(3)
C
         rlag(nv(6),1)=rlag(nv(6),1)+desm(6,1)
         ilag(nv(6),1)=nv(1)
C
         rlag(nv(6),3)=rlag(nv(6),3)+desm(6,3)
         ilag(nv(6),3)=nv(3)
C
         rlag(nv(6),5)=rlag(nv(6),5)+desm(6,5)
         ilag(nv(6),5)=nv(5)
C
C     VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C
C     END OF VARIANT 4 MODIFICATION
C
C     if((i.eq.n1/2+1).and.(j.eq.n2/2+1).and.(k.gt.(n3+1)/4)) then
C     do ii=1,6 
C       do jj=1,6
C         desm(ii,jj)=desm(ii,jj)/1000. 
C       enddo
C     enddo
C     endif
C
C     VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C
C
C     VARIANT 4 MODIFICATION
C
      if((i.eq.n1/2-1).and.(j.eq.n2/2-1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2-1).and.(j.eq.n2/2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2-1).and.(j.eq.n2/2+1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2-1).and.(j.eq.n2/2+2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
C
      if((i.eq.n1/2).and.(j.eq.n2/2-1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2).and.(j.eq.n2/2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2).and.(j.eq.n2/2+1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2).and.(j.eq.n2/2+2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
C
      if((i.eq.n1/2+1).and.(j.eq.n2/2-1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+1).and.(j.eq.n2/2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+1).and.(j.eq.n2/2+1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+1).and.(j.eq.n2/2+2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
C
      if((i.eq.n1/2+2).and.(j.eq.n2/2-1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+2).and.(j.eq.n2/2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+2).and.(j.eq.n2/2+1).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
      if((i.eq.n1/2+2).and.(j.eq.n2/2+2).and.(k.gt.n3/2+2)) then
       do ii=1,6
        do jj=1,6
          desm(ii,jj)=desm(ii,jj)/EE
        enddo
       enddo
      endif
C
C     VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C
C     END OF VARIANT 4 MODIFICATION
C
C
C     VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C
C        D_BC DESM Recovery
C
         if (k.eq.1) then
           do ii=1,6
           do jj=1,6
             desm(ii,jj)=esm(ii,jj)
           enddo
           enddo
         endif
C
C        D_BC DESM R_END
C 
        enddo
       enddo
      enddo
C 
      return
      end
C
C     ***********************************************************
C     Sparse matrix vector multiplication. Matrix is stored in
C     a compressed form.
C
      subroutine smvm(v,w)
C     ***********************************************************
      PARAMETER (NNMAX=4723056,MMMAX=14169168)
C     PARAMETER (NNMAX=83700,MMMAX=251100)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/LOCALI_DD/ M1, M2, M3, MMDD
      COMMON /LOCALI/ N1, N2, N3, NN, NV(6)
      COMMON /GLOBR/ RLAG(NNMAX,5), RUAG(NNMAX,6), FF(MMMAX), XX(MMMAX)
      COMMON /GLOBI/ ILAG(NNMAX,5), IUAG(NNMAX,6)
      dimension v(1),w(1)
C
      do i=1,nn
        w(i)=0.
      enddo
C
      do i=1,nn
        w(i)=w(i)+ruag(i,1)*v(i)
        do j=2,6
         w(i)=w(i)+ruag(i,j)*v(iuag(i,j)) 
         w(iuag(i,j))=w(iuag(i,j))+ruag(i,j)*v(i)
        enddo
      enddo
C
      return
      end
C
C***************************************************************
C     inner product function

C***************************************************************
      FUNCTION PRODIN(U,V,N)
C***************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (NNMAX=4723056,MMMAX=14169168)
C     PARAMETER (NNMAX=83700,MMMAX=251100)
      DIMENSION U(1),V(1)
      PRODIN=0.D0
      DO 1 I=1,N
        PRODIN=PRODIN+U(I)*V(I)
1     CONTINUE
      RETURN
      END
C
C     ***********************************************************
C     MIC(0) FAVTORIZATION ==> computation of D(I)
C
      SUBROUTINE MIC_0
C     ***********************************************************
C
      PARAMETER (NNMAX=4723056,MMMAX=14169168)
C     PARAMETER (NNMAX=83700,MMMAX=251100)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/LOCALI_DD/ M1, M2, M3, MMDD
      COMMON /LOCALI/ N1, N2, N3, NN, NV(6)
      COMMON /GLOBR/ RLAG(NNMAX,5), RUAG(NNMAX,6), FF(MMMAX), XX(MMMAX)
      COMMON /GLOBI/ ILAG(NNMAX,5), IUAG(NNMAX,6)
      COMMON /WORK/ DWORK(MMMAX),V(MMMAX),W(MMMAX)
      COMMON /MIC0/  D(NNMAX)
C
      do i=1,nn
        w(i)=ruag(i,1)
      enddo
C
C     tt=0.1
      tt=(1./n1)**2
C     PERT_A
      do i=1,nn
        s=0.
        do j=1,5
          s=s+ruag(i,j+1)
        enddo
        t=tt*w(i)
          if(w(i).lt.(-2.*s)) t=sqrt(tt)*w(i)
        ruag(i,1)=ruag(i,1)+t
      enddo
C
C
      do i=1,nn
        d(i)=0.
      enddo
C
      d(1)=ruag(1,1)
C
      do i=2,nn
       d(i)=ruag(i,1)
       do k=1,5
        if(ilag(i,k).ne.0) then
        kk=ilag(i,k)
        s=0.
           do j=2,6
             s=s+ruag(kk,j)
           enddo
         s=s*rlag(i,k)/d(kk)
         d(i)=d(i)-s
         endif
       enddo
C 
       if(d(i).lt.0) then
C        write(*,*) 'd(',i,')=',d(i)
        stop 'C is not PD'
       endif
C
      enddo
C
C     unpert_a
C
      do i=1,nn
       ruag(i,1)=w(i)
      enddo

      return
      end
C
C     ***********************************************************
C     preconditioned conjugate gradient solver
C     ***********************************************************
      SUBROUTINE PCG_DD
C     ***********************************************************
C
C       PROGRAM CGM-PRECON
C       AX=B, C-PRECONDITIONER
C       A MATRIX (MMDD X MMDD)
C       B, X - VECTORS MMDD 
C
      PARAMETER (NNMAX=4723056,MMMAX=14169168)
C     PARAMETER (NNMAX=83700,MMMAX=251100)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/LOCALI_DD/ M1, M2, M3, MMDD
      COMMON /LOCALI/ N1, N2, N3, NN, NV(6)
      COMMON /GLOBR/ RLAG(NNMAX,5), RUAG(NNMAX,6), B(MMMAX), X(MMMAX)
      COMMON /GLOBI/ ILAG(NNMAX,5), IUAG(NNMAX,6)
      COMMON /WORK/ RN(MMMAX),SN(MMMAX),WN(MMMAX)
      COMMON /CG_PCG_E/ EPS
C     EPS=1.d-8
C     EPS=1.d-6
C     EPS=1.d-3
C      write(*,*) 'EPS=', eps
      ISTOP= 1400
C       X0 - ARBITRARY
      DO  I=1,MMDD
        X(I)=0.D0
      ENDDO
      CALL DDSMVM(X,RN)
      
      DO I=1,MMDD
        RN(I)=B(I)-RN(I)
      ENDDO
C       SN = (I/C) * RN
      RW=PRECONDD(RN,SN)
C
      IF(RW.EQ.0.D0) STOP '  RIGHT SIDE IS 0  '
      EPS=RW*EPS*EPS
C      write(*,*) 'PCG NORM (R0) = ',RW
C
C       BEGIN OF ITERATION PROCESS
C
      DO 5 ITER=1,ISTOP
        CALL DDSMVM(SN,WN)
        ALFA=RW/PRODIN(SN,WN,MMDD)
C
C
        DO 3 I=1,MMDD
          X(I)=X(I)+ALFA*SN(I)
          RN(I)=RN(I)-ALFA*WN(I)
3       CONTINUE
C         WN = (I/C) * RN
        RW1=PRECONDD(RN,WN)
C        WRITE(*,*) 'PCG NORM ',ITER,' = ',RW1
        IF(RW1.LE.EPS) THEN
C          WRITE(*,*) 'NUMBER OF PCG ITER = ',ITER
C        write(*,*)'#'
          CALL DDSMVM(X,RN)
C
          DO I=1,MMDD
            RN(I)=B(I)-RN(I)
          ENDDO
C          WRITE(*,*) 'PCG (RN,RN) = ',PRODIN(RN,RN,MMDD)
          RETURN
C          STOP '  SOLUTION FOUND  '
        ENDIF
        BETA=RW1/RW
        RW=RW1
        DO 4 I=1,MMDD
          SN(I)=WN(I)+BETA*SN(I)
4       CONTINUE
5     CONTINUE
      STOP '  SOLUTION NOT FOUND  '
      END
C
***************************************************************
C     V= C^{-1} U
C     PRECONDD = (U,V)
C     DISPLACEMENT DECOMPOSITION +
C     Modified Incomplete LU is used as a preconditioner ==> MIC(0)
C     inner product function
C***************************************************************
      FUNCTION PRECONDD(U,V)
C***************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (NNMAX=4723056,MMMAX=14169168)
C     PARAMETER (NNMAX=83700,MMMAX=251100)
      COMMON /LOCALI/ N1, N2, N3, NN, NV(6)
C
      DIMENSION U(1),V(1)
      precondd=precon(u(1),v(1))+
     >         precon(u(nn+1),v(nn+1))+
     >         precon(u(2*nn+1),v(2*nn+1))
      return
      end
C
***************************************************************
C       V= C^{-1} U
C       PRECON = (U,V)
C     Modified Incomplete LU is used as a preconditioner ==> MIC(0)
C     inner product function
C***************************************************************
      FUNCTION PRECON(U,V)
C***************************************************************
C
      PARAMETER (NNMAX=4723056,MMMAX=14169168)
C     PARAMETER (NNMAX=83700,MMMAX=251100)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(1),V(1)
      DIMENSION W(NNMAX)
C
      COMMON/LOCALI_DD/ M1, M2, M3, MMDD
      COMMON /LOCALI/ N1, N2, N3, NN, NV(6)
      COMMON /GLOBR/ RLAG(NNMAX,5), RUAG(NNMAX,6), FF(MMMAX), XX(MMMAX)
      COMMON /GLOBI/ ILAG(NNMAX,5), IUAG(NNMAX,6)
      COMMON /MIC0/  D(NNMAX)
C
C     w = (D+L)^{-1} u
C
      w(1) = u(1)/d(1)
      do i=2,nn
        w(i)=u(i)
        do j=1,5
         w(i)=w(i)-rlag(i,j)*w(ilag(i,j))
        enddo
        w(i)=w(i)/d(i)
      enddo
C
C     w = D w
C
      do i=1,nn
        w(i)=w(i)*d(i)
      enddo
C
C     v = (D+U)^{-1} w
C
      v(nn)=w(nn)/d(nn)
      do ii=1,nn-1
        i=nn-ii
        v(i)=w(i)
        do j=2,6
         v(i)=v(i)-ruag(i,j)*v(iuag(i,j))
        enddo
        v(i)=v(i)/d(i)
      enddo
C
      PRECON=PRODIN(u,v,nn) 
C
      return
      end
C     ***********************************************************
C     ***********************************************************
C     computation of strain and stress tenzors
C     ***********************************************************
      subroutine post_pr
C     ***********************************************************
C
      PARAMETER (NNMAX=4723056,MMMAX=14169168)
      implicit real*8(a-h,o-z)
C
      common /locali/ n1,n2,n3,nn,nv(6)
      common/GLOBR/ RLAG(NNMAX,5), RUAG(NNMAX,6), B(MMMAX), X(MMMAX)
      common /step/ h1,h2,h3
C      COMMON /Step/ HX(116),HY(116),HZ(116)
C      COMMON /Step/ HX(31),HY(31),HZ(31)
C      common /Lame/ EE,anu,alambda,amu
      common/Lame/EE_s,EE_p,anu_s,anu_p,alambda_s,alambda_p,amu_s,amu_p

      dimension PD(3,3)
C     PD=
C     |du1/dx du2/dx du3/dx|
C     |du1/dy du2/dy du3/dy|
C
C     Partiadd
      dimension dx(6)
      dimension dy(6)
      dimension dz(6)

      dimension stress(n1,n3),strain(n1,n3),Zdispl(n1,n3)
      dimension work1(3,3),work2(3,3)
C
C     !!!!!!!!!-ravnomerna mreza!!!!!!!!   
C 
        do j=1,6
         dx(j)=0
         dy(j)=0
         dz(j)=0
        enddo
C
      dx(1)=-1./(2*h1)
      dx(2)=1./(2*h1)
C
      dy(3)=-1./(2*h2)
      dy(4)=1./(2*h2)
C
      dz(5)=-1./(2*h3)
      dz(6)=1./(2*h3)
C
      j0=(n2/2)+1
C     ***************************************************
C
      do i=1,n1
       do k=1,n3

       call itop(i,j0,k)
C     ***************************************************
C     initialization of Zdispl(i,k)
C
      z=0.
      do jk=1,6
       z=z+x(nv(jk)+2*nn)
      enddo
      Zdispl(i,k)=z/6.
C      write(*,*)Zdispl(i,k)
C     ***************************************************
C     initialization of PD(3,3) for the element (i,j0,k)

      p1=0.
      do i1=1,6
C       write(*,*)'x=',x(nv(i1)),'nv=',nv(i1)
       p1=p1+x(nv(i1))*dx(i1)
      enddo
      pd(1,1)=p1
C      write(*,*)'pd(1,1)=',p1
C
      p1=0.
      do i1=1,6
C       write(*,*)'x=',x(nv(i1)),'nv=',nv(i1)
       p1=p1+x(nv(i1))*dy(i1)
      enddo
      pd(2,1)=p1
C      write(*,*)'pd(2,1)=',p1
C
      p1=0.
      do i1=1,6
C       write(*,*)'x=',x(nv(i1)),'nv=',nv(i1)
       p1=p1+x(nv(i1))*dz(i1)
      enddo
      pd(3,1)=p1
C      write(*,*)'pd(3,1)=',p1
C
      p1=0.
      do i1=1,6
C       write(*,*)'x=',x(nv(i1)+nn),'nv=',nv(i1)
       p1=p1+x(nv(i1)+nn)*dx(i1)
      enddo
      pd(1,2)=p1
C      write(*,*)'pd(1,2)=',p1
C
      p1=0.
      do i1=1,6
C       write(*,*)'x=',x(nv(i1)+nn),'nv=',nv(i1)
       p1=p1+x(nv(i1)+nn)*dy(i1)
      enddo
      pd(2,2)=p1
C      write(*,*)'pd(2,2)=',p1

C
      p1=0.
      do i1=1,6
C       write(*,*)'x=',x(nv(i1)+nn),'nv=',nv(i1)
       p1=p1+x(nv(i1)+nn)*dz(i1)
      enddo
      pd(3,2)=p1
C      write(*,*)'pd(3,2)=',p1
C
      p1=0.
      do i1=1,6
C       write(*,*)'x=',x(nv(i1)+2*nn),'nv=',nv(i1)
       p1=p1+x(nv(i1)+2*nn)*dx(i1)
      enddo
      pd(1,3)=p1
C      write(*,*)'pd(1,3)=',p1
C
      p1=0.
      do i1=1,6
C       write(*,*)'x=',x(nv(i1)+2*nn),'nv=',nv(i1)
       p1=p1+x(nv(i1)+2*nn)*dy(i1)
      enddo
      pd(2,3)=p1
C      write(*,*)'pd(2,3)=',p1
C
      p1=0.
      do i1=1,6
C       write(*,*)'x=',x(nv(i1)+2*nn),'nv=',nv(i1)
       p1=p1+x(nv(i1)+2*nn)*dz(i1)
      enddo
      pd(3,3)=p1
C      write(*,*) p1
C
      do i3=1,3
       do j3=1,3
        work1(i3,j3)=0
        work2(i3,j3)=0
       enddo
      enddo
C
C     *********************************************
C     strain tensor for the  element (i,j0,k)
C
      do ii=1,3
       do jj=1,3
        work1(ii,jj)=0.5*(pd(jj,ii)+pd(ii,jj))
       enddo
      enddo
C
      strain(i,k)=work1(3,3)
C      write(*,*) work1(3,3)

C     *********************************************
C     stress tensor for the element (i,j0,k)
C
      ww=work1(1,1)+work1(2,2)+work1(3,3)
C
      if ((i.eq.n1/2-1).and.(k.gt.n3/2+2)) then
      do ii=1,3
       do jj=1,3
        if (ii.eq.jj) then
        work2(ii,jj)=alambda_p*ww+2.*amu_p*work1(ii,jj)
        work2(ii,jj)=0.
        else
        work2(ii,jj)=2.*amu_p*work1(ii,jj)
       endif
       enddo
      enddo
C
      goto 12
C
      endif
C
      if ((i.eq.n1/2).and.(k.gt.n3/2+2)) then
      do ii=1,3
       do jj=1,3
        if (ii.eq.jj) then
        work2(ii,jj)=alambda_p*ww+2.*amu_p*work1(ii,jj)
        work2(ii,jj)=0.
        else
        work2(ii,jj)=2.*amu_p*work1(ii,jj)
       endif
       enddo
      enddo
C
      goto 12
C
      endif
C
C
      if ((i.eq.n1/2+1).and.(k.gt.n3/2+2)) then
      do ii=1,3
       do jj=1,3
        if (ii.eq.jj) then
        work2(ii,jj)=alambda_p*ww+2.*amu_p*work1(ii,jj)
        work2(ii,jj)=0.
        else
        work2(ii,jj)=2.*amu_p*work1(ii,jj)
       endif
       enddo
      enddo
C
      goto 12
C
      endif
C
C
      if ((i.eq.n1/2+2).and.(k.gt.n3/2+2)) then
      do ii=1,3
       do jj=1,3
        if (ii.eq.jj) then
        work2(ii,jj)=alambda_p*ww+2.*amu_p*work1(ii,jj)
        work2(ii,jj)=0.
        else
        work2(ii,jj)=2.*amu_p*work1(ii,jj)
       endif
       enddo
      enddo
C
      goto 12
C
      endif
C
      do ii=1,3
       do jj=1,3
        if (ii.eq.jj) then
        work2(ii,jj)=alambda_s*ww+2.*amu_s*work1(ii,jj)
        else
        work2(ii,jj)=2.*amu_s*work1(ii,jj)
       endif


       enddo
      enddo
C

C
 12   continue
C
      stress(i,k)= work2(3,3)
C 
      enddo
       enddo
C
C
       write(*,*)'*** vertical displacements *************'
       do i=1,n1
         do j=1,n3
        write(*,*) Zdispl(i,j)
        enddo
       enddo

C
       write(*,*)'*** vertical strain t(3,3) *************'
       do i=1,n1
         do j=1,n3
        write(*,*) strain(i,j)
        enddo
       enddo
C
       write(*,*)'*** vertical stress s(3,3) *************'
       do i=1,n1
        do j=1,n3
        write(*,*) stress(i,j)
        enddo
       enddo

      return
      end
C     ***************************************************

