#ifndef __projection_h_included__
#define __projection_h_included__
#include "vectors.h"
#include "index.h"
#include "small.h"
#include <vector>


EXPORT
template<class Base> class PDom
{
 public:
  typedef typename Base::element_type element_type;
  typedef typename Base::const_element_type const_element_type;
  typedef typename Base::base_type base_type;
  typedef typename Base::int_type int_type;
  typedef typename Myf<base_type>::base_type Double;
  typedef BDom<SmallVector<Double, 3>, int_type> CoordsBase;
  CoordsBase *coords;

  int type;
  PDom(){}
  int x[3];
  void SetType(int tp, CoordsBase &co);
  int_type N1, N2, N3, ON3;
  MPI::Intracomm *comm;
  int size;
  int rank;

  element_type const operator[](const Index3dBase<int_type> &i)const;
};

EXPORT
template<class Vector>
class Projection
{
public:
  void Project(Vector&){};
  void SetProject(Vector&){};
  void SetComm(MPI::Intracomm &comm_){}
};

// we only project for elasticity;
template<class Double, class Int>
class Projection<BDom<SmallVector<Double, 3>, Int> >
{
  typedef BDom<SmallVector<Double, 3>, Int> Vector;
  typedef Vector CoordsVector;

  PDom<Vector> P[6];
/*   Int N1, N2, N3, N3R; */
/*   Int DoubleLines; */
/*   bool FirstFull; */
/*   bool FirstFirst; */
/*   bool LastFull; */
/*   bool LastLast; */

/*   Int Lines; */
/*   Int StartLine; */
  int rank, size;
  SmallMatrix<Double, 6, 6> mat;
  std::vector<int> perm;
  bool bad;
 public:
  void GenSystem();
  void SetComm(MPI::Intracomm &comm_);
  void Project(Vector&);
  void SetProject(Vector&);
};


#endif
#ifdef INCLUSION
#include "projection.hpp"
#endif
