#ifndef __projection_hpp_included__
#define __projection_hpp_included__


#include "projection.h"
#include "ntransform.h"
#include "functors.h"

// class PDom
template<class Base>
void
PDom<Base>::
SetType(int tp, CoordsBase &co)
{
  type = tp;
  coords = &co;
  comm = co.comm;
  size = comm->Get_size();
  rank = comm->Get_rank();
  N1 = co.N1;
  N2 = co.N2;
  N3 = co.N3;
  ON3= co.N3 - (Options::GetOptions().PBC &&(rank==(size-1)));
  if (tp < 3)
    return;
  tp-=3;
  int mask = 7 - (1 << tp);
  x[0] = tp;                  //x0 e nomera na komponentata, koqto stawa nula
  int c = 1;
  for(int j = 0; j < 3;++j)
    if (mask&(1<<j))          //x1 i x2 sa ostanalite dwe komponenti
      x[c++]=j;
   // if(rank==0)
   //    std::cout << tp << " " << c << " " << x[0] << " " << x[1] << " " <<x[2] << std::endl;
}


template<class Base>
typename PDom<Base>::element_type const
PDom<Base>::
operator[](const Index3dBase<int_type> &ind)const
{
  element_type el;
  switch (type) //0 negative
  {
  case 0:
  case 1:
  case 2:
    {
      //      element_type &f = (*coords)[ind];
      double one;
      el[0]=0;
      el[1]=0;
      el[2]=0;
      for (int prip=0; prip<3; ++prip)
	//	for(int i = 0; i < 3; ++i)
	{
	  // 	double sum = 0;
	  // 	for(int j = 0; j < 3; ++j)
	  // 	  sum += fabs(f[i][j]);
	  // 	if (sum != 0.0)
	  el[prip][type] = 1;
	}
      return el;
    }
  case 3:
  case 4:
  case 5:
    {
      
//       element_type &f = (*coords)[ind];
      
//       //      std::cout << type << " " << " " << x[0] << " " << x[1] << " " <<x[2] << std::endl;
//       for(int prip = 0; prip <3; ++prip)
//       {
// 	el[prip][x[0]]= 0;
// 	el[prip][x[1]]=-f[prip][x[2]];
// 	el[prip][x[2]]=f[prip][x[1]];
//       };
//       return el;
      
      element_type &f = (*coords)[ind];
      
      //      std::cout << type << " " << " " << x[0] << " " << x[1] << " " <<x[2] << std::endl;
      //      for(int prip = 0; prip <3; ++prip)
      int x[3] = {0, 1, 2};
      int sw = type-3;
      //      std::cout << "*****************************************" << sw << std::endl;
      for (int prip = 0; prip<3; ++prip)
      {
	//	typedef base_type Double;
	const Double &X1 = f[prip][0];
	const Double &X2 = f[prip][1];
	const Double &X3 = f[prip][2];
	switch (sw)
	{
	case 0:
	  el[prip][0]=   0;
	  el[prip][1]= -X3;
	  el[prip][2]=  X2;
	  break;
	case 1:
	  el[prip][0]=  X3;
	  el[prip][1]=   0;
	  el[prip][2]= -X1;
	  break;
	case 2:
	  el[prip][0]= -X2;
	  el[prip][1]=  X1;
	  el[prip][2]=   0;
	  break;
	default:
	  throw "pichka mu lelijna";
	}


      }
      //      std::cout << el[0] << std::endl;
      return el;
    }
  }
  throw "pichka mu lelijna2";
}


//Projection
// only the partial template specialization
template<class Double, class Int>
void
Projection<BDom<SmallVector<Double, 3>, Int> >::
GenSystem()
{
  static int firstj = 0;
  for (int i = 0; i <6; ++i)
  {
    int sj=(firstj>i) ? firstj:i;
    for(int j = sj; j <6;++j)
    {
      mat[i][j] = mat[j][i] = VecVecReducePBC<VecDot>(P[i],P[j]);
    }
  }
  firstj=3;
  double det = DoLU(mat, perm);
  bad = isnan(det) || isinf(det) ||(fabs(det)<1e-206) || (fabs(det) >1e206);
  if ((rank == 0) && bad)
    std::cout << "bad " << det << std::endl;
}

template<class Double, class Int>
void
Projection<BDom<SmallVector<Double, 3>, Int> >::
SetComm(MPI::Intracomm &comm_)
{
  bad = true;
    rank = comm_.Get_rank();
    size = comm_.Get_size();
//     N1 = Options::GetOptions().N1;
//     N2 = Options::GetOptions().N2;
//     N3R = Options::GetOptions().N3;
//     StartLine = rank*(N3R+1)/size;
//     Lines = (rank+1)*(N3R+1)/size - StartLine;
    
//     N3 = Lines;
//     //    typedef typename Vector::int_type Int;
//     Int NumberOfLines = Lines+1;
//     Int SL = StartLine-1;
//     Int SO = -1;
//     if (rank == 0)
//     {
//       SL++;
//       SO++;
//       NumberOfLines--;
//     }
//     if (rank +1 == size)
//     {
//       NumberOfLines--;
//     }

//     FirstFirst = rank==0;
//     LastLast = rank == (size-1);
//     FirstFull = ((StartLine &1) == 0);
    
//     DoubleLines = (Lines&1)? (Lines+1)/2-Int(FirstFull) : (Lines)/2;
    
}
template<class Double, class Int>
void
Projection<BDom<SmallVector<Double, 3>, Int> >::
SetProject(Vector& R)
{
  if (Options::GetOptions().PBC)
    R.AddBoundarys(2);
  R.SetPeriodic(true);
  R.AddBoundarys(0);
  R.DoCyclo(0);
  if (Options::GetOptions().PBC)
    R.AddBoundarys(2);

  static int firsti=0;
 for(int i = firsti; i < 6; ++i)
    P[i].SetType(i, R);
  GenSystem();
  R.SetPeriodic(false);
  firsti=3;
}
template<class Double, class Int>
void
Projection<BDom<SmallVector<Double, 3>, Int> >::
Project(Vector& R)
{
  if (bad)
  {
    //    ClearVector(R);
    return;
  }
  SmallVector<Double, 6> rhs, x;
  for (int k = 0; k < 1; ++k)
  {
    if (Options::GetOptions().PBC)
      R.AddBoundarys(2);
    for(int i = 0; i < 6; ++i)
      rhs[i] = VecVecReducePBC<VecDot>(P[i], R);
    BackSubst(mat, rhs, x, perm);
    for (int i = 0; i < 6; ++i)
      VecVecOper<VecUpdate>(R, P[i], -x[i]);
    //    std::cout << x << std::endl ;
  }
  //  std::cout <<std::endl;

  if (Options::GetOptions().PBC)
     R.AddBoundarys(2);
}


#endif


