#ifndef __sparcemmat_hpp__
#define __sparcemmat_hpp__

#include "sparcemmat.h"


// static variable declaration
template<class Double, int Rows, int Columns>
typename SparceMacroMatrix<Double, Rows, Columns>::index_type SparceMacroMatrix<Double, Rows, Columns>::index;


template<class Double, int Rows, int Columns>
void SparceMacroMatrix<Double, Rows, Columns>::
MulVec(vector_type &r, const vector_type &v)const
{
  r = Double();
  MulVecAdd(r, v);
}
template<class Double, int Rows, int Columns>
void SparceMacroMatrix<Double, Rows, Columns>::
MulVecAdd(vector_type &r, const vector_type &v)const
{
  // ij.MulAdd(&r[0], &v[0]);
  // return;
  for(int i = 0; i < Rows; ++i)
  {
    const int cols = index[i][Columns];
    Double sum = Double();
    for(int j = 0; j < cols; ++j)
      sum += (*this)[i][j] * v[index[i][j]];
    r[i]+= sum;
  }    
}

template<class Double, int Rows, int Columns>
SparceMacroMatrix<Double, Rows, Columns>::
SparceMacroMatrix()
{
  (*this).Base::operator =( Double());
}

template<class Double, int Rows, int Columns>
void
SparceMacroMatrix<Double, Rows, Columns>::
operator = (const SmallMatrix<Double, Rows, Rows, HeapStorage> &a)
{
  //  ij = a;
  int total = 0;
  for(int i = 0; i < Rows; ++i)
  {
    total += index[i][Columns];
    const int cols = index[i][Columns];
    //    std::cout << "cdf" << cols << std::endl;
    for(int j = 0; j < cols; ++j)
      (*this)[i][j] = a[i][index[i][j]];
  }
  //  std::cerr << "Total elements = " << total << " avarage = " <<(double)total/Rows << std::endl;
}

template<class Double, int Rows, int Columns>
void
SparceMacroMatrix<Double, Rows, Columns>::
RemoveIndex(int ind)
{
  //  ij.RemoveIndex(ind);
  
  for(int i = 0; i < Rows; ++i)
  {
    const int cols = index[i][Columns];
    for(int j=0; j < cols; ++j)
      if((index[i][j]==ind)||i==ind)
      {
	(*this)[i][j] = 0;
	if((index[i][j]==ind)&&i==ind)
	  (*this)[i][j] = 1;	
      }
  }
}

#endif
