#ifndef __sumator_h__
#define __sumator_h__

template <class T>
class ParSumator
{
  static const int zero = 0x400;
  T sum, bigS;
  int c;
public:
  ParSumator():sum(T()),bigS(T()),c(0)
  {
  }
  void operator +=(const T&f)
  {
    sum += f;
    if(!(++c & zero))
    {
      bigS += sum;
      sum = T();
      c = 0;
    }
  }

  void operator -=(const T&f)
  {
    sum -= f;
    if(!(++c & zero))
    {
      bigS += sum;
      sum = T();
      c = 0;
    }
  }
  void operator = (const T &a)
  {
    sum = T();
    bigS = T();
    c = 0;
  }
  operator T()const
  {
    T ret;
    ret = sum;
    ret += bigS;
    return ret;
  }

};

template <class T>
class ErrSumator
{
  T Sum;
  T ErrSum;
public:
  ErrSumator():Sum(T()), ErrSum(T())
  {
  }

  void operator +=(const T&f)
  {
    T oldsum;
    oldsum = Sum;
    Sum += f;
    T diff ;
    diff = Sum;
    diff -= oldsum;
    T err;
    err = f;
    err -= diff;
    ErrSum += err;
  }
  void operator -=(const T&f)
  {
    T oldsum;
    oldsum = Sum;
    Sum -= f;
    T diff ;
    diff = Sum;
    diff -= oldsum;
    T err;
    err = f;
    err -= diff;
    ErrSum += err;
  }
  void operator = (const T&a)
  {
    ErrSum= T();
    Sum = T();
    (*this)+=a;
  }

  operator T()const
  {
    T sum;
    sum = Sum;
    sum += ErrSum;
    return sum;
  }
};

template <class T>
class PNSumator
{
  T possum;
  T negsum;
public:
  PNSumator():possum(T()), negsum(T())
  {
  }

  void operator +=(const T&a)
  {
    possum+= (a>0)*a;
    negsum+= (a<0)*a;
  }

  void operator -=(const T&a)
  {
    negsum -= (a>0)*a;
    possum -= (a<0)*a;
  }

  void operator = (const T &a)
  {
    possum= T();
    negsum= T();
    (*this)+=a;
  }

  operator T()const
  {
    T sum;
    sum = possum;
    sum += negsum;
    return sum;
  }
  
};

#endif
