#include "mpi.h"
#include "sysgen.hpp"

vector3d<double> coefficientvec;


#ifndef USE_EXPORT
template
double  U(const SmallVector<double, 3> &p);

template class Discretizator<double>;

template void Discretizator<double>::GenerateMatrix<
  BDom<SmallVector<double, 6>, int>, BDom<double, int> >(BDom<SmallVector<double, 6>, int>&, BDom<double, int>&, BDom<SmallVector<double, 6>, int>::int_type, BDom<SmallVector<double, 6>, int>::int_type, BDom<SmallVector<double, 6>, int>::int_type, BDom<SmallVector<double, 6>, int>::int_type, BoundaryConditions);

#ifdef MY_HYPRE
template void Discretizator<double>::GenerateMatrix<
  HypreIJMatrix, HypreIJVector>
  (HypreIJMatrix&, HypreIJVector&, int, int, int, int, BoundaryConditions);
#endif
#ifdef _FLOAT_EXPAND
template void Discretizator<float>::GenerateMatrix<
  BDom<SmallVector<float, 6>, int>, BDom<float, int> >(BDom<SmallVector<float, 6>, int>&, BDom<float, int>&, BDom<SmallVector<float, 6>, int>::int_type, BDom<SmallVector<float, 6>, int>::int_type, BDom<SmallVector<float, 6>, int>::int_type, BDom<SmallVector<float, 6>, int>::int_type, BoundaryConditions);
template class Discretizator<float>;
template
float  U(const SmallVector<float, 3> &p);
#endif
#endif //export
