#ifndef __cg_h__
#define __cg_h__
#include "basic.h"
#include <string>

#include "vectors.h"
//#include "useful.h"
#include "sysgen.h"
#include "matrix.h"
#include "solver.h"

/* template<class Double, class Int> */
/* class Worker */
/* { */
/*   MPI::Intracomm comm; */

/*   int rank, size; */

/*   Int N1, N2, N3R, N3L; */
/*   Int StartLine; */
/*   Int Lines; */
/* public: */
/*   typedef SmallVector<Double, 6> row_type; */
/*   typedef BDom<row_type, Int> matrix_type; */
/*   typedef BDom<Double, Int> bvector_type; */
/*   //  typedef BDom<Double, Int> vector_type; */
/* private: */
/*   matrix_type mat; */
/*   bvector_type rhs; */
/*   bvector_type x; */
/* public: */

/*   double commtimevecdot; */
/*   double commtimematvec; */
/*   double commtimepreconditioner; */
/*   double comptimepreconditionercreation; */
/*   double comptime; */
/*   double comptimevecdot; */
/*   double comptimematvec; */
/*   double comptimevecvec; */
/*   double comptimepreconditioner; */
/*   double comptimesysgen; */
/*   double comptimesystemsolve; */
/*   double comptimesystemsolveiterations; */
/*   double eps; */

/*   std::string algname; */
/*   Int iterations; */
/* public: */
/*   bool readcoeffs; */
/*   Double zero; */



/* public: */

/*   unsigned CG( */
/*               const matrix_type &Mat, */
/*               bvector_type &X, */
/*               const bvector_type &RHS, */
/*               Double Eps, */
/*               Index3dBase<Int> &ind); */
 
/*   template<class PreconMethod> */
/*   unsigned PCG( */
/* 	       const matrix_type &Mat, */
/* 	       bvector_type &X, */
/* 	       bvector_type &RHS, */
/* 	       Double Eps, */
/* 	       Index3dBase<Int> &ind); */
/*   template<class PreconMethod> */
/*   unsigned PCGm4( */
/* 		 const matrix_type &Mat, */
/* 		 bvector_type &X, */
/* 		 bvector_type &RHS, */
/* 		 Double Eps, */
/* 		 Index3dBase<Int> &ind); */



/*   Worker(MPI::Intracomm  & c, Int n1, Int n2, Int n3); */


/*   void Reduce(double &a); */
/*   void ClearTimes(); */

/*   void PrintSumary(); */
/*   Double CheckSolution(); */
/*   void Sysgen(DiscretizationType distype, BoundaryConditions bc); */

/*   void Solve(Double eps, SolutionMethod method); */
/* }; */


EXPORT
template<class Double, class Int>
class NewWorkerScalar
{
 public:
  Int StartLine, Lines;
  Int N1, N2, N3R;
  MPI::Intracomm comm;
  int rank,size;

  typedef SmallVector<Double, 6> row_type;
  typedef BDom<row_type, Int> matrix_type;
  typedef BDom<Double, Int> bvector_type;
  typedef SmallVector<float, 6> srow_type;
  typedef BDom<srow_type, Int> smatrix_type;
  typedef BDom<float, Int> sbvector_type;
  //  typedef BDom<Double, Int> vector_type;
private:
  ScalarMatrix<bvector_type> mat;
  bvector_type rhs;
  bvector_type x;
public:
  std::string algname;
  NewWorkerScalar(MPI::Intracomm &c,
		  Int n1, Int n2, Int n3);
  void Sysgen(DiscretizationType distype, BoundaryConditions bc);
  
  int Solve(Double eps, SolutionMethod method);

  Double CheckSolution();
  ~NewWorkerScalar(){}
};


#endif
