#ifndef __index_h__
#define __index_h__

template<class Int_type> class Index3dBase
{
 public:
  typedef Int_type Int;
protected:
  //  Int CurrentCPos
  Int CurrentbCPos;

  //  const Int N1stride, N2stride;
public:
  const Int N1, N2, N3;
  const Int N1bstride, N2bstride;
  Index3dBase(Int n1, Int n2, Int n3):
    N1(n1), 
    N2(n2), 
    N3(n3),
    //    N2stride(n3+1), 
    N1bstride((n3+3)*(n2+3)),
    N2bstride(n3+3)
    //    N1stride((n3+1)*(n2+1)), 
//    N2stride((n3+1)*(n2+1)), N2bstride((n3+3)*(n2+3)), 
//    N1stride((n3+1)), N1bstride((n3+3))
  {
//    N2stride = N3+1;
//    N2bstride = N3 +3;

//    N1stride = (N3+1)*(N2+1);
//    N1bstride = (N3+3)*(N2+3);    
  }

  Index3dBase(const Index3dBase &a):
    CurrentbCPos(a.CurrentbCPos),
    N1(a.N1), N2(a.N2), N3(a.N3),// N3R(a.N3R),
    N1bstride((a.N3+3)*(a.N2+3)),
    N2bstride(a.N3+3)
    {
    }


  void ToUp(){++CurrentbCPos;}
  void ToDown() { --CurrentbCPos;}
  void ToFront(){CurrentbCPos -= N2bstride;}
  void ToBack() {CurrentbCPos += N2bstride;}
  void ToRight(){CurrentbCPos += N1bstride;}
  void ToLeft() {CurrentbCPos -= N1bstride;}
  void SetPos(Int i, Int j, Int k)
  {
    CurrentbCPos = k + 1 + (j+1)*N2bstride + (i+1)*N1bstride;    
  }
  
  Index3dBase& operator=(Index3dBase const& a)
  {
    CurrentbCPos = a.CurrentbCPos;
    return *this;
  }
  /*
  Int Up()const    {return CurrentCPos+1;}
  Int Down()const  {return CurrentCPos-1;}
  Int Left()const  {return CurrentCPos - N1stride;}
  Int Right()const {return CurrentCPos + N1stride;}
  Int Back()const  {return CurrentCPos + N2stride;}
  Int Front()const {return CurrentCPos - N2stride;}
  Int RightFront()const {return CurrentCPos + N1stride - N2stride;}
  Int BackDown()const   {return CurrentCPos + N2stride -1;}
  Int RightDown()const  {return CurrentCPos + N1stride - 1;}
  */
  Int BUp()const   {return CurrentbCPos+1;}
  Int BDown()const {return CurrentbCPos-1;}
  Int BLeft()const {return CurrentbCPos - N1bstride;}
  Int BRight()const{return CurrentbCPos + N1bstride;}
  Int BBack()const {return CurrentbCPos + N2bstride;}
  Int BFront()const{return CurrentbCPos - N2bstride;}
  Int BRightFront()const {return CurrentbCPos + N1bstride - N2bstride;}
  Int BBackDown()const   {return CurrentbCPos + N2bstride -1;}
  Int BRightDown()const  {return CurrentbCPos + N1bstride - 1;}


  //  Int Ind()const{return CurrentCPos;}
  Int BInd()const{return CurrentbCPos;}

  //  Int This()const{return CurrentCPos;}
  Int BThis()const{return CurrentbCPos;}

//  Int Size()const{return N1*N2*N3;}wrong
//  Int BSize()const{return (N1+2)*(N2+2)*(N3+2);}wrong

};


/* template<class Int> class Index3dBase */
/* { */
/* protected: */
/*   Int CurrentCPos, CurrentbCPos; */

/*   const Int N1stride, N2stride; */
/*   const Int N1bstride, N2bstride; */
/* public: */
/*   const Int N1, N2, N3; */
/*   Index3dBase(Int n1, Int n2, Int n3): */
/*     N1(n1),  */
/*     N2(n2),  */
/*     N3(n3), */
/*     N2stride(n3+1),  */
/*     N2bstride(n3+3),  */
/*     N1stride((n3+1)*(n2+1)),  */
/*     N1bstride((n3+3)*(n2+3)) */
/* //    N2stride((n3+1)*(n2+1)), N2bstride((n3+3)*(n2+3)),  */
/* //    N1stride((n3+1)), N1bstride((n3+3)) */
/*   { */
/* //    N2stride = N3+1; */
/* //    N2bstride = N3 +3; */

/* //    N1stride = (N3+1)*(N2+1); */
/* //    N1bstride = (N3+3)*(N2+3);     */
/*   } */


/*   void ToUp(){++CurrentCPos;++CurrentbCPos;} */
/*   void ToDown() {--CurrentCPos; --CurrentbCPos;} */
/*   void ToFront(){CurrentCPos-=N2stride; CurrentbCPos -= N2bstride;} */
/*   void ToBack() {CurrentCPos+=N2stride; CurrentbCPos += N2bstride;} */
/*   void ToRight(){CurrentCPos+=N1stride; CurrentbCPos += N1bstride;} */
/*   void ToLeft() {CurrentCPos-=N1stride; CurrentbCPos -= N1bstride;} */
/*   void SetPos(Int i, Int j, Int k) */
/*   { */
/*     CurrentCPos = k + j *N2stride + i * N1stride; */
/*     CurrentbCPos = k + 1 + (j+1)*N2bstride + (i+1)*N1bstride;     */
/*   } */
  
/*   Index3dBase& operator=(Index3dBase const& a) */
/*   { */
/*     CurrentCPos = a.CurrentCPos; */
/*     CurrentbCPos = a.CurrentbCPos; */
/*     return *this; */
/*   } */

/*   Int Up()const    {return CurrentCPos+1;} */
/*   Int Down()const  {return CurrentCPos-1;} */
/*   Int Left()const  {return CurrentCPos - N1stride;} */
/*   Int Right()const {return CurrentCPos + N1stride;} */
/*   Int Back()const  {return CurrentCPos + N2stride;} */
/*   Int Front()const {return CurrentCPos - N2stride;} */
/*   Int RightFront()const {return CurrentCPos + N1stride - N2stride;} */
/*   Int BackDown()const   {return CurrentCPos + N2stride -1;} */
/*   Int RightDown()const  {return CurrentCPos + N1stride - 1;} */

/*   Int BUp()const   {return CurrentbCPos+1;} */
/*   Int BDown()const {return CurrentbCPos-1;} */
/*   Int BLeft()const {return CurrentbCPos - N1bstride;} */
/*   Int BRight()const{return CurrentbCPos + N1bstride;} */
/*   Int BBack()const {return CurrentbCPos + N2bstride;} */
/*   Int BFront()const{return CurrentbCPos - N2bstride;} */
/*   Int BRightFront()const {return CurrentbCPos + N1bstride - N2bstride;} */
/*   Int BBackDown()const   {return CurrentbCPos + N2bstride -1;} */
/*   Int BRightDown()const  {return CurrentbCPos + N1bstride - 1;} */


/*   Int Ind()const{return CurrentCPos;} */
/*   Int BInd()const{return CurrentbCPos;} */

/*   Int This()const{return CurrentCPos;} */
/*   Int BThis()const{return CurrentbCPos;} */

/* //  Int Size()const{return N1*N2*N3;}wrong */
/* //  Int BSize()const{return (N1+2)*(N2+2)*(N3+2);}wrong */

/* }; */


#endif
