#ifndef __matrix_h__
#define __matrix_h__
#include "basic.h"
#include "solver.h"
#include "vectors.h"
#include "small.h"

EXPORT
template<class Vector>
class ScalarMatrix:public MatrixBase<Vector>
{
 public:
  typedef typename Vector::Int Int;
  typedef typename Vector::base_type base_type;
  typedef base_type Double;
  typedef SmallVector<Double, 6> row_type;
  typedef BDom<row_type, Int> matrix_type;
  typedef Vector bvector_type;
  
  matrix_type mat;

  virtual void Multiply(Vector &res, Vector  &src)const;
  virtual std::string GetName()const
  {
    return "Scal";
  }
  
};



#endif
