#ifndef __matrix_hpp__
#define __matrix_hpp__

#include "matrix.h"
#include "vectors.h"
#include "index.h"
#include "functors.h"
#include "visitors.h"


template<class Vector>
void
ScalarMatrix<Vector>::
Multiply(Vector &res, Vector  &src)const
{
  TimeCalc1("MatVec");
  Index3dBase<typename Vector::int_type>
    ind(src.N1, src.N2, src.N3);
  
  MultiplyMatVector<matrix_type, Vector, Vector> MulHd(mat, src, res);


  {
    TimeCalc1("MatVecComm");
    src.StartSendRecv();
  }    
  ClearVector(res);
  ForAllMiddle(ind, MulHd);
  {
    TimeCalc1("MatVecComm");
    src.FinishSendRecv();
  }    
  ForAllNonMiddle(ind, MulHd);
  
}


#endif
