#ifndef __mirorer_h__
#define __mirorer_h__

#include <vector>
#include <iostream>
#include <algorithm>
#include <string>
#include <fstream>
#include <limits>
#include <memory>
#include <queue>

template<class T>
struct Tripple
{
  T i, j, k;
};

template<class T>
class vector3d
{
  typedef std::vector<T> vec_type;
  typedef typename vec_type::size_type size_type;
  vec_type buf;
  vector3d(const vector3d&);
public:
  void Clear()
  {
    vec_type buf1;
    buf1.swap(buf);
  }
  double zero, xmin, xmax, ymin, ymax, zmin, zmax, xs,ys,zs;
  void SetPars(double zer, double xmi, double xma,
	       double ymi, double yma,
	       double zmi, double zma)
  {
    zero = zer;
    xmin = xmi;
    xmax = xma;
    ymin = ymi;
    ymax = yma;
    zmin = zmi;
    zmax = zma;
/*     xmax -= xmin; */
/*     ymax -= ymin; */
/*     zmax -= zmin; */
    xs = xmax-xmin;
    ys = ymax-ymin;
    zs = zmax-zmin;
//    std::cout << zmin << " " << zmax << std::endl;
  }
  
  template<class V>
  V GetAt(V x, V y, V z)
  {
    T a = (*this)(size_type((double)(x-xmin)/xs*sizes[0]),
		   size_type((double)(y-ymin)/ys*sizes[1]),
		   size_type((double)(z-zmin)/zs*sizes[2]));
/*     if (a < 100) */
/*       std::cout << x + xmin << " " << y +ymin << " " << z +zmin<< " " <<a <<std::endl; */
    return a;
    T val =  a/std::numeric_limits<T>::max();
    return zero + val*(1.0-zero);

  }
  void Write(std::string fname)
  {
    std::ofstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str(), std::ios::binary);
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type i = 0; i < sizes[0]; ++i)
	for(size_type j = 0; j < sizes[1]; ++j)
	  f.write(reinterpret_cast<const char*>(&(*this)(i,j,k)), sizeof(T));
  }
  void Read(std::string fname, int startline)
  {
    std::ifstream f;
    using namespace std;
    f.exceptions(ios::failbit | ios::badbit |ios::eofbit);
    f.open(fname.c_str(), std::ios::binary);
    f.seekg(startline * sizes[0]*sizes[1]);
    for(size_type k = 0; k < sizes[2]; ++k)
      for(size_type i = 0; i < sizes[0]; ++i)
	for(size_type j = 0; j < sizes[1]; ++j)
	  {
	    char b;
	    f.read(&b, sizeof(b));
	    (*this)(i,j,k) = (unsigned char)b;
	  }
  }
  size_type sizes[3];
  vector3d(){sizes[0] = sizes[1] = sizes[2] = 0;}
  void SetSize(size_type i, size_type j, size_type k)
  {
    sizes[0] = i; sizes[1] = j; sizes[2] = k;
    buf.resize(i*j*k);
  }
  vector3d& operator=(const vector3d &a)
  {
    for(size_type i = 0; i < sizes[0]; ++i)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type k = 0; k < sizes[2]; ++k)
	  (*this)(i,j,k) = a(i,j,k);
    return (*this);
  }
  void ExtrudePt(size_type i, size_type j, size_type k)
  {
    ptrdiff_t szs[3];
    for(szs[0] = i - 1; szs[0] <=i+1; ++szs[0])
      for(szs[1] = j - 1; szs[1] <=j+1; ++szs[1])
	for(szs[2] = k - 1; szs[2] <=k+1; ++szs[2])
	{
	  for(int l = 0; l < 3; ++l)
	    if((szs[l] < 0)||(szs[l] >=sizes[l]))
	      goto cont;
	  (*this)(szs[0], szs[1], szs[2]) |= 1;
	cont:;
	}
  }
  void ExtrudeAll()
  {
    ptrdiff_t szs[3];
    for(szs[0] = 0; szs[0] <sizes[0]; ++szs[0])
      for(szs[1] = 0; szs[1] <sizes[1]; ++szs[1])
	for(szs[2] = 0 ; szs[2] <sizes[2]; ++szs[2])
	  if((*this)(szs[0], szs[1], szs[2])&2)
	    ExtrudePt(szs[0], szs[1], szs[2]);
  }
  void ConvertAllTo(T one)
  {
    ptrdiff_t szs[3];
    for(szs[0] = 0; szs[0] <sizes[0]; ++szs[0])
      for(szs[1] = 0; szs[1] <sizes[1]; ++szs[1])
	for(szs[2] = 0 ; szs[2] <sizes[2]; ++szs[2])
	  if((*this)(szs[0], szs[1], szs[2]))
	    (*this)(szs[0], szs[1], szs[2]) = one;
  }
  T & operator()(size_type i, size_type j, size_type k)
  {
    return buf[sizes[0]*sizes[1]*k + sizes[0]*j + i];
  }
  T const operator()(size_type i, size_type j, size_type k)const
  {
    return buf[sizes[0]*sizes[1]*k + sizes[0]*j + i];
  }

  T Enumerate(int i, int j, int k, T val)
  {
    //    std::cout << i << " " << j  << " " << k << std::endl;
    if(
       i < 0 ||
       i >=sizes[0] ||
       j < 0 ||
       j >=sizes[1] ||
       k < 0 ||
       k >=sizes[2])
      return 0;
    T  &a = (*this)(i,j,k);
    if (a!=1)
      return a;
    std::queue<Tripple<int> > que;
    Tripple<int> tri;
    tri.i = i;
    tri.j = j;
    tri.k = k;
    que.push(tri);
    (*this)(tri.i, tri.j, tri.k) = val;
    while(!que.empty())
      {
	tri = que.front();
	que.pop();
	  for(int ii = -1; ii <= 1; ++ii)
	    for(int jj = -1; jj <= 1; ++jj)
	      for(int kk = -1; kk <= 1; ++kk)
		{
		  if((abs(ii)+abs(jj)+abs(kk))!=1)	       
		  continue;
		  i = tri.i + ii;
		  j = tri.j + jj;
		  k = tri.k + kk;
		  if(
		     i < 0 ||
		     i >=sizes[0] ||
		     j < 0 ||
		     j >=sizes[1] ||
		     k < 0 ||
		     k >=sizes[2])
		  continue;
		  if((*this)(i,j,k)!=1)
		  continue;
		  tri.i = i;
		  tri.j = j;
		  tri.k = k;
		  (*this)(tri.i, tri.j, tri.k) = val;
		  que.push(tri);
		}
      }
    return val;
  }

  void RemoveBad(int minsize = 200)
  {
    T cur = 2;
    T ret;
    for(size_type i = 0; i < sizes[0]; ++i)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type k = 0; k < sizes[2]; ++k)
	{
	  ret = Enumerate(i,j,k,cur);
	  if (ret == cur)
	  {
	    //	    std::cout << (int) cur << std::endl;
	    if(cur<200)
	      cur++;
	  }
	}
    if (cur==200)
      cur++;
    //    return;
    std::vector<size_t> counts;
    counts.resize(cur);
    for(size_type i = 0; i < sizes[0]; ++i)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type k = 0; k < sizes[2]; ++k)
	{
	  assert((*this)(i,j,k)<cur);
	  //	  std::cout << i << " " << j < " " << k << std::endl;
	  ++counts[(*this)(i,j,k)];
	}
    counts[0] = counts[1] = 0;
    //    std::sort(counts.begin(), counts.end(), std::greater<size_t>());
    //    std::cout << "sizes are" << std::endl;
    minsize = 0;
    for(int i = 0; i < counts.size(); ++i)
      if(counts[i] > minsize)
	minsize=counts[i];
/*     for(int i = 0; i < counts.size();++i) */
/*       std:: cout << counts[i] << std::endl; */
    std::cout << "num = " << minsize << std::endl;
    for(size_type i = 0; i < sizes[0]; ++i)
      for(size_type j = 0; j < sizes[1]; ++j)
	for(size_type k = 0; k < sizes[2]; ++k)
	{
	    T &a = (*this)(i,j,k);
	    int off;
	    for(off = 2; off < counts.size(); off++)
	      if(a == off && counts[off]>=minsize)
	      {
		a = std::numeric_limits<T>::max();break;
	      }
	    if (off == counts.size())
	      a = 0;
	}
      
  }
  
};


template<class T>
std::auto_ptr<vector3d<T> >
Mirror(vector3d<T> const & vec, int times)
{
  vector3d<T> *ret = new vector3d<T>;
  ret->SetSize(vec.sizes[0]*times,
	       vec.sizes[1]*times,
	       vec.sizes[2]*times);

  for(int ii = 0; ii <  times; ++ii)
    for(int jj = 0; jj < times; ++jj)
      for(int kk = 0; kk < times; ++kk)
      {
	int si = (ii&1)*-2 +1;
	int sj = (jj&1)*-2 +1;
	int sk = (kk&1)*-2 +1;
	int oi = vec.sizes[0]*(ii + (ii&1))-(ii&1);
	int oj = vec.sizes[1]*(jj + (jj&1))-(jj&1);
	int ok = vec.sizes[2]*(kk + (kk&1))-(kk&1);
	for(int i = 0; i < vec.sizes[0]; ++i)
	  for(int j = 0; j < vec.sizes[1];++j)
	    for(int k = 0; k < vec.sizes[2];++k)
	      (*ret)(oi + si*i, oj + sj*j, ok + sk*k) = vec(i,j,k);
      }
  return std::auto_ptr<vector3d<T> >(ret);
}


#endif
