#include "precon.hpp"


#ifndef USE_EXPORT
#include "vectors.h"
#include "small.h"
#include "mmpl.hpp"
namespace{
  typedef SmallVector<double, 6> Drow_type;
  typedef BDom<Drow_type, int> Dmatrix_type;
  typedef BDom<double, int> DVector;

  typedef SmallVector<float, 6> Frow_type;
  typedef BDom<Frow_type, int> Fmatrix_type;
  typedef BDom<float, int> FVector;
  
  typedef SmallVector<double, 3> Dpoint_type;
  typedef BDom<Dpoint_type, int> Dbvector_type;
  typedef SmallVector<float, 3> Fpoint_type;
  typedef BDom<Fpoint_type, int> Fbvector_type;
}


template class NoPrecon<DVector>;
template class MIC0Precon<Dmatrix_type, DVector, DVector, PreconDescriptorM1>;
template class MIC0Precon<Dmatrix_type, DVector, DVector, PreconDescriptorM2>;
template class MIC0Precon<Dmatrix_type, DVector, DVector, PreconDescriptorM3>;
template class MIC0Precon<Dmatrix_type, DVector, DVector,  PreconDescriptorM4>;
template class MIC0PreconM4<Dmatrix_type, DVector, DVector, PreconDescriptorM4>;

template class NoPrecon<Dbvector_type>;
template class MIC0Precon<Dmatrix_type, Dbvector_type, DVector, PreconDescriptorM1>;
template class MIC0Precon<Dmatrix_type, Dbvector_type, DVector, PreconDescriptorM2>;
template class MIC0Precon<Dmatrix_type, Dbvector_type, DVector, PreconDescriptorM3>;
template class MIC0Precon<Dmatrix_type, Dbvector_type, DVector,  PreconDescriptorM4>;
template class MIC0PreconM4<Dmatrix_type, Dbvector_type, DVector, PreconDescriptorM4>;





#ifdef _FLOAT_EXPAND

template class NoPrecon<FVector>;
template class MIC0Precon<Fmatrix_type, FVector, FVector, PreconDescriptorM1>;
template class MIC0Precon<Fmatrix_type, FVector, FVector, PreconDescriptorM2>;
template class MIC0Precon<Fmatrix_type, FVector, FVector, PreconDescriptorM3>;
template class MIC0Precon<Fmatrix_type, FVector, FVector, PreconDescriptorM4>;
template class MIC0PreconM4<Fmatrix_type, FVector, FVector, PreconDescriptorM4>;

template class NoPrecon<Fbvector_type>;
template class MIC0Precon<Fmatrix_type, Fbvector_type, FVector, PreconDescriptorM1>;
template class MIC0Precon<Fmatrix_type, Fbvector_type, FVector, PreconDescriptorM2>;
template class MIC0Precon<Fmatrix_type, Fbvector_type, FVector, PreconDescriptorM3>;
template class MIC0Precon<Fmatrix_type, Fbvector_type, FVector, PreconDescriptorM4>;
template class MIC0PreconM4<Fmatrix_type, Fbvector_type, FVector, PreconDescriptorM4>;

template class SinglePrecon<Dbvector_type, MIC0Precon<Fmatrix_type, Fbvector_type, FVector, PreconDescriptorM1> >;
template class SinglePrecon<Dbvector_type, MIC0Precon<Fmatrix_type, Fbvector_type, FVector, PreconDescriptorM2> >;
template class SinglePrecon<Dbvector_type, MIC0Precon<Fmatrix_type, Fbvector_type, FVector, PreconDescriptorM3> >;
template class SinglePrecon<Dbvector_type, MIC0Precon<Fmatrix_type, Fbvector_type, FVector, PreconDescriptorM4> >;
template class SinglePrecon<Dbvector_type, MIC0PreconM4<Fmatrix_type, Fbvector_type, FVector, PreconDescriptorM4> >;

#endif



#endif //export
