#ifndef __sparcemmat_h__
#define __sparcemmat_h__

#include "basic.h"
#include "small.h"
EXPORT
template<class Double, int Rows, int Columns>
class SparceMacroMatrix:public SmallMatrix<Double, Rows, Columns, HeapStorage>
{
private:
  SparceMacroMatrix(const SparceMacroMatrix&);
public:
  typedef  SmallMatrix<Double, Rows, Columns, HeapStorage> Base;
  typedef SmallMatrix<int, Rows, Columns+1, HeapStorage> index_type;
  typedef SmallVector<Double, Rows> vector_type;
public:
  static index_type index;
public:
  SparceMacroMatrix();
  static index_type& GetIndex(){return index;};
  void MulVec(vector_type &r, const vector_type &v);
  void RemoveIndex(int index);
  void operator = (const SmallMatrix<Double, Rows, Rows, HeapStorage> &);
};



#endif
