#ifndef __sparcemmat_hpp__
#define __sparcemmat_hpp__

#include "sparcemmat.h"


// static variable declaration
template<class Double, int Rows, int Columns>
typename SparceMacroMatrix<Double, Rows, Columns>::index_type SparceMacroMatrix<Double, Rows, Columns>::index;


template<class Double, int Rows, int Columns>
void SparceMacroMatrix<Double, Rows, Columns>::
MulVec(vector_type &r, const vector_type &v)
{
  r = Double();
  for(int i = 0; i < Rows; ++i)
  {
    const int cols = index[i][Columns];
    Double sum = Double();
    for(int j = 0; j < cols; ++j)
      sum += static_cast<Base&>(*this)[i][j] * v[index[i][j]];
    r[i] = sum;
  }    
}

template<class Double, int Rows, int Columns>
SparceMacroMatrix<Double, Rows, Columns>::
SparceMacroMatrix()
{
  static_cast<Base&>(*this) = Double();
}

template<class Double, int Rows, int Columns>
void
SparceMacroMatrix<Double, Rows, Columns>::
operator = (const SmallMatrix<Double, Rows, Rows, HeapStorage> &a)
{
  for(int i = 0; i < Rows; ++i)
  {
    const int cols = index[i][Columns];
    //    std::cout << "cdf" << cols << std::endl;
    for(int j = 0; j < cols; ++j)
      static_cast<Base&>(*this)[i][j] = a[i][index[i][j]];
  }
}

template<class Double, int Rows, int Columns>
void
SparceMacroMatrix<Double, Rows, Columns>::
RemoveIndex(int ind)
{
  for(int i = 0; i < Rows; ++i)
  {
    const int cols = index[i][Columns];
    for(int j=0; j < cols; ++j)
      if((index[i][j]==ind)||i==ind)
      {
	static_cast<Base&>(*this)[i][j] = 0;
	if((index[i][j]==ind)&&i==ind)
	  static_cast<Base&>(*this)[i][j] = 1;	
      }
  }
}

#endif
