#ifndef __util_h__
#define __util_h__

#include <string>
#include <typeinfo>
#include <iostream>

template<class T> 
std::string GetFileSuffix()
{
	const std::type_info &ti = typeid(T);
	if(ti==typeid(float))
		return "f";
	return "";
}

bool OptionPresent(const std::string option, int argc, char **argv)
{
	for(int i = 1; i <argc; i++)
		if(option==argv[i])
			return true;
	return false;
}
#include <sstream>

std::string GetStringOption(const std::string option, int argc, char**argv, const std::string defaultoption="")
{
	for(int i = 1; i <argc; i++)
	{
		std::string a = argv[i];
		if(a.find(option)==0)
		{
			return std::string(a, option.length(), a.length());
		}
	}
	return defaultoption;
}

template<typename  T> 
T GetOption(const std::string option, int argc, char**argv, const T& defaultoption)
{
	std::stringstream a;
	a << defaultoption;
	T res;
	std::istringstream b;
	b.str(GetStringOption(option, argc, argv, a.str()));
	b >> res;
	return res;
}




#endif

