#include <iostream>
#include <vector>
#include <string>
#include <sstream>
#include <fstream>
#include <algorithm>
#include <iomanip>

using namespace std;

class Info
{
public:
    vector<string> msg;
    vector<string> data;
    string id;
    string num;
};
vector<Info> Data;
template<class T>
T To(const string &a)
{
    istringstream is (a);
    T d;
    is >> d;
    return d;
}

struct SortInfo
{
     bool operator()(Info const &A, Info const &B)const
     {
	 return (A.id < B.id) || ((A.id == B.id)&&(To<int>(A.num) < To<int>(B.num)));
     }
};


void ReadFile(string fname)
{
    ifstream f(fname.c_str());
    string line, msg, data;
    Info info;
    do{
      getline(f, line);
      if (!f)
	return;
    }while(line.find("Starting"));
    for(int i=31;i--;)
    {
	getline(f, line);
	if(!f)
	    return;
	msg = line.substr(0, 30);
	data = line.substr(30, 30);
	info.msg.push_back(msg);
	info.data.push_back(data);
    }
    ostringstream oss;
    oss <<right << setw(30) << info.data[0] + " " + info.data[2].substr(0,5);//<< " " << To<int>( info.data[2]);
    info.id = oss.str();
    info.num = info.data[1];
    Data.push_back(info);
}



void PrintLine(int from, int to)
{
    cout << "+---------------------------------+";
    for (int j = from; j < to; ++j)
	cout << "------------+" ;
    cout << endl;
}
void PrintRow(int field, int from, int to)
{
    const int firstcol = 33;
    const int nextcol = 12;
    cout.precision(6);
    
    cout << right;
    cout << setiosflags(ios::fixed | ios::showpoint);
    PrintLine(from, to);
    cout << "|" << setw(firstcol) << " " << "|";
    for(int i = from ; i < to; i++)
    {
	cout << setw(nextcol) << To<int>(Data[i].num) << "|";
    }
    cout << endl;
    cout << "|" << setw(firstcol) << Data[from].id <<"|";
    double first = To<double>(Data[from].data[field]);
    cout << setw(nextcol) << first << "|";
    
    for(int i = from + 1; i < to; i++)
    {
	cout << setw(nextcol) << To<double>(Data[i].data[field]) << "|";
    }
    cout << endl;
    cout << "|" << setw(firstcol) << "Speedup" << "|";
    for(int i = from ; i < to; i++)
    {
	cout << setw(nextcol) << first/To<double>(Data[i].data[field]) << "|";
    }
    cout << endl;
    cout << "|" << setw(firstcol) << "eff" << "|";
    for(int i = from ; i < to; i++)
    {
	cout << setw(nextcol) << first/To<double>(Data[i].data[field])/To<double>(Data[i].num) << "|";
    }
    cout << endl;

    PrintLine(from, to);
}


void PrintSummary()
{
    if (Data.size())
    {
	for(int field = 3; field < Data[0].data.size(); field++)
	{
	    cout << endl;
	    cout << Data[0].msg[field] << endl;
	    int start = 0;
	    int i;
	    for(i = 1; i < Data.size(); ++i)
	    {
		if (Data[start].id != Data[i].id)
		{
//		    cout << "Different" << i << endl;
		    PrintRow(field, start, i);
		    start = i;
		}
	    }
	    PrintRow(field, start, i);
	}
			
    }
    
}

int main(int argc, char const **argv)
{

    Info a,b;

    for (int i = 1; i <argc; ++i)
    {
	ReadFile(argv[i]);
    }

    std::sort(Data.begin(), Data.end(), SortInfo());

    PrintSummary();
}
