#include <string>
#include <fstream>
#include <stdexcept>
#include <iostream>
#include "epswriter.h"
using namespace std;


void SetColor1(EpsWriter&eps)
{
  eps.SetColor(1.0, .125, .0);
  //  eps.SetColor(0,0,0);
}
void SetColor2(EpsWriter&eps)
{
   eps.SetColor(0.0, 0.60, 0.0);
   // eps.SetColor(0,0,0);
}

void OutputEl(EpsWriter&eps, int i, int j, int N)
{
  double y1 = (double)i/N;
  double x1 = (double)j/N;
  double y2 = (double)(i+1)/N;
  double x2 = (double)(j+1)/N;

  /*  x1*=5;
  x2*=5;
  y1*=5;
  y2*=5;  
  x1-=3;
  x2-=3;
  y1-=3;
  y2-=3;
  if((x1>=0)&&(y2>=0)&&(x2<=1)&&(y1<=1))
  */
  y1 = 1-y1;
  y2 = 1-y2;
  eps.FillRect(x1, y1, x2, y2);
}

void GenAll()
{
	EpsWriter eps("proba.eps", 200, 200);
  int N = 100;
  for(int i = 0; i < N; ++i)
  {
    OutputEl(eps, i, i, N);
    OutputEl(eps, i, i+2, N);
    OutputEl(eps, i+1, i, N);
  }
}

int N1 = 2;
int N2 = 2;
int N3 = 6;

enum Pos{Left , Front , Down};

int GetTotalCount()
{
  return N1*N2*N3*3 + N1*N2 + N2*N3 + N1*N3;
}
int N = GetTotalCount();
int IndFromPos(int i, int j, int k, Pos p)
{
  int ind = 0;
  if(p==Left)
  {
    ind += (N2*N3*3+N2+N3)*i ;
    ind += j*N3;
    ind += k;
    return ind;
  }
  if(p==Front)
  {
    ind += (N2*N3*3+N2+N3)*i+ N2*N3;
    ind += j*N3 + j*(N3+1);
    ind += k;
    return ind;
  }
  if(p==Down)
  {
    ind += (N2*N3*3+N2+N3)*i+ N2*N3;
    ind += j*N3 + j*(N3+1);
    ind += k + N3;
    return ind;
  }
  return ind;
}
void PosFromInd(int ind, int &i, int &j, int &k, Pos &p)
{
  i = ind/(N2*N3*3+N2+N3);
  ind -= i *(N2*N3*3+N2+N3);
  if (ind < (N2*N3))
  {
    p = Left;
    j = ind/N3;
    k = ind%N3;
    return;
  }
  ind -= N2*N3;
  j = ind/(N3+N3+1);
  k = ind%(N3+N3+1);
  if (k>=N3)
  {
    p = Down;
    k-= N3;
  }else
    p = Front;
}

bool IfPosInBounds(int i, int j, int k, Pos p)
{
  if (( i <0) || (j<0) || (k <0))
    return false;
  if ((i>N1) || ((i==N1)&&(p!=Left)))
    return false;
  if ((j>N2) || ((j==N2)&&(p!=Front)))
    return false;
  if ((k>N3) || ((k==N3)&&(p!=Down)))
    return false;
  return true;
}


bool b1 = false;
bool b2 = false;


template<class F>
void Do(int ind, F &f)
{
  int i, j, k;
  
  int i1, j1, k1;
  Pos p, p1;
  double allc = 0;
  double v1olny = 0.8;
  double v2olny = 0.6;
  f.eps.SetColor(allc, allc, allc);
  PosFromInd(ind, i, j, k, p);
  f(ind, ind);
  if (p == Left)
  {
  f.eps.SetColor(allc, allc, allc);
    i1 = i;
    j1 = j;
    k1 = k;
    p1 = Front;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i;
    j1 = j;
    k1 = k;
    p1 = Down;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i;
    j1 = j+1;
    k1 = k;
    p1 = Front;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i;
    j1 = j;
    k1 = k+1;
    p1 = Down;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));

    i1 = i-1;
    j1 = j;
    k1 = k;
    p1 = Front;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i-1;
    j1 = j;
    k1 = k;
    p1 = Down;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i-1;
    j1 = j+1;
    k1 = k;
    p1 = Front;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i-1;
    j1 = j;
    k1 = k+1;
    p1 = Down;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));

    if(not b1 and not b2)
      {
	SetColor2(f.eps);//f.eps.SetColor(v2olny, v2olny, v2olny);
	i1 = i+1;
	j1 = j;
	k1 = k;
	p1 = Left;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
	i1 = i-1;
	j1 = j;
	k1 = k;
	p1 = Left;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
      }
  }

  if (p == Down)
  {
  f.eps.SetColor(allc, allc, allc);
    i1 = i;
    j1 = j;
    k1 = k;
    p1 = Left;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i+1;
    j1 = j;
    k1 = k;
    p1 = Left;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i;
    j1 = j;
    k1 = k-1;
    p1 = Left;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i+1;
    j1 = j;
    k1 = k-1;
    p1 = Left;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));

    if(not b2)
      {
	SetColor1(f.eps);//f.eps.SetColor(v1olny, v1olny, v1olny);
	i1 = i;
	j1 = j;
	k1 = k;
	p1 = Front;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
	i1 = i;
	j1 = j+1;
	k1 = k;
	p1 = Front;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
	i1 = i;
	j1 = j;
	k1 = k-1;
	p1 = Front;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
	i1 = i;
	j1 = j+1;
	k1 = k-1;
	p1 = Front;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
      }
    if(not b1 and not b2)
      {
	SetColor2(f.eps);//f.eps.SetColor(v2olny, v2olny, v2olny);
	i1 = i;
	j1 = j;
	k1 = k+1;
	p1 = Down;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
	i1 = i;
	j1 = j;
	k1 = k-1;
	p1 = Down;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
      }
  }

  if (p == Front)
  {
  f.eps.SetColor(allc, allc, allc);
    i1 = i;
    j1 = j;
    k1 = k;
    p1 = Left;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i+1;
    j1 = j;
    k1 = k;
    p1 = Left;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i;
    j1 = j-1;
    k1 = k;
    p1 = Left;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));
    i1 = i+1;
    j1 = j-1;
    k1 = k;
    p1 = Left;
    if (IfPosInBounds(i1, j1, k1, p1))
      f(ind, IndFromPos(i1, j1, k1, p1));

    if(not b2)
      {
	SetColor1(f.eps);//f.eps.SetColor(v1olny, v1olny, v1olny);
	i1 = i;
	j1 = j;
	k1 = k;
	p1 = Down;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
	i1 = i;
	j1 = j;
	k1 = k+1;
	p1 = Down;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
	i1 = i;
	j1 = j-1;
	k1 = k;
	p1 = Down;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
	i1 = i;
	j1 = j-1;
	k1 = k+1;
	p1 = Down;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
      }

    if(not b1 and not b2)
      {
	SetColor2(f.eps);//f.eps.SetColor(v2olny, v2olny, v2olny);
	i1 = i;
	j1 = j+1;
	k1 = k;
	p1 = Front;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
	i1 = i;
	j1 = j-1;
	k1 = k;
	p1 = Front;
	if (IfPosInBounds(i1, j1, k1, p1))
	  f(ind, IndFromPos(i1, j1, k1, p1));
      }
  }

}

template<class ER>
void DrawSingleLine(ER&eps, int&prev, int count)
{
  int tmp;
  double o;
  o = prev/double(N);
  eps.DrawLine(0,1-o,1,1-o);
  eps.DrawLine(o,0,o,1);
  prev += count;
}
class Write
{
int N;
public:
EpsWriter eps;
public:
  Write():N(GetTotalCount()), eps("proba.eps", 320, 320){}
  bool small;
void operator()(int i, int j)
{
  OutputEl(eps, i, j, N);
  //  OutputEl(eps, j, i, N);
}
  void DrawMesh()
  {
    eps.SetColor(0.25, 0.25, 0.25);
    eps.LineWidth(0.05);
    eps.NewPath();
    eps.MoveTo(0,0);
    eps.LineTo(1,0);
    eps.LineTo(1,1);
    eps.LineTo(0,1);
    eps.LineTo(0,0);
    eps.Stroke();
    int prev = 0;
    if(small)
      {
	
	for(int i = 0; i < N1;++i)
	  {
	    for(int j = 0; j < N2; ++j)
	      DrawSingleLine(eps, prev, N3);
	    for(int j = 0; j < N2; ++j)
	      {
		DrawSingleLine(eps, prev, N3);
		DrawSingleLine(eps, prev, N3+1);
	      }
	    DrawSingleLine(eps, prev, N3);
	  }
	for(int j = 0; j < N2; ++j)
	  DrawSingleLine(eps, prev, N3);
      }
    else
    eps.LineWidth(0.2);
    prev = 0;
      {
	for(int i = 0; i < N1; ++i)
	  {
	    DrawSingleLine(eps, prev, N3*N2);
	    DrawSingleLine(eps, prev, N3*(N2+1)+N2*(N3+1));
	  }
	DrawSingleLine(eps, prev, N3*N2);
	DrawSingleLine(eps, prev, N3*(N2+1)+N2*(N3+1));
      }
  }
};

int main(int argc, char *argv[])
{
  int N = GetTotalCount();
  
  int i, j, k;
  Pos p;

  Write W;
  //  b1 = false;
  W.small = not b2;
  W.DrawMesh();
  
  for (int cnt = 0; cnt < N; ++cnt)
  {
    Do(cnt, W);
  }
  

	return 0;
}

