#include "mpi.h"
#include <iostream>
using namespace std;

const int N = 1024*1024;
long buf[N];
int rank;
int size;

inline double test(int n)
{
  const int count = 1000;
  MPI::Status st;
  double time = MPI::Wtime();
  for(int i = 0; i < count; i++)
    {
      if(rank == size-1)
	{
	  if(i&1)
	    MPI::COMM_WORLD.Recv(buf, n, MPI::LONG, 0,i,st);
	  else
	    MPI::COMM_WORLD.Send(buf, n, MPI::LONG, 0,i);
	}
      if(rank == 0)
	{
	  if(i&1)
	    MPI::COMM_WORLD.Send(buf, n, MPI::LONG, size-1,i);
	  else
	    MPI::COMM_WORLD.Recv(buf, n, MPI::LONG, size-1,i,st);
	}
    }
  time = MPI::Wtime() - time;
  return time/count;    
}

void calcab(double t2, double t3, int N2, int N3)
{
 double beta = (t3 - t2)/(N3 - N2);
 double alpha = t2 - N2*beta;
 if(rank == 0)
   cout << alpha << " " << beta << endl;

}



int main(int argc, char**argv)
{
  MPI_Init(&argc, &argv);

  rank = MPI::COMM_WORLD.Get_rank();
  size = MPI::COMM_WORLD.Get_size();
  double t1 = test(1);
  double t2 = test(1024);
  double t3 = test(1024*1024);
  double t4 = test(4096);
 
  calcab(t1,t2, 1, 1024);
  calcab(t2,t3, 1024, N);
  calcab(t1,t3, 1, N);
  calcab(t2,t4, 1024,4096);

  MPI_Finalize();
}
