#ifndef __util_h__
#define __util_h__

#include <string>
#include <typeinfo>
#include <iostream>
#include <cctype>

template<class T> 
inline std::string GetFileSuffix()
{
  const std::type_info &ti = typeid(T);
  if(ti==typeid(float))
    return "f";
  return "";
}

extern bool Help;
#define PRINTHELP(WHAT) if (Help) std::cout << "        " << option <<"\t" <<  help << " " << #WHAT << std::endl
inline bool OptionPresent(const std::string option, int argc, char **argv, const std::string &help="")
{
  PRINTHELP(Boolean option.);
  for(int i = 1; i <argc; i++)
    if(option==argv[i])
      return true;
  return false;
}
#include <sstream>

inline std::string GetStringOption(const std::string option, int argc, char**argv, const std::string defaultoption="")
{
  //  PRINTHELP(str;
  for(int i = 1; i <argc; i++)
  {
    std::string a = argv[i];
    if(a.find(option)==0)
    {
      return std::string(a, option.length(), a.length());
    }
  }
  return defaultoption;
}

template<typename  T> 
inline T GetOption(const std::string option, int argc, char**argv, const T& defaultoption, const std::string &help="")
{
  PRINTHELP(Value option.);
  std::stringstream a;
  a << defaultoption;
  T res;
  std::istringstream b;
  std::string str;
  b.str(str = GetStringOption(option, argc, argv, a.str()));
  b >> res;
  //  std::cout << option << " str = " << res << " = " << str <<  std::endl; 
  return res;
}

template<typename  Array> 
inline void GetArrayOption(const std::string option, int argc, char**argv, 
			   Array& array, const std::string &help="")
{
  PRINTHELP(Array value option.);
  for(int i = 1; i <argc; i++)
  {
    std::string a = argv[i];
    if(a.find(option)!=0)
      continue;
    a = a.substr(option.length());
    int index = 0;
    unsigned int cur = 0;
    while((cur < a.length())&&(std::isdigit(a[cur])))
    {
      index = 10*index + (a[cur++]-'0');
    }
    if ((cur>=a.length()) || (a[cur++]!='='))
      continue;

    std::istringstream b(a.substr(cur));
    b >>array[index];
    //    std::cout << option << "[" << index << "] = " << array[index] << std::endl;
  }
}




#endif

