#ifndef __vectors_h__
#define __vectors_h__
#include "basic.h"
// IBM workaround
#ifdef _MY_CPP
#include "mympicxx.hpp"
#endif



#include "mpi.h"
#include <vector>
#include "small.h"
#include "index.h"
enum Elment{LeftEl, FrontEl, DownEl};






template<class BaseType> class Priplet :public SmallVector<BaseType, 3>
{
};


//extern int totalsize;


EXPORT
template<class BaseType, class In> class Dom_base
{
public:
  typedef Priplet<BaseType> element_type;
  typedef Priplet<BaseType> const_element_type;
  typedef BaseType base_type;
  typedef In Int;
protected:
  element_type *buf;  
private:
  Dom_base(const Dom_base&);
public:
  Int Size;
  Dom_base():Size(0)
  {
    buf = 0;
  }
  void SetSize1(Int size)
  {
    Size = size;
/*     totalsize += Size*sizeof(element_type); */
/*     std::cout << totalsize << std::endl; */
    buf = new element_type[size];
  }
  Dom_base(Int size)
  {
    SetSize1(size);
  }
  element_type& Index(Int i)
  { 
    return buf[i];
  }
  const_element_type& Index(Int i)const
  {
    return buf[i];
  }
  ~Dom_base(){delete[] buf;}
  
};



EXPORT
template<class BaseType, class Int> class BDom:public Dom_base<BaseType, Int>
{
  using Dom_base<BaseType, Int>::buf;
public:
  using Dom_base<BaseType, Int>::Index;
  typedef Dom_base<BaseType, Int> Base;
  typedef typename Base::element_type element_type;
  typedef typename Base::const_element_type const_element_type;
  typedef typename Base::base_type base_type;
  typedef Int int_type;

protected:
  //using Base::SetSize;
  //std::vector<base_type> SendBufferD, SendBufferU, RecvBufferD, RecvBufferU, SendLine, RecvLine;
  MPI::Request rsu, rsd, rru, rrd, rsf, rsl, rrf, rrl;
  //, lrs, lrr;

static   MPI::Datatype DtUp_plane, DtDown_plane;
static   MPI::Datatype DtLeft, DtDown, DtFront;
static   MPI::Datatype DtLeft_line, DtDown_line, DtFront_line;
static   MPI::Datatype DtLeft_down, DtFront_down;
static   MPI::Datatype DtUp_unfinished;
static   MPI::Datatype DtDown_left_plane;
static   bool Dt_Created;
static   int Dt_refcnt;
public:
  MPI::Intracomm *comm;
  int rank, size;
  int UpP, DownP;
  int PUpP, PDownP;
  int FirstP, LastP;
  int NextP, PrevP;
  bool periodic;

  Int N1, N2, N3, ON3, N3R;
  //  typedef Dom<BaseType, Int> Type;
  typedef BDom BType;

  void  CreateDatatypes();
      
    
  
  BDom(Int n1, Int n2, Int n3, Int n3r); // N1, N2, N3 size of the mesh
  void SetComm(MPI::Intracomm  &co);
  BDom();
  ~BDom();

  void SetPeriodic(bool peri)
  {
    periodic = peri;
    ON3 = N3 -  ((size==(rank+1))&&peri);
    if (peri)
    {
      PUpP = NextP;
      PDownP = PrevP;
    }else
    {
      PUpP = UpP;
      PDownP = DownP;
    }
	
    
    
  }
  void CopyBoundary( BDom&a);
  
  void SetSize(Int n1, Int n2, Int n3, Int n3r);
  void MakeSame(const BDom &a)
    {
      SetSize(a.N1, a.N2, a.N3, a.N3R);
    }
  
  void ClearLine(Int I, Int K, Elment El, Int a = 0);
  void ClearOthers();
  void ClearOthers1();
  void ClearOthers2();
  void ClearZero();

  /// good start ! e da we, ebati komentara! Koj znae kakwo e iskal da kave poeta..!

  base_type Recvdata[4], senddata[4];
  std::vector<base_type> RecvdataLong;
  std::vector<base_type> RecvdataLong2;

  std::vector<base_type> BufUp, BufDown, BufUpR, BufDownR;

  bool SendUp, SendDown;

  void Pack();
  void Pack2();
  void AddSides(int add);
  void CopyLeft(int=0);
  void AddSidesM0(int);
  void UnPackAdd();
  void UnPackAdd2(int add);
  void AddBoundarys(int add);
  void AddBoundarysM0(int add);
  void UnPackNoAdd();
  void StartSendRecvAdd();
  void FinishSendRecvAdd(bool add=true);
  void StartSendRecvAdd2();
  void FinishSendRecvAdd2(int add);
  void StartSendRecvAddM0();
  void FinishSendRecvAddM0(int add);
  void AddParts();
  void SendRecvPBC();
  void StartSendRecvh1();
  void FinishSendRecvh1();
  void StartSendRecvh2();
  void FinishSendRecvh2();


  void StartFwdM4(Index3dBase<Int>const & Id, Index3dBase<Int>const & Iu);
  void FinishFwdM4(Index3dBase<Int>const & Id, Index3dBase<Int>const & Iu);
  void StartBwdM4(Index3dBase<Int>const & Id, Index3dBase<Int>const & Iu);
  void FinishBwdM4(Index3dBase<Int>const & Id, Index3dBase<Int>const & Iu);

  void StartFwdFront(Index3dBase<Int>const & Id, Index3dBase<Int>const & Iu);
  void FinishFwdFront(Index3dBase<Int>const & Id, Index3dBase<Int>const & Iu);
  void StartFwdDown(Index3dBase<Int> const & Id, Index3dBase<Int> const & Iu);
  void FinishFwdDown(Index3dBase<Int> Id, Index3dBase<Int> Iu);
  void StartFwdLeft(Index3dBase<Int> const & Id, Index3dBase<Int> const & Iu);
  void FinishFwdLeft(Index3dBase<Int> const & Id, Index3dBase<Int> const & Iu);
  void StartBwdLeft(Index3dBase<Int> const& Id, Index3dBase<Int> const & Iu);
  void FinishBwdLeft(Index3dBase<Int> const& Id, Index3dBase<Int> const &Iu);
  void StartBwdFront(Index3dBase<Int> const& Id, Index3dBase<Int> const &Iu);
  void FinishBwdFront(Index3dBase<Int> const& Id, Index3dBase<Int> const&Iu);
  void StartBwdDown(Index3dBase<Int> const &Id, Index3dBase<Int> const&Iu);
  void FinishBwdDown(Index3dBase<Int> const& Id, Index3dBase<Int> const&Iu);
  void StartFwdLineLeft(Index3dBase<Int> const &Id, Index3dBase<Int> const&Iu);
  
  // we need these variables so we pass by value
  void FinishFwdLineLeft(Index3dBase<Int> Id, Index3dBase<Int> Iu);
  void StartFwdLineMiddle(Index3dBase<Int> const &Id, Index3dBase<Int> const&Iu);
   // we need these variables so we pass by value
  void FinishFwdLineMiddle(Index3dBase<Int> Id, Index3dBase<Int> Iu);
  void StartBwdLineLeft(Index3dBase<Int> const &Id, Index3dBase<Int> const&Iu);
  void FinishBwdLineLeft(Index3dBase<Int> const &Id, Index3dBase<Int> const&Iu);
  void StartBwdLineMiddle(Index3dBase<Int> const &Id, Index3dBase<Int> const&Iu);
  void FinishBwdLineMiddle(Index3dBase<Int> const &Id, Index3dBase<Int> const&Iu);
  void StartDownLeftPlane();
  void FinishDownLeftPlane();

  void StartSendRecv();
  void FinishSendRecv();
     

  void DoCyclo(int dir);

  element_type& operator[](const Index3dBase<Int> &i)
  {
    return Index(i.BInd());
  }
  const_element_type& operator[](const Index3dBase<Int> &i) const
  {
    return Index(i.BInd());
  }

  element_type& Front(const Index3dBase<Int> &i)
  {
    return Base::Index(i.BFront());
  }
  element_type& RightFront(const Index3dBase<Int> &i)
  {
    return Base::Index(i.BRightFront());
  }
  element_type& BackDown(const Index3dBase<Int> &i)
  {
    return Base::Index(i.BBackDown());
  }
  element_type& RightDown(const Index3dBase<Int> &i)
  {
    return Base::Index(i.BRightDown());
  }

  const_element_type& Up(const Index3dBase<Int> &i)const
  {
    return Base::Index(i.BUp());
  }
  const_element_type& Down(const Index3dBase<Int> &i)const
  {
    return Base::Index(i.BDown());
  }
  const_element_type& Left(const Index3dBase<Int> &i)const
  {
    return Base::Index(i.BLeft());
  }
  const_element_type& LeftUp(const Index3dBase<Int> &i)const
  {
    return Base::Index(i.BLeftUp());
  }
  const_element_type& LeftBack(const Index3dBase<Int> &i)const
  {
    return Base::Index(i.BLeftBack());
  }
  const_element_type& Right(const Index3dBase<Int> &i)const
  {
    return Base::Index(i.BRight());
  }
  const_element_type& Back(const Index3dBase<Int> &i)const
  {
    return Base::Index(i.BBack());
  }
  const_element_type& Front(const Index3dBase<Int> &i)const
  {
    return Base::Index(i.BFront());
  }
  const_element_type& RightFront(const Index3dBase<Int> &i)const
  {
    return Base::Index(i.BRightFront());
  }
  const_element_type& BackDown(const Index3dBase<Int> &i)const
  {
    return Base::Index(i.BBackDown());
  }
  const_element_type& RightDown(const Index3dBase<Int> &i)const
  {
    return Base::Index(i.BRightDown());
  }

};



EXPORT
template<class T, class Int>
void ClearMatrix(BDom<SmallVector<T, 6>, Int > & mat);
EXPORT
template<class T, class Int, template<class F, class G> class Vector>
void ClearVector(Vector<T, Int> & vec, Int AAA = 0);
template<class T, class Int, template<class F, class G> class Vector>
void ClearVectorRand(Vector<T, Int> & vec, Int AAA = 0);




//template<class A, class B> class BDom;
// template<class BaseType, class Int > class Dom:public Dom_base<BaseType, Int>
// {

// public:
//   typedef Dom_base<BaseType, Int> Base;
//   typedef typename Base::element_type element_type;
//   typedef typename Base::const_element_type const_element_type;
//   typedef typename Base::base_type base_type;
//   typedef Int int_type;
//   typedef Dom Type;
//   typedef BDom<BaseType, Int> BType;

// protected:
// //using Base::SetSize;
// public:

//   Int N1, N2, N3;
//   Dom(Int n1, Int n2, Int n3) // N1, N2, N3 size of the mesh
//     :N1(n1), N2(n2), N3(n3), Base((n1+1)*(n2+1)*(n3+1)){}
//   Dom():N1(0), N2(0), N3(0){}
//   void SetSize(Int n1, Int n2, Int n3)
//   {
//     N1 = n1; N2 = n2; N3 = n3;
//     Base::SetSize1((n1+1)*(n2+1)*(n3+1));
//   }

  
  
//   element_type& operator[](const Index3dBase<Int> &i)
//   {
//     return Base::Index(i.Ind());
//   }
//   const_element_type& operator[](const Index3dBase<Int> &i) const
//   {
//     return Base::Index(i.Ind());
//   }
  
//   element_type& Up(const Index3dBase<Int> &i)
//   {
//     return Base::Index(i.Up());
//   }
//   element_type& Down(const Index3dBase<Int> &i)
//   {
//     return Base::Index(i.Down());
//   }
//   element_type& Left(const Index3dBase<Int> &i)
//   {
//     return Base::Index(i.Left());
//   }
//   element_type& Right(const Index3dBase<Int> &i)
//   {
//     return Base::Index(i.Right());
//   }
//   element_type& Back(const Index3dBase<Int> &i)
//   {
//     return Base::Index(i.Back());
//   }
//   element_type& Front(const Index3dBase<Int> &i)
//   {
//     return Base::Index(i.Front());
//   }
//   element_type& RightFront(const Index3dBase<Int> &i)
//   {
//     return Base::Index(i.RightFront());
//   }
//   element_type& BackDown(const Index3dBase<Int> &i)
//   {
//     return Base::Index(i.BackDown());
//   }
//   element_type& RightDown(const Index3dBase<Int> &i)
//   {
//     return Base::Index(i.RightDown());
//   }

//   const_element_type& Up(const Index3dBase<Int> &i)const
//   {
//     return Base::Index(i.Up());
//   }
//   const_element_type& Down(const Index3dBase<Int> &i)const
//   {
//     return Base::Index(i.Down());
//   }
//   const_element_type& Left(const Index3dBase<Int> &i)const
//   {
//     return Base::Index(i.Left());
//   }
//   const_element_type& Right(const Index3dBase<Int> &i)const
//   {
//     return Base::Index(i.Right());
//   }
//   const_element_type& Back(const Index3dBase<Int> &i)const
//   {
//     return Base::Index(i.Back());
//   }
//   const_element_type& Front(const Index3dBase<Int> &i)const
//   {
//     return Base::Index(i.Front());
//   }
//   const_element_type& RightFront(const Index3dBase<Int> &i)const
//   {
//     return Base::Index(i.RightFront());
//   }
//   const_element_type& BackDown(const Index3dBase<Int> &i)const
//   {
//     return Base::Index(i.BackDown());
//   }
//   const_element_type& RightDown(const Index3dBase<Int> &i)const
//   {
//     return Base::Index(i.RightDown());
//   }

// };




/*   void PackLineLeftFront(Int I, Int K) */
/*   { */
/*     Index3dBase<Int> ind(N1, N2, N3); */
/*     ind.SetPos(I, 0, K); */
/*     Int cnt = 0; */
/*     Int J; */
/*     for (J = N2+1; J; --J, ind.ToBack()) */
/*     {  */
/*       SendLine[cnt++] = (*this)[ind][LeftEl]; */
/*       SendLine[cnt++] = (*this)[ind][FrontEl]; */
/*     }         */
/*   } */
/*   void PackLineDown(Int I, Int K) */
/*   { */
/*     Index3dBase<Int> ind(N1, N2, N3); */
/*     ind.SetPos(I, 0, K); */
/*     Int cnt = 0; */
/*     Int J; */
/*     for (J = N2+1; J; --J, ind.ToBack()) */
/*     {  */
/*       SendLine[cnt++] = (*this)[ind][DownEl]; */
/* //      if ((*this)[ind][DownEl] < 0)  */
/* //        cout << "hhh " << ((*this)[ind][DownEl]) << endl; */
/*     }     */
/*   } */
/*   void UnPackLineLeftFrontAdd(Int I, Int K) */
/*   { */
/*     Index3dBase<Int> ind(N1, N2, N3); */
/*     ind.SetPos(I, 0, K); */
/*     Int cnt = 0; */
/*     Int J; */
/*     for (J = N2+1; J; --J, ind.ToBack()) */
/*     {  */
/*       (*this)[ind][LeftEl] += RecvLine[cnt++]  ; */
/*       (*this)[ind][FrontEl]+= RecvLine[cnt++]  ; */
/*     }     */
/*   } */
/*   void UnPackLineLeftFront(Int I, Int K) */
/*   { */
/*     Index3dBase<Int> ind(N1, N2, N3); */
/*     ind.SetPos(I, 0, K); */
/*     Int cnt = 0; */
/*     Int J; */
/*     for (J = N2+1; J; --J, ind.ToBack()) */
/*     {  */
/*       (*this)[ind][LeftEl] = RecvLine[cnt++]  ; */
/*       (*this)[ind][FrontEl]= RecvLine[cnt++]  ; */
/*     }         */
/*   } */
/*   void UnPackLineDownAdd(Int I, Int K) */
/*   { */
/*     Index3dBase<Int> ind(N1, N2, N3); */
/*     ind.SetPos(I, 0, K); */
/*     Int cnt = 0; */
/*     Int J; */
/*     for (J = N2+1; J; --J, ind.ToBack()) */
/*     {  */
/*       (*this)[ind][DownEl] += RecvLine[cnt++]  ; */
/* //      cout << MPI::COMM_WORLD.Get_rank() << " " << ((*this)[ind][DownEl]) << "  ff " << RecvLine[cnt-1] << endl; */
/*     }         */
/*   } */
/*   void UnPackLineDown(Int I, Int K) */
/*   { */
/*     Index3dBase<Int> ind(N1, N2, N3); */
/*     ind.SetPos(I, 0, K); */
/*     Int cnt = 0; */
/*     Int J; */
/*     for (J = N2+1; J; --J, ind.ToBack()) */
/*     {  */
/*       (*this)[ind][DownEl] = RecvLine[cnt++]  ; */
/*     }         */
/*   } */

/*   void SendRecvConstr123(Int I, MPI::Intracomm&comm) */
/*   { */
/*     int size = comm.Get_size(); */
/*     int rank = comm.Get_rank(); */


/*     int UpP = rank+1; */
/*     int DownP = rank-1; */
/*     if (DownP <0) DownP = MPI::PROC_NULL; */
/*     if (UpP == size) UpP = MPI::PROC_NULL; */

/*     for(int i = 0; i < N2; ++i) */
/*       RecvLine[i] = 0; */
/*     PackLineDown(I, N3); //toppest line */
/*     lrs = comm.Ibsend(&SendLine[0], N2  , Myf<base_type>::Datatype(), UpP, 0); */
/*     lrr = comm.Irecv(&RecvLine[0], N2  , Myf<base_type>::Datatype(), DownP, 0); */
/*     lrs.Wait(); */
/*     lrr.Wait(); */
/*     UnPackLineDownAdd(I, 0); */
/*   } */

/*   void SendRecvConstr2down(Int I, MPI::Intracomm& comm) */
/*   { */
/*     int size = comm.Get_size(); */
/*     int rank = comm.Get_rank(); */


/*     int UpP = rank+1; */
/*     int DownP = rank-1; */
/*     if (DownP <0) DownP = MPI::PROC_NULL; */
/*     if (UpP == size) UpP = MPI::PROC_NULL; */

/*     for(int i = 0; i < N2; ++i) */
/*       RecvLine[i] = 0; */
/*     PackLineDown(I, N3); //toppest line */
/*     lrs = comm.Ibsend(&SendLine[0], N2  , Myf<base_type>::Datatype(), UpP, 0); */
/*     lrr = comm.Irecv(&RecvLine[0], N2  , Myf<base_type>::Datatype(), DownP, 0); */
/*     lrs.Wait(); */
/*     lrr.Wait(); */
/*     UnPackLineDownAdd(I, 0); */
/*     PackLineDown(I, 0); */
/*     lrs = comm.Ibsend(&SendLine[0], N2  , Myf<base_type>::Datatype(), DownP, 0); */
/*     lrr = comm.Irecv(&RecvLine[0], N2  , Myf<base_type>::Datatype(), UpP, 0); */
/*     lrs.Wait(); */
/*     lrr.Wait(); */
/*     if(rank+1 != size) UnPackLineDown(I, N3); */
/* /\*    if (rank +1 == size) */
/*     { */
/*       for(int i = 0; i < N2; ++i) */
/*         if (RecvLine[i] != 0) */
/*           cout << " mmm " << RecvLine[i] << endl; */
/*     } */
/* *\/ */
/*   } */
/*   void SendRecvConstr2left(Int I, MPI::Intracomm& comm) */
/*   { */
/*     int size = comm.Get_size(); */
/*     int rank = comm.Get_rank(); */


/*     int UpP = rank+1; */
/*     int DownP = rank-1; */
/*     if (DownP <0) DownP = MPI::PROC_NULL; */
/*     if (UpP == size) UpP = MPI::PROC_NULL; */

/*     for(int i = 0; i < N2*2+2; ++i) */
/*       RecvLine[i] = 0; */
/*     PackLineLeftFront(I, -1); //toppest line */
/*     lrs = comm.Ibsend(&SendLine[0], 2*N2+2  , Myf<base_type>::Datatype(), DownP, 0); */
/*     lrr = comm.Irecv(&RecvLine[0], 2*N2+2  , Myf<base_type>::Datatype(), UpP, 0); */
/*     lrs.Wait(); */
/*     lrr.Wait(); */
/*     UnPackLineLeftFrontAdd(I, N3-1); */
/*   } */

/*   void SendRecvSolve1down(Int I,MPI::Intracomm& comm) */
/*   { */
/*     int size = comm.Get_size(); */
/*     int rank = comm.Get_rank(); */


/*     int UpP = rank+1; */
/*     int DownP = rank-1; */
/*     if (DownP <0) DownP = MPI::PROC_NULL; */
/*     if (UpP == size) UpP = MPI::PROC_NULL; */

/*     for(int i = 0; i < N2; ++i) */
/*       RecvLine[i] = 0; */
/*     PackLineDown(I, N3); //toppest line */
/*     lrs = comm.Ibsend(&SendLine[0], N2  , Myf<base_type>::Datatype(), UpP, 0); */
/*     lrr = comm.Irecv(&RecvLine[0], N2  , Myf<base_type>::Datatype(), DownP, 0); */
/*   } */
/*   void SendRecvSolve1downFinish(Int I,MPI::Intracomm& comm) */
/*   { */
/*     lrs.Wait(); */
/*     lrr.Wait(); */
/*     UnPackLineDownAdd(I, 0); */

/*   } */
/*   void SendRecvSolve1Front(Int I, MPI::Intracomm&comm) */
/*   { */
/*     int size = comm.Get_size(); */
/*     int rank = comm.Get_rank(); */


/*     int UpP = rank+1; */
/*     int DownP = rank-1; */
/*     if (DownP <0) DownP = MPI::PROC_NULL; */
/*     if (UpP == size) UpP = MPI::PROC_NULL; */

/*     for(int i = 0; i < N2*2+2; ++i) */
/*       RecvLine[i] = 0; */
/*     PackLineLeftFront(I, -1); //toppest line */
/*     lrs = comm.Ibsend(&SendLine[0], 2*N2+2  , Myf<base_type>::Datatype(), DownP, 0); */
/*     lrr = comm.Irecv(&RecvLine[0], 2*N2+2  , Myf<base_type>::Datatype(), UpP, 0); */
/*   } */
/*   void NillRequests() */
/*   { */
/*     lrs = MPI::REQUEST_NULL; */
/*     lrr = MPI::REQUEST_NULL; */
/*     for(int i = 0; i < N2*2+2; ++i) */
/*       RecvLine[i] = 0; */
/*     lrs.Wait(); */
/*     lrr.Wait(); */
/*   } */
/*   void SendRecvSolve1FrontFinish(Int I, MPI::Intracomm&comm) */
/*   { */
/*     lrs.Wait(); */
/*     lrr.Wait(); */
/*     UnPackLineLeftFrontAdd(I, N3-1); */
/*   } */
/*   void SendRecvSolve2Down(Int I, MPI::Intracomm&comm) */
/*   { */
/*     int size = comm.Get_size(); */
/*     int rank = comm.Get_rank(); */


/*     int UpP = rank+1; */
/*     int DownP = rank-1; */
/*     if (DownP <0) DownP = MPI::PROC_NULL; */
/*     if (UpP == size) UpP = MPI::PROC_NULL; */

/*     for(int i = 0; i < N2; ++i) */
/*       RecvLine[i] = 0; */
/*     PackLineDown(I, 0); //toppest line */
/*     lrs = comm.Ibsend(&SendLine[0], N2  , Myf<base_type>::Datatype(), DownP, 0); */
/*     lrr = comm.Irecv(&RecvLine[0], N2  , Myf<base_type>::Datatype(), UpP, 0); */
/*   } */
/*   void SendRecvSolve2DownFinish(Int I, MPI::Intracomm&comm) */
/*   { */
/*     int size = comm.Get_size(); */
/*     int rank = comm.Get_rank(); */
/*     lrs.Wait(); */
/*     lrr.Wait(); */
/*     if (rank +1 != size) UnPackLineDown(I, N3); */
/*   }  */
/*   void SendRecvSolve2Left(Int I, MPI::Intracomm&comm) */
/*   { */
/*     int size = comm.Get_size(); */
/*     int rank = comm.Get_rank(); */


/*     int UpP = rank+1; */
/*     int DownP = rank-1; */
/*     if (DownP <0) DownP = MPI::PROC_NULL; */
/*     if (UpP == size) UpP = MPI::PROC_NULL; */

/*     for(int i = 0; i < N2*2+2; ++i) */
/*       RecvLine[i] = 0; */
/*     PackLineLeftFront(I, N3-1); //toppest line */
/*     lrs = comm.Ibsend(&SendLine[0], 2*N2+2  , Myf<base_type>::Datatype(), UpP, 0); */
/*     lrr = comm.Irecv(&RecvLine[0], 2*N2+2  , Myf<base_type>::Datatype(), DownP, 0); */
/*   } */
/*   void SendRecvSolve2LeftFinish(Int I, MPI::Intracomm&comm) */
/*   { */
/*     lrs.Wait(); */
/*     lrr.Wait(); */
/*     UnPackLineLeftFront(I, -1); */
/*   } */
  
/*   void Pack() */
/*   { */
/*     Int i, j, k; */
/*     Index3dBase<Int> ind(N1, N2, N3); */
/*     Index3dBase<Int> IU(ind), JU(ind), KU(ind); */
/*     Index3dBase<Int> ID(ind), JD(ind), KD(ind); */
/*     ID.SetPos(0, 0, 0); */
/*     IU.SetPos(0, 0, N3-1); */
/*     Int suk = 0; */
/*     Int sdk = 0; */
  
/*     for(i = N1+1;i; --i, IU.ToRight(), ID.ToRight()) */
/*     { */
/*       for(j = N2+1, JD=ID,JU=IU; j; --j, JD.ToBack(), JU.ToBack()) */
/*       {  */
/*         SendBufferD[sdk++] = (*this)[JD][DownEl]; */
        
/*         SendBufferU[suk++] = (*this)[JU][LeftEl]; */
/*         SendBufferU[suk++] = (*this)[JU][FrontEl]; */
/*         SendBufferU[suk++] = (*this)[JU][DownEl]; */
/*       } */
/*     } */

/*   } */
/*   void UnPack(bool und, bool unu) */
/*   { */
/*     Int i, j, k; */
/*     Index3dBase<Int> ind(N1, N2, N3); */
/*     Index3dBase<Int> IU(ind), JU(ind), KU(ind); */
/*     Index3dBase<Int> ID(ind), JD(ind), KD(ind); */
/*     ID.SetPos(0, 0, -1); */
/*     IU.SetPos(0, 0, N3); */
/*     Int suk = 0; */
/*     Int sdk = 0; */
  
/*     for(i = N1+1;i; --i, IU.ToRight(), ID.ToRight()) */
/*     { */
/*       for(j = N2+1, JD=ID,JU=IU; j; --j, JD.ToBack(), JU.ToBack()) */
/*       {  */
/*         if (unu) (*this)[JU][DownEl] = RecvBufferU[suk++]  ; */
        
/*         if (und) */
/*           {   */
/*             (*this)[JD][LeftEl] = RecvBufferD[sdk++] ; */
/*             (*this)[JD][FrontEl] = RecvBufferD[sdk++] ; */
/*             (*this)[JD][DownEl] = RecvBufferD[sdk++]  ; */
/*           } */
/*       } */
/*     } */
/*   } */









#endif
#ifdef INCLUSION
#include "vectors.hpp"
#endif
